//
//  Ajustes.h
//  COMUNICADOR
//
//  Created by JOSE CRUZ PEREZ PI on 31/05/11.
//  Copyright 2011 UNIVERSIDAD PUBLICA DE NAVARRA. All rights reserved.
//

#import <UIKit/UIKit.h>

# define KEY_TIPO_LETRA @"tipo_letra"
# define KEY_RESP_NEGATIVA @"resp_negativa"
# define KEY_TIEMPO_PULSACION @"tiempo_pulsacion"

# define ficheroPersistente @"ajustes.plist"

@class COMUNICADORViewController;
@class EditarAlbumFavorito;
@class Personalizacion;


@interface Ajustes : UIViewController {
    
    NSString *rutaFichero;
    NSMutableArray *ajustes;
    
    COMUNICADORViewController *controladorViewController;
    EditarAlbumFavorito * EditarAlbumFavoritoVista;
    Personalizacion * controladorPersonalizacion;
    
    int selectedUnit_resp_negativa;
	IBOutlet UISegmentedControl *segmentedControl_resp_negativa;

    int selectedUnit3;
	UISegmentedControl *segmentedControl_tiempo_pulsacion;

    int selectedUnit_minusc_mayusc;
	UISegmentedControl *segmentedControl_minusc_mayusc;

    int selectedUnit_cast_ing;
	UISegmentedControl *segmentedControl_cast_ing;
    
    IBOutlet UILabel * label_resp_negativa;
    IBOutlet UILabel * label_tiempo_pulsacion;
    IBOutlet UILabel * label_tamano_letra;
    IBOutlet UILabel * label_idioma;
    IBOutlet UILabel * label_pictos_personalizar;
    IBOutlet UILabel * label_album_favorito_personalizar;
    
    IBOutlet UIButton * but_pictos_personalizar;
    IBOutlet UIButton * but_album_favorito_personalizar;
    IBOutlet UIButton * but_guardar_ajustes;
    IBOutlet UIButton * but_inicio;


    IBOutlet id BOTON_AJUSTES;
    
    int resp_negativa;
    int tiempo_pulsacion;
    int tipo_letra;
    
    NSString * resp_negativa_string;
    NSString * tiempo_pulsacion_string;
    NSString * tipo_letra_string;

  	
}


@property (nonatomic,retain) NSString *rutaFichero;
@property (nonatomic,retain) NSMutableArray *ajustes;

@property (nonatomic, retain) COMUNICADORViewController *controladorViewController;
@property (nonatomic, retain) EditarAlbumFavorito *EditarAlbumFavoritoVista;
@property (nonatomic, retain) Personalizacion *controladorPersonalizacion;
@property (nonatomic, retain) IBOutlet UISegmentedControl *segmentedControl_resp_negativa;
@property (nonatomic, retain) IBOutlet UISegmentedControl *segmentedControl_tiempo_pulsacion;
@property (nonatomic, retain) IBOutlet UISegmentedControl *segmentedControl_minusc_mayusc;
@property (nonatomic, retain) IBOutlet UISegmentedControl *segmentedControl_cast_ing;

@property (nonatomic, retain) IBOutlet UILabel * label_resp_negativa;
@property (nonatomic, retain) IBOutlet UILabel * label_tiempo_pulsacion;
@property (nonatomic, retain) IBOutlet UILabel * label_tamano_letra;
@property (nonatomic, retain) IBOutlet UILabel * label_idioma;
@property (nonatomic, retain) IBOutlet UILabel * label_pictos_personalizar;
@property (nonatomic, retain) IBOutlet UILabel * label_album_favorito_personalizar;

@property (nonatomic, retain)IBOutlet UIButton * but_pictos_personalizar;
@property (nonatomic, retain)IBOutlet UIButton * but_album_favorito_personalizar;
@property (nonatomic, retain)IBOutlet UIButton * but_guardar_ajustes;
@property (nonatomic, retain)IBOutlet UIButton * but_inicio;

@property (nonatomic) int resp_negativa;
@property (nonatomic) int tiempo_pulsacion;
@property (nonatomic) int tipo_letra;

@property (nonatomic,retain) NSString *resp_negativa_string;
@property (nonatomic,retain) NSString *tiempo_pulsacion_string;
@property (nonatomic,retain) NSString *tipo_letra_string;

- (IBAction)segmentedControlValueChangedRespNegativa;
- (void)cambioRespuestaNegativa;

- (IBAction)segmentedControlValueChanged3;
- (void)cambioTiempoPulsacion;

- (IBAction)segmentedControlValueChanged4;
- (void)cambioIdioma;

- (IBAction)segmentedControlValueChanged6;
- (void)cambioMayusculasMinusculas;

- (IBAction)ajustes_personalizar_pictos;
- (IBAction)ajustes_personalizar_album_favorito;

- (NSString *) rutaFichero;
- (void) mostrarAjustes;
- (void) guardarAjustes;

- (int)CargarRespuestaNegativa;

//- (IBAction) PULSAR_BOTON_OPCIONES: (id) sender;
- (IBAction) PULSAR_BOTON_SALIR_AJUSTES: (id) sender;
- (IBAction) PULSAR_BOTON_GUARDAR_AJUSTES: (id)sender;

@end
