//
//  Personalizacion.m
//  COMUNICADOR
//
//  Created by JOSE CRUZ PEREZ PI on 17/06/11.
//  Copyright 2011 UNIVERSIDAD PUBLICA DE NAVARRA. All rights reserved.
//

#import "COMUNICADORAppDelegate.h"
#import "Personalizacion.h"
#import "Ajustes.h"

@implementation Personalizacion

@synthesize controladorAjustes;

@synthesize switch_persona;  
@synthesize switch_verbo;  
@synthesize switch_complemento;

@synthesize popover;
@synthesize copyImage;

@synthesize label_frase_guardado;
@synthesize label_busqueda;
@synthesize label_instrucciones;
@synthesize label_borrar;

@synthesize label_nombre_castellano;
@synthesize label_nombre_ingles;
@synthesize label_Persona;
@synthesize label_Verbo;
@synthesize label_Complemento;

@synthesize BOTON_BUSCAR;
@synthesize BOTON_GUARDAR;
@synthesize BOTON_BUSCAR_IMAGEN;
@synthesize BOTON_BORRAR;

@synthesize BOTON_REINICIAR_VALORES;
@synthesize BOTON_ATRAS;


- (void)Ajustar
{
    [controladorAjustes viewDidLoad];
    ajuste_resp_negativa=controladorAjustes.resp_negativa;
    ajuste_tiempo_pulsacion=controladorAjustes.tiempo_pulsacion;
    ajuste_tipo_letra=controladorAjustes.tipo_letra;
    
    NSLog(@"respuesta negativa %i, tiempo pulsacion %i, tipo letra %i",ajuste_resp_negativa,ajuste_tiempo_pulsacion,ajuste_tipo_letra);
}


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    NSLog(@"estoy entrando en personalizacion");
    
    controladorAjustes =[[Ajustes alloc]init];

    
    [self Ajustar];
    
    if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
    {
        label_instrucciones.text=@"Introduce el elemento a modificar o el elemento nuevo a guardar.";
        label_nombre_castellano.text=@"NOMBRE (Castellano)";
        label_nombre_ingles.text=@"NOMBRE (Inglés)";
        label_Persona.text=@"PERSONA";
        label_Verbo.text=@"VERBO";
        label_Complemento.text=@"COMPLEMENTO";
                
        
        [BOTON_BUSCAR_IMAGEN setTitle:@"SELECCIONA IMAGEN" forState:normal];
        [BOTON_GUARDAR setTitle:@"GUARDAR" forState:normal];
        [BOTON_BUSCAR setTitle:@"BUSCAR" forState:normal];
        [BOTON_BORRAR setTitle:@"BORRAR" forState:normal];
        [BOTON_REINICIAR_VALORES setTitle:@"REINICIAR VALORES" forState:normal];
        [BOTON_ATRAS setTitle:@"ATRÁS" forState:normal];
    }
    else //IDIOMA INGLÉS
    {
        label_instrucciones.text=@"Introduce a new element to store or modify an existing one.";
        label_nombre_castellano.text=@"NAME (Spanish)";
        label_nombre_ingles.text=@"NAME (English)";
        label_Persona.text=@"PERSON";
        label_Verbo.text=@"VERB";
        label_Complemento.text=@"COMPLEMENT";
        
        
        [BOTON_BUSCAR_IMAGEN setTitle:@"CHOOSE IMAGE" forState:normal];
        [BOTON_GUARDAR setTitle:@"SAVE" forState:normal];
        [BOTON_BUSCAR setTitle:@"SEARCH" forState:normal];
        [BOTON_BORRAR setTitle:@"DELETE" forState:normal];
        [BOTON_REINICIAR_VALORES setTitle:@"RESTORE VALUES" forState:normal];
        [BOTON_ATRAS setTitle:@"BACK" forState:normal];
    }
    
    [self DeshabilitarElementos];
    label_instrucciones.hidden=NO;
    
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return YES;
}

//Busco elementos en todas las entidades (Persona, verbo y complemento) y activo los switches
- (IBAction) PULSAR_BUSCAR: (id) sender{
    
    switch_persona.on=NO;
    switch_verbo.on=NO;
    switch_complemento.on=NO;
    label_frase_guardado.text=nil;
    
    existe=1;
    existe_personas=1;
    existe_verbos=1;
    existe_complementos=1;
    Es_nuevo_personas=0;
    Es_nuevo_verbos=0;
    Es_nuevo_complementos=0;
    
    COMUNICADORAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    
    NSManagedObjectContext *context = [appDelegate managedObjectContext];
    
    NSEntityDescription *entityDesc = [NSEntityDescription entityForName:@"Personas" inManagedObjectContext:context];
    
    NSFetchRequest *request = [[NSFetchRequest alloc] init];
    
    [request setEntity:entityDesc];
    
    
    
    NSPredicate *pred = [NSPredicate predicateWithFormat:@"(nombre = %@ AND activo=1)", texto_busqueda.text];
    
    NSError *error;
    
    [request setPredicate:pred];
    
    NSArray *objects = [context executeFetchRequest:request error:&error];
    
    if ([objects count] == 0) {
        existe=existe*1;
        VISTA_IMAGEN.image=nil;
    } 
    
    else if ([objects count] == 1){
        
        existe=existe*0;
        existe_personas=0;
        NSManagedObject *matches = [objects objectAtIndex:0];
        texto_castellano.text=[matches valueForKey:@"nombre"];
        texto_ingles.text=[matches valueForKey:@"nombre_ing"];
        fila_a_cambiar_post_busqueda_personas=[[matches valueForKey:@"pk"]intValue];
        Es_nuevo_personas=[[matches valueForKey:@"nuevo"]intValue];
        switch_persona.on=YES;
        NSLog(@"fila %i", fila_a_cambiar_post_busqueda_personas);
    }    
    
    
    entityDesc= [NSEntityDescription entityForName:@"Verbos" inManagedObjectContext:context];
    [request setEntity:entityDesc];
    [request setPredicate:pred];
    objects = [context executeFetchRequest:request error:&error];
    
    if ([objects count] == 0) {
        existe=existe*1;
        VISTA_IMAGEN.image=nil;
    } 
    
    else if ([objects count] == 1){
        
        existe=existe*0;
        existe_verbos=0;
        NSManagedObject *matches = [objects objectAtIndex:0];
        texto_castellano.text=[matches valueForKey:@"nombre"];
        texto_ingles.text=[matches valueForKey:@"nombre_ing"];
        fila_a_cambiar_post_busqueda_verbos=[[matches valueForKey:@"pk"]intValue];
        Es_nuevo_verbos=[[matches valueForKey:@"nuevo"]intValue];
        
        switch_verbo.on=YES;
    }    
    
    
    entityDesc= [NSEntityDescription entityForName:@"Complementos" inManagedObjectContext:context];
    [request setEntity:entityDesc];
    [request setPredicate:pred];
    objects = [context executeFetchRequest:request error:&error];
    
    if ([objects count] == 0) {
        existe=existe*1;
        VISTA_IMAGEN.image=nil;
    } 
    
    else if ([objects count] == 1){
        
        existe=existe*0;
        existe_complementos=0;
        NSManagedObject *matches = [objects objectAtIndex:0];
        texto_castellano.text=[matches valueForKey:@"nombre"];
        texto_ingles.text=[matches valueForKey:@"nombre_ing"];
        fila_a_cambiar_post_busqueda_complementos=[[matches valueForKey:@"pk"]intValue];
        Es_nuevo_complementos=[[matches valueForKey:@"nuevo"]intValue];
        
        
        switch_complemento.on=YES;
    }    
    if (existe==1){
        
        if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
        {
            label_busqueda.text = @"Ese valor no existe. Rellene los parametros inferiores para crearlo";
        }
        else //IDIOMA INGLÉS
        {
            label_busqueda.text = @"This value don´t exist. Please introduce the following values to create it";
        }
        
        label_instrucciones.hidden=YES;
        [self HabilitarElementos];
        texto_castellano.text=texto_busqueda.text;
        texto_busqueda.text=nil;
        texto_castellano.enabled=NO;
        texto_ingles.text=nil;
        BOTON_BORRAR.enabled=NO;
        
    }
    else if (existe==0){
        
        if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
        {
            label_busqueda.text = @"Ese nombre ya existe. Modifique los parametros inferiores y pulse guardar";
            label_borrar.text = @"Si desea eliminarlo, pulse BORRAR";
        }
        else //IDIOMA INGLÉS
        {
            label_busqueda.text = @"This element already exists. Please introduce new values and touch 'SAVE'";
            label_borrar.text = @"If you want to delete it, please touch 'DELETE'";
        }
        
        label_instrucciones.hidden=YES;
        [self HabilitarElementos];
        texto_busqueda.text=nil;
        texto_castellano.enabled=NO;
        UIImage *btnImage;
        if (Es_nuevo_personas==1 || Es_nuevo_verbos==1 || Es_nuevo_complementos==1) {
            
                btnImage = [self loadImage:texto_castellano.text];
            }
            else{
                btnImage = [UIImage imageNamed:texto_castellano.text];
                
            }
        VISTA_IMAGEN.image=btnImage;
    }
    
}


//Guardo los elementos en la entidad correspondiente en función del switch activado
- (IBAction) GUARDAR_NUEVA_ENTRADA: (id) sender{
    

    if (switch_persona.on==YES){
    
        [self Nuevo_elemento:@"Personas" Fila_cambia:fila_a_cambiar_post_busqueda_personas Indice:1];

    }
    if (switch_verbo.on==YES){
        
        [self Nuevo_elemento:@"Verbos" Fila_cambia:fila_a_cambiar_post_busqueda_verbos Indice:2];
        
    }
    if (switch_complemento.on==YES){
        
        [self Nuevo_elemento:@"Complementos" Fila_cambia:fila_a_cambiar_post_busqueda_complementos Indice:3];
        
    }
    
    UIImage *imagen=VISTA_IMAGEN.image;
    
    /*
    //Con esto, salvo en el álbum
    
    UIImageWriteToSavedPhotosAlbum(VISTA_IMAGEN.image, nil, nil, nil);
    */
    [self saveImage: imagen: texto_castellano.text];
    //UIImage *myUIImage = [self loadImage: @"myUIImageName"];

    //VISTA_IMAGEN2.image= myUIImage;
    
    if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
    {
        label_frase_guardado.text=@"Nueva entrada guardada";
        
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"ENHORABUENA" message:@"Su elemento ha sido guardado" delegate:self cancelButtonTitle:nil otherButtonTitles:@"Ok", nil];

        [alertView show];
        [alertView release];
    }
    else //IDIOMA INGLÉS
    {
        label_frase_guardado.text=@"ENTRY SAVED";
        
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"CONGRATULATIONS" message:@"Your element has been saved" delegate:self cancelButtonTitle:nil otherButtonTitles:@"Ok", nil];
        
        [alertView show];
        [alertView release];

    }
    
    
    [self DeshabilitarElementos];
    label_borrar.text=nil;
    label_busqueda.text=nil;
    label_instrucciones.hidden=NO;
    
}

//Guardo un nuevo elemento con sus respectivas relaciones a todos los sublugares
- (void) Nuevo_elemento: (NSString *) entidad_a_guardar Fila_cambia: (int) fila Indice: (int) indice{
    
    
    
    COMUNICADORAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    NSManagedObjectContext *context = [appDelegate managedObjectContext];
    
    NSEntityDescription *entityDesc = [NSEntityDescription entityForName:@"Sublugar" inManagedObjectContext:context];
    
    NSFetchRequest *request = [[NSFetchRequest alloc] init];
    
    [request setEntity:entityDesc];
    
    NSError *error;
    
    NSArray *items=[context executeFetchRequest:request error:&error];
    
    [request release];
    
    
    
    NSManagedObjectContext *context1 = [appDelegate managedObjectContext];
    
    NSEntityDescription *entityDesc1 = [NSEntityDescription entityForName:entidad_a_guardar inManagedObjectContext:context];
    
    NSFetchRequest *request1 = [[NSFetchRequest alloc] init];
    
    [request1 setEntity:entityDesc1];
    
    
    
    NSArray *items1=[context executeFetchRequest:request1 error:&error];
    
    [request1 release];
    
    NSError *error1;

    
    NSManagedObject *mo3 = [NSEntityDescription insertNewObjectForEntityForName:entidad_a_guardar
                                                         inManagedObjectContext:context1];
    
    [mo3 setValue:texto_castellano.text forKey:@"nombre"];
    [mo3 setValue:texto_ingles.text forKey:@"nombre_ing"];
    NSString *cambio_mayusculas;
    cambio_mayusculas=[texto_castellano.text uppercaseString];
    [mo3 setValue:cambio_mayusculas forKey:@"nombre_may"];
    cambio_mayusculas=[texto_ingles.text uppercaseString];
    [mo3 setValue:cambio_mayusculas forKey:@"nombre_may_ing"];
    
    [mo3 setValue:[NSNumber numberWithInt:([items1 count]+1)] forKey:@"pk"];
    [mo3 setValue:[NSNumber numberWithInt:1] forKey:@"nuevo"];
    [mo3 setValue:[NSNumber numberWithInt:0] forKey:@"album_personalizado"];
    [mo3 setValue:[NSNumber numberWithInt:1] forKey:@"activo"];
    
    if (indice==1) {
        
    if (existe_personas==0){
        
       NSManagedObject *fila_que_cambia= [items1 objectAtIndex:(fila-1)];
        
    [fila_que_cambia setValue:[NSNumber numberWithInt: 0] forKey:@"activo"];
        existe_personas=1;
        
        //[mo3 setValue:[NSNumber numberWithInt:([items1 count]+1)] forKey:@"activo"];
    }
    }
    
    else if (indice==2) {
        
    if (existe_verbos==0){
        
        NSManagedObject *fila_que_cambia= [items1 objectAtIndex:(fila-1)];
        
        [fila_que_cambia setValue:[NSNumber numberWithInt: 0] forKey:@"activo"];
        existe_verbos=1;
        
        //[mo3 setValue:[NSNumber numberWithInt:([items1 count]+1)] forKey:@"activo"];
    }
    }
    else if (indice==3){
    if (existe_complementos==0){
        
        NSManagedObject *fila_que_cambia= [items1 objectAtIndex:(fila-1)];
        
        [fila_que_cambia setValue:[NSNumber numberWithInt: 0] forKey:@"activo"];
        existe_complementos=1;
        
        //[mo3 setValue:[NSNumber numberWithInt:([items1 count]+1)] forKey:@"activo"];
    }
    }
    
    NSManagedObject *mo= [items objectAtIndex:0];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:1];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:2];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:3];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:4];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:5];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:6];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:7];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:8];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:9];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:10];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:11];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:12];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:13];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:14];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:15];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:16];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:17];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:18];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:19];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:20];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:21];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    mo= [items objectAtIndex:22];
    [[mo3 mutableSetValueForKey:@"FraseSublugar"] addObject:mo];
    
    
    [context refreshObject:mo mergeChanges:YES];
    
    NSLog(@"He guardado");
    
    
    if (![context save:&error]) {
        NSLog(@"error de coredata %@, %@", error, [error userInfo]);
        exit(-1);
    }
    
    if (![context1 save:&error1]) {
        NSLog(@"error de coredata %@, %@", error1, [error1 userInfo]);
        exit(-1);
    }
    
    NSLog(@"LLego");  
    
    
    
    
    
}

//Método del boton "reiniciar valores" que llama a los métodos 
//EliminoObjetoEntidad, ModificoColumnasActivo y ModificoColumnasContador en todas las entidades 
- (IBAction) PULSAR_REINICIAR_VALORES: (id) sender{
    
    [self EliminoObjetosEntidad:@"Personas"];
    [self ModificoColumnasActivo:@"Personas"];
    [self ModificoColumnasContador:@"Personas"];
    
    [self EliminoObjetosEntidad:@"Verbos"];
    [self ModificoColumnasActivo:@"Verbos"];
    [self ModificoColumnasContador:@"Verbos"];
    
    [self EliminoObjetosEntidad:@"Complementos"];
    [self ModificoColumnasActivo:@"Complementos"];
    [self ModificoColumnasContador:@"Complementos"];
    
    
    
    if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
    {
        label_frase_guardado.text=@"Se han restaurado los valores iniciales";
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"ENHORABUENA" message:@"Se han restaurado los valores iniciales" delegate:self cancelButtonTitle:nil otherButtonTitles:@"Ok", nil];
        [alertView show];
        [alertView release];
        

    }
    else //IDIOMA INGLÉS
    {
        label_frase_guardado.text=@"All values have been restored";
        
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"CONGRATULATIONS" message:@"All values have been restored" delegate:self cancelButtonTitle:nil otherButtonTitles:@"Ok", nil];
        
        [alertView show];
        [alertView release];
        
    }
    
}


//Método que elimina todos los elementos de la entidad "entidad" que tengan un 1 en la columna "nuevo"
- (void) EliminoObjetosEntidad: (NSString *) entidad{
    
    COMUNICADORAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    NSManagedObjectContext *context = [appDelegate managedObjectContext];
    
    NSEntityDescription *entityDesc = [NSEntityDescription entityForName:entidad inManagedObjectContext:context];
    
    NSFetchRequest *request = [[NSFetchRequest alloc] init];
    
    [request setEntity:entityDesc];
    
    
    NSPredicate *pred = [NSPredicate predicateWithFormat:@"ANY nuevo=1"];
    
    
    [request setPredicate:pred];
    
    NSError *error;
    
    NSArray *items=[context executeFetchRequest:request error:&error];
    
    [request release];
    
    if ([items count]==0){
        NSLog(@"no hay elementos");
    }
    
    else{
        
        NSManagedObject *objeto_que_eliminar= [items objectAtIndex:0];
        [context deleteObject:objeto_que_eliminar];
        [self EliminoObjetosEntidad:entidad];
        
    }
    
    if (![context save:&error]) {
        NSLog(@"error de coredata %@, %@", error, [error userInfo]);
        exit(-1);
    }    
    
}

//Método que pone la columna activo igual a 1 en todos los elementos.
- (void) ModificoColumnasActivo: (NSString *) entidad{
    
    COMUNICADORAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    NSManagedObjectContext *context = [appDelegate managedObjectContext];
    
    NSEntityDescription *entityDesc = [NSEntityDescription entityForName:entidad inManagedObjectContext:context];
    
    NSFetchRequest *request = [[NSFetchRequest alloc] init];
    
    [request setEntity:entityDesc];
    
    
    NSPredicate *pred = [NSPredicate predicateWithFormat:@"ANY activo=0"];
    
    
    [request setPredicate:pred];
    
    NSError *error;
    
    NSArray *items=[context executeFetchRequest:request error:&error];
    
    [request release];
    
    if ([items count]==0){
        NSLog(@"no hay elementos");
        if (![context save:&error]) {
            NSLog(@"error de coredata %@, %@", error, [error userInfo]);
            exit(-1);
        }   
    }
    
    else{
        
        NSManagedObject *objeto_que_cambiar= [items objectAtIndex:0];
        [objeto_que_cambiar setValue:[NSNumber numberWithInt: 1] forKey:@"activo"];
        if (![context save:&error]) {
            NSLog(@"error de coredata %@, %@", error, [error userInfo]);
            exit(-1);
        }   
        [self ModificoColumnasActivo:entidad];
        
    }

}

//Método que pone la columna contador igual a 0 en todos los elementos.
- (void) ModificoColumnasContador: (NSString *) entidad{
    
    COMUNICADORAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    NSManagedObjectContext *context = [appDelegate managedObjectContext];
    
    NSEntityDescription *entityDesc = [NSEntityDescription entityForName:entidad inManagedObjectContext:context];
    
    NSFetchRequest *request = [[NSFetchRequest alloc] init];
    
    [request setEntity:entityDesc];
    
    
    NSPredicate *pred = [NSPredicate predicateWithFormat:@"ANY contador!=0"];
    
    
    [request setPredicate:pred];
    
    NSError *error;
    
    NSArray *items=[context executeFetchRequest:request error:&error];
    
    [request release];
    
    if ([items count]==0){
        NSLog(@"no hay elementos");
        if (![context save:&error]) {
            NSLog(@"error de coredata %@, %@", error, [error userInfo]);
            exit(-1);
        }   
    }
    
    else{
        
        NSManagedObject *objeto_que_cambiar= [items objectAtIndex:0];
        [objeto_que_cambiar setValue:[NSNumber numberWithInt: 0] forKey:@"contador"];
        if (![context save:&error]) {
            NSLog(@"error de coredata %@, %@", error, [error userInfo]);
            exit(-1);
        }   
        [self ModificoColumnasContador:entidad];
        
    }
    
}


//Elimino el objeto buscado
- (IBAction)EliminarObjeto: (id) sender{
    
    if (existe_personas==0){
    
        [self funcion_de_eliminar_objeto:@"Personas" fila: fila_a_cambiar_post_busqueda_personas Variable_nuevo:Es_nuevo_personas];
    }

    if (existe_verbos==0){
        [self funcion_de_eliminar_objeto:@"Verbos" fila: fila_a_cambiar_post_busqueda_verbos Variable_nuevo:Es_nuevo_verbos];
    }
    
    if (existe_complementos==0){
        [self funcion_de_eliminar_objeto:@"Complementos" fila: fila_a_cambiar_post_busqueda_complementos Variable_nuevo:Es_nuevo_complementos];
        
    }
    texto_castellano.text=nil;
    texto_ingles.text=nil;
    texto_busqueda.text=nil;
    VISTA_IMAGEN.image=nil;
    switch_persona.on=NO;
    switch_verbo.on=NO;
    switch_complemento.on=NO;
    
    if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
    {
        label_frase_guardado.text=@"Elemento borrado";
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"ENHORABUENA" message:@"El elemento ha sido borrado" delegate:self cancelButtonTitle:nil otherButtonTitles:@"Ok", nil];
        [alertView show];
        [alertView release];
        
        
    }
    else //IDIOMA INGLÉS
    {
        
        label_frase_guardado.text=@"Element deleted";
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"CONGRATULATIONS" message:@"The element has been deleted" delegate:self cancelButtonTitle:nil otherButtonTitles:@"Ok", nil];
        [alertView show];
        [alertView release];

        
    }
    
    
    label_borrar.text=nil;
    label_busqueda.text=nil;
    label_instrucciones.hidden=NO;
    [self DeshabilitarElementos];
    
        
}


//funcion que elimina el objeto
- (void) funcion_de_eliminar_objeto: (NSString *) entidad fila: (int) fila_cambio Variable_nuevo: (int) es_nuevo{
    
    COMUNICADORAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    NSManagedObjectContext *context = [appDelegate managedObjectContext];
    
    NSEntityDescription *entityDesc = [NSEntityDescription entityForName:entidad inManagedObjectContext:context];
    
    NSFetchRequest *request = [[NSFetchRequest alloc] init];
    
    [request setEntity:entityDesc];
    
    
    //NSPredicate *pred = [NSPredicate predicateWithFormat:@"ANY nuevo=1"];
    
    
    //[request setPredicate:pred];
    
    NSError *error;
    
    NSArray *items=[context executeFetchRequest:request error:&error];
    
    [request release];
    
    NSManagedObject *fila_que_eliminar= [items objectAtIndex:(fila_cambio-1)];
    
    if (es_nuevo==1){
    
    [context deleteObject:fila_que_eliminar];
    
    [self removeImage:texto_castellano.text];
    }
    else{
        [fila_que_eliminar setValue:[NSNumber numberWithInt: 0] forKey:@"activo"];
        
    }
    
    if (![context save:&error]) {
        NSLog(@"error de coredata %@, %@", error, [error userInfo]);
        exit(-1);
    }

    
}


/*
 
 save -->[self saveImage: myUIImage: @"myUIImageName"];
 load --> myUIImage = [self loadImage: @"myUIImageName"];
 remove --> [self removeImage: @"myUIImageName"];
 
 
 */


- (void)saveImage:(UIImage*)image:(NSString*)imageName {
    
    NSData *imageData = UIImagePNGRepresentation(image); //convert image into .png format.
    
    NSFileManager *fileManager = [NSFileManager defaultManager];//create instance of NSFileManager
    
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES); //create an array and store result of our search for the documents directory in it
    
    NSString *documentsDirectory = [paths objectAtIndex:0]; //create NSString object, that holds our exact path to the documents directory
    
    NSString *fullPath = [documentsDirectory stringByAppendingPathComponent:[NSString stringWithFormat:@"%@.png", imageName]]; //add our image to the path
    
    [fileManager createFileAtPath:fullPath contents:imageData attributes:nil]; //finally save the path (image)
    
    NSLog(@"image saved");
    
}

- (void)removeImage:(NSString*)fileName {
    
    NSFileManager *fileManager = [NSFileManager defaultManager];
    
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    NSString *documentsDirectory = [paths objectAtIndex:0];
    
    NSString *fullPath = [documentsDirectory stringByAppendingPathComponent:[NSString stringWithFormat:@"%@.png", fileName]];
    
    [fileManager removeItemAtPath: fullPath error:NULL];
    
    NSLog(@"image removed");
    
}


- (UIImage*)loadImage:(NSString*)imageName {
    
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    
    NSString *documentsDirectory = [paths objectAtIndex:0];
    
    NSString *fullPath = [documentsDirectory stringByAppendingPathComponent:[NSString stringWithFormat:@"%@.png", imageName]];
    
    return [UIImage imageWithContentsOfFile:fullPath];
    
}

- (UIImage*)imageWithImage:(UIImage*)image scaledToSize:(CGSize)newSize
{
    UIGraphicsBeginImageContext( newSize );
    [image drawInRect:CGRectMake(0,0,newSize.width,newSize.height)];
    UIImage* newImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    
    return newImage;
}

- (IBAction) PULSAR_VOLVER_PERSONALIZACION: (id) sender{
    
    [self.view removeFromSuperview];
    switch_persona.on=NO;
    switch_verbo.on=NO;
    switch_complemento.on=NO;
    texto_castellano.text=nil;
    texto_ingles.text=nil;
    texto_busqueda.text=nil;
    label_busqueda.text=nil;
    [self DeshabilitarElementos];
    label_instrucciones.hidden=NO;
    label_frase_guardado.text=nil;
    VISTA_IMAGEN.image=nil;
    label_borrar.text=nil;
    
}




-(void)exitProg:(UIImage *)image didFinishSavingWithError:(NSError *)error contextInfo:(void *)contextInfo {
	
    if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
    {UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"ENHORABUENA" message:@"Su imagen ha sido guardada" delegate:self cancelButtonTitle:nil otherButtonTitles:@"Ok", nil];
        [alertView show];
        [alertView release];
        
        
    }
    else //IDIOMA INGLÉS
    {
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"CONGRATULATIONS" message:@"Image has been saved" delegate:self cancelButtonTitle:nil otherButtonTitles:@"Ok", nil];
        [alertView show];
        [alertView release];
        
        
    }

    
	
	
}

- (IBAction)choosePic: (id) sender {
	UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
	imagePicker.delegate = self;
	imagePicker.allowsEditing = NO;
	imagePicker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
	
	popover = [[UIPopoverController alloc]
               initWithContentViewController:imagePicker];
	[imagePicker release];
	UIButton *btnSender = sender;
	CGRect r = btnSender.frame;
	[popover presentPopoverFromRect:r inView:self.view permittedArrowDirections:UIPopoverArrowDirectionAny animated:YES];

}






- (void)imagePickerController:(UIImagePickerController *)picker_pizarra didFinishPickingImage:(UIImage *)image editingInfo:(NSDictionary *)editingInfo {
	
    VISTA_IMAGEN.image=[self imageWithImage:image scaledToSize:CGSizeMake(190,190)];
    
    [picker_pizarra release];
	[self.popover dismissPopoverAnimated:YES];
	
}   


- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker_pizarra {
	
	[picker_pizarra release];
	[self.popover dismissPopoverAnimated:YES];
}


- (void) DeshabilitarElementos{
    
    texto_castellano.enabled=NO;
    texto_ingles.enabled=NO;
    switch_persona.enabled=NO;
    switch_verbo.enabled=NO;
    switch_complemento.enabled=NO;
    BOTON_GUARDAR.enabled=NO;
    BOTON_BUSCAR_IMAGEN.enabled=NO;
    BOTON_BORRAR.enabled=NO;
    
}

- (void) HabilitarElementos{
    
    texto_castellano.enabled=YES;
    texto_ingles.enabled=YES;
    switch_persona.enabled=YES;
    switch_verbo.enabled=YES;
    switch_complemento.enabled=YES;
    BOTON_GUARDAR.enabled=YES;
    BOTON_BUSCAR_IMAGEN.enabled=YES;
    BOTON_BORRAR.enabled=YES;
    
}




- (void)dealloc
{
    [switch_persona release];  
    [switch_verbo release];  
    [switch_complemento release];
    [label_frase_guardado release];
    [copyImage release];
    [super dealloc];
}


@end
