//
//  Pizarra.h
//  COMUNICADOR
//
//  Created by JOSE CRUZ PEREZ PI on 27/05/11.
//  Copyright 2011 UNIVERSIDAD PUBLICA DE NAVARRA. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>

@class Ajustes;

@interface Pizarra : UIViewController <UINavigationControllerDelegate, UIImagePickerControllerDelegate> {
    
    Ajustes * ControladorAjustes;
    
    int ajuste_resp_negativa;
    int ajuste_tiempo_pulsacion;
    int ajuste_tipo_letra;
    
    IBOutlet UIView *VISTA_PRIMERA_PIZARRA;
	IBOutlet UIView *MENU_PIZARRA;
    
    UIAlertView *alertView; 
    
    IBOutlet UIButton * but_menu_cargar_imagen;
    IBOutlet UIButton * but_menu_deshacer;
    IBOutlet UIButton * but_menu_borrar_todo;
    IBOutlet UIButton * but_menu_guardar_imagen;
    IBOutlet UIButton * but_menu_inicio;
    
	CGPoint ultimoPunto;
	UIImageView *drawImage;
	BOOL userSwiped;   
	int userMoved;
	int selectedUnit;
	UISegmentedControl *segmentedControl;
	int selectedUnit1;
	UISegmentedControl *segmentedControl_grosor;
	int selectedUnit2;
	UISegmentedControl *segmentedControl_color;
    
    
    float colorRed;
	float colorGreen; 
	float colorBlue;
	float lineWidth;
	
	int menupizarra;
	
	IBOutlet UIToolbar *barra_pizarra;
	
	UIPopoverController *popover;
}

@property(nonatomic,retain)Ajustes * ControladorAjustes;
@property (nonatomic, retain) IBOutlet UISegmentedControl *segmentedControl;
@property (nonatomic, retain) IBOutlet UISegmentedControl *segmentedControl_grosor;
@property (nonatomic, retain) IBOutlet UISegmentedControl *segmentedControl_color;

@property (nonatomic, retain)IBOutlet UIButton * but_menu_cargar_imagen;
@property (nonatomic, retain)IBOutlet UIButton * but_menu_deshacer;
@property (nonatomic, retain)IBOutlet UIButton * but_menu_borrar_todo;
@property (nonatomic, retain)IBOutlet UIButton * but_menu_guardar_imagen;
@property (nonatomic, retain)IBOutlet UIButton * but_menu_inicio;

@property (nonatomic, retain) UIPopoverController *popover;
@property (nonatomic, retain) UIImage *copyImage;


- (void)Ajustar;

- (IBAction)saveDrawing;
- (IBAction)cancelDrawing: (id) sender;
- (IBAction)segmentedControlValueChanged;
- (void)cambioHerramienta;
- (IBAction)segmentedControlValueChanged1;
- (void)cambioGrosor;
- (IBAction)segmentedControlValueChanged2;
- (void)cambioColor;


- (IBAction)PULSAR_DESHACER: (id) sender;
- (IBAction)PULSAR_MENU_PIZARRA: (id) sender;
//- (IBAction)PULSAR_VOLVER_MENU_PIZARRA: (id) sender;
- (IBAction)choosePic: (id) sender;

@end
