//
//  Reloj.h
//  COMUNICADOR
//
//  Created by JOSE CRUZ PEREZ PI on 27/05/11.
//  Copyright 2011 UNIVERSIDAD PUBLICA DE NAVARRA. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>
#import "COMUNICADORAppDelegate.h"


@class Ajustes;

@interface Reloj : UIViewController <UIPickerViewDelegate, UIPickerViewDataSource>{
    
    //Elementos usados para efectuar ajustes:
    Ajustes * ControladorAjustes;
    
    int ajuste_resp_negativa;
    int ajuste_tiempo_pulsacion;
    int ajuste_tipo_letra;
    
    //Array del picker con las actividades y etiquetas de los pickers.
	
	NSArray *arrayDatos;
	
	//IBOutlet UITextField *txt;
	IBOutlet UILabel *label;
	IBOutlet UILabel *label_crono;
	
    IBOutlet UIPickerView *picker; //picker actividades
	IBOutlet UIDatePicker *picker_crono;
	IBOutlet NSTimer *timer;
	int mainInt;
	int cuenta_atras;
	
	IBOutlet NSString *prueba;
    
    BOOL pulsacion_reloj;
    
    // ELEMENTOS PRIMERA PANTALLA
    IBOutlet UIView *VISTA_PRINCIPAL_RELOJ;
	IBOutlet UIImageView *VISTA_IMAGEN_RELOJ;
    IBOutlet UILabel *texto_imagen_primera;
    
    IBOutlet UIButton * but_reloj_ok;
    IBOutlet UIButton * but_reloj_inicio_primero;

    // ELEMENTOS SEGUNDA PANTALLA
    IBOutlet UIView *VISTA_SECUNDARIA_RELOJ;
	IBOutlet UIImageView *VISTA_SECUNDARIA_IMAGEN;
    IBOutlet UILabel *texto_imagen_segunda;
    
    IBOutlet UIButton * but_reloj_inicio_segundo;
    IBOutlet UIButton * but_reloj_volver;
    IBOutlet UIButton * but_reloj_empezar;
    IBOutlet UIButton * but_reloj_parar;
    IBOutlet UIButton * but_reloj_parar_oculto;
    
        //Caracol//
    
    IBOutlet UIImageView *reloj_caracol;
	IBOutlet UIView *mascara;
	IBOutlet UIView *animalillo;
    
        //Creo las capas del caracol
	
	CALayer *hoja;
	CALayer *babamask;
	CALayer *hierba;
	CALayer *caracol;
	CALayer *cabeza;
	CALayer *baba;
	
        //animaciones del caracol
	CABasicAnimation *cabezamove;
	CABasicAnimation *caracolmove;
	CABasicAnimation *maskmove;
	
}

@property (nonatomic, retain)IBOutlet UIButton * but_reloj_inicio_segundo;
@property (nonatomic, retain)IBOutlet UIButton * but_reloj_volver;
@property (nonatomic, retain)IBOutlet UIButton * but_reloj_empezar;
@property (nonatomic, retain)IBOutlet UIButton * but_reloj_parar;
@property (nonatomic, retain)IBOutlet UIButton * but_reloj_inicio_primero;
@property (nonatomic, retain)IBOutlet UIButton * but_reloj_ok;
@property (nonatomic, retain)IBOutlet UIButton * but_reloj_parar_oculto;

@property(nonatomic,retain)Ajustes * ControladorAjustes;

@property (nonatomic,retain) IBOutlet UIPickerView *picker;
@property (nonatomic,retain) IBOutlet UILabel *label;
@property (nonatomic, retain) IBOutlet NSTimer *timer;

- (void)Ajustar;

- (IBAction) PULSAR_VOLVER_RELOJ: (id) sender;

- (IBAction) PULSAR_VOLVER_OK_RELOJ: (id) sender;
- (IBAction) PULSAR_OK_RELOJ: (id) sender;
- (IBAction) PULSAR_VOLVER_OK_A_HOME: (id) sender;
- (IBAction) PULSAR_START: (id) sender;
- (IBAction) PULSAR_STOP: (id) sender;
- (IBAction) PULSAR_BOTON_OCULTO_PARAR: (id) sender;

@end
