//
//  Reloj.m
//  COMUNICADOR
//
//  Created by JOSE CRUZ PEREZ PI on 27/05/11.
//  Copyright 2011 UNIVERSIDAD PUBLICA DE NAVARRA. All rights reserved.
//

#import "Reloj.h"
#import <AudioToolbox/AudioServices.h>
#import "COMUNICADORAppDelegate.h"

#import "Ajustes.h"


@implementation Reloj

@synthesize ControladorAjustes;

@synthesize picker;
@synthesize label;
@synthesize timer;

@synthesize but_reloj_inicio_segundo;
@synthesize but_reloj_volver;
@synthesize but_reloj_empezar;
@synthesize but_reloj_parar;
@synthesize but_reloj_inicio_primero;
@synthesize but_reloj_ok;
@synthesize but_reloj_parar_oculto;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    ControladorAjustes =[[Ajustes alloc]init];
    [self Ajustar];
    
    if (ajuste_tipo_letra<40)
    {
        [but_reloj_inicio_primero setTitle:@"INICIO" forState:normal];
        [but_reloj_volver setTitle:@"VOLVER" forState:normal];
        [but_reloj_empezar setTitle:@"EMPEZAR" forState:normal];
        [but_reloj_parar setTitle:@"PARAR" forState:normal];
        [but_reloj_inicio_segundo setTitle:@"INICIO" forState:normal];
        
        arrayDatos  = [[NSArray alloc] initWithObjects:@"SELECCIONA ACTIVIDAD:",@"TRABAJAR", @"JUGAR", @"COMER", @"BAILAR",  nil];
        label.text=@"SELECCIONA ACTIVIDAD:";
    }
    else
    {
        [but_reloj_inicio_primero setTitle:@"HOME" forState:normal];
        [but_reloj_volver setTitle:@"BACK" forState:normal];
        [but_reloj_empezar setTitle:@"START" forState:normal];
        [but_reloj_parar setTitle:@"STOP" forState:normal];
        [but_reloj_inicio_segundo setTitle:@"HOME" forState:normal];
        
        arrayDatos  = [[NSArray alloc] initWithObjects:@"CHOOSE ACTIVITY:",@"WORK", @"PLAY", @"EAT", @"DANCE",  nil];
        label.text=@"CHOOSE ACTIVITY:";
    }

    [picker reloadAllComponents];

	[picker_crono addTarget:self
                     action:@selector(changeDateInLabel:)
           forControlEvents:UIControlEventValueChanged];
	pulsacion_reloj=NO;
    
    [VISTA_IMAGEN_RELOJ setHidden:YES];
    [texto_imagen_primera setHidden:YES];

    [but_reloj_ok setHidden:YES];
    [but_reloj_ok setEnabled:NO];

    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (void)Ajustar
{
    [ControladorAjustes viewDidLoad];
    ajuste_resp_negativa=ControladorAjustes.resp_negativa;
    ajuste_tiempo_pulsacion=ControladorAjustes.tiempo_pulsacion;
    ajuste_tipo_letra=ControladorAjustes.tipo_letra;
    
    NSLog(@"respuesta negativa %i, tiempo pulsacion %i, tipo letra %i",ajuste_resp_negativa,ajuste_tiempo_pulsacion,ajuste_tipo_letra);
}


- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return YES;
}

#pragma mark - PickerView Delegate

- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component
{
	return [arrayDatos count];	
}

- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView
{
	return 1;
}

- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component
{
	NSString *returnStr;
	if (component == 0 )
	{
		returnStr = [arrayDatos objectAtIndex:row];
    }
	
	return returnStr;
    
}


//picker de actividades.

- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component{
	//[[[UIApplication sharedApplication] delegate] cargarVista:row];
	label.text = [arrayDatos objectAtIndex:row];
	prueba=@"00:00:00";
    
    /*
	if ((label.text==@"OTRO")||(label.text==@"OTHER"))
    {
		txt.hidden=NO;
		[VISTA_IMAGEN_RELOJ addSubview:VISTA_ACCION_OTRO];
		[txt becomeFirstResponder];
	}
	else 
    {
		txt.hidden=YES;
		[txt resignFirstResponder];
	}
    */
	if (((label.text==@"SELECCIONA ACTIVIDAD:")||(label.text==@"CHOOSE ACTIVITY:")))
    {
        [VISTA_IMAGEN_RELOJ setHidden:YES];
        [texto_imagen_primera setHidden:YES];
        
		[but_reloj_ok setHidden:YES];
        [but_reloj_ok setEnabled:NO];
	}
	else 
    {
        [VISTA_IMAGEN_RELOJ setHidden:NO];
        [texto_imagen_primera setHidden:NO];
        
        if ([label_crono.text isEqualToString:prueba]) 
        {
            [but_reloj_ok setHidden:YES];
            [but_reloj_ok setEnabled:NO];
        }
        else
        {
            [but_reloj_ok setHidden:NO];
            [but_reloj_ok setEnabled:YES];
        }
	}
    
	//En función de lo seleccionado en el picker, saco una imagen u otra
	if ((label.text==@"TRABAJAR")||(label.text==@"WORK"))
    {
    [VISTA_IMAGEN_RELOJ setImage:[UIImage imageNamed:@"trabajar"]];
        if (ajuste_tipo_letra<40)
        {
            [texto_imagen_primera setText:@"trabajar"];
        }
        else
        {
            [texto_imagen_primera setText:@"work"];
        }
	}
	else if ((label.text==@"JUGAR")||(label.text==@"PLAY"))
    {
        [VISTA_IMAGEN_RELOJ setImage:[UIImage imageNamed:@"jugar"]];
        if (ajuste_tipo_letra<40)
        {
            [texto_imagen_primera setText:@"jugar"];
        }
        else
        {
            [texto_imagen_primera setText:@"play"];
        }
	}
	else if ((label.text==@"COMER")||(label.text==@"EAT"))
    {
        [VISTA_IMAGEN_RELOJ setImage:[UIImage imageNamed:@"comer"]];
        if (ajuste_tipo_letra<40)
        {
            [texto_imagen_primera setText:@"comer"];	
        }
        else
        {
            [texto_imagen_primera setText:@"eat"];	
        }
    }
	else if ((label.text==@"BAILAR")||(label.text==@"DANCE"))
    {
        [VISTA_IMAGEN_RELOJ setImage:[UIImage imageNamed:@"bailar"]];
        if (ajuste_tipo_letra<40)
        {
            [texto_imagen_primera setText:@"bailar"];	
        }
        else
        {
            [texto_imagen_primera setText:@"dance"];	
        }
    }
    /*
	else if ((label.text==@"OTRO")||(label.text==@"OTRO"))
    {
		[VISTA_IMAGEN_RELOJ addSubview:VISTA_ACCION_OTRO];
	}
     */
}

//Actualizar etiqueta label_crono en funcion del picker_crono

- (void)changeDateInLabel:(id)sender{
	//Use NSDateFormatter to write out the date in a friendly format
	NSDateFormatter *df = [[NSDateFormatter alloc] init];
	df.dateStyle = NSDateFormatterMediumStyle;
	[df setDateFormat:@"HH:mm:ss"];
	label_crono.text = [NSString stringWithFormat:@"%@",
                        [df stringFromDate:picker_crono.date]];
	[df release];

    if (((label.text==@"SELECCIONA ACTIVIDAD:")||(label.text==@"CHOOSE ACTIVITY:")))
    {
        [VISTA_IMAGEN_RELOJ setHidden:YES];
        [texto_imagen_primera setHidden:YES];
        
		[but_reloj_ok setHidden:YES];
        [but_reloj_ok setEnabled:NO];
	}
	else 
    {
        [VISTA_IMAGEN_RELOJ setHidden:NO];
        [texto_imagen_primera setHidden:NO];
        
        if ([label_crono.text isEqualToString:prueba]) 
        {
            [but_reloj_ok setHidden:YES];
            [but_reloj_ok setEnabled:NO];
        }
        else
        {
            [but_reloj_ok setHidden:NO];
            [but_reloj_ok setEnabled:YES];
        }
	}
}

-(IBAction) PULSAR_OK_RELOJ: (id) sender
{
	[VISTA_PRINCIPAL_RELOJ addSubview:VISTA_SECUNDARIA_RELOJ];
    
    [but_reloj_volver setHidden:NO];
    [but_reloj_volver setEnabled:YES];
    
    [but_reloj_empezar setHidden:NO];
    [but_reloj_empezar setEnabled:YES];
    
    [but_reloj_inicio_segundo setHidden:NO];
    [but_reloj_inicio_segundo setEnabled:YES];

	[VISTA_SECUNDARIA_RELOJ addSubview:reloj_caracol];
	[VISTA_SECUNDARIA_RELOJ addSubview:mascara];
	[VISTA_SECUNDARIA_RELOJ addSubview:animalillo];
	
    if ((label.text==@"TRABAJAR")||(label.text==@"WORK"))
    {
        [VISTA_SECUNDARIA_IMAGEN setImage:[UIImage imageNamed:@"trabajar"]];
        if (ajuste_tipo_letra<40)
        {
            [texto_imagen_segunda setText:@"TRABAJAR"];
        }
        else
        {
            [texto_imagen_segunda setText:@"WORK"];
        }
	}
	else if ((label.text==@"JUGAR")||(label.text==@"PLAY"))
    {
        [VISTA_SECUNDARIA_IMAGEN setImage:[UIImage imageNamed:@"jugar"]];
        if (ajuste_tipo_letra<40)
        {
            [texto_imagen_segunda setText:@"JUGAR"];
        }
        else
        {
            [texto_imagen_segunda setText:@"PLAY"];
        }
	}
	else if ((label.text==@"COMER")||(label.text==@"EAT"))
    {
        [VISTA_SECUNDARIA_IMAGEN setImage:[UIImage imageNamed:@"comer"]];
        if (ajuste_tipo_letra<40)
        {
            [texto_imagen_segunda setText:@"COMER"];
        }
        else
        {
            [texto_imagen_segunda setText:@"EAT"];
        }
	}
	else if ((label.text==@"BAILAR")||(label.text==@"DANCE"))
    {
        [VISTA_SECUNDARIA_IMAGEN setImage:[UIImage imageNamed:@"bailar"]];
        if (ajuste_tipo_letra<40)
        {
            [texto_imagen_segunda setText:@"BAILAR"];
        }
        else
        {
            [texto_imagen_segunda setText:@"DANCE"];
        }
	}
	
    /*
	if (txt.hidden == NO)  
    {
		label.text=txt.text;
		[VISTA_SECUNDARIA_IMAGEN addSubview:VISTA_ACCION_OTRO];
	}
	*/
    
	//Coloco las capas del caracol
	hierba=[CALayer layer];
	hierba=reloj_caracol.layer;  // "hierba" es una CALayer que va insertada dentro del UIView "reloj".
	hierba.bounds=CGRectMake(0.0f, 0.0f, 900.0f, 95.0f); // los límites de la imagen que contenga, en el origen 0,0 con respecto al total de pantalla.
	hierba.anchorPoint=CGPointMake(0.5f, 0.0f); // el punto de referencia de la capa se sitúa en el 0,5; 0,0 de la capa en la que está contenida.
	hierba.contents= (id)[[UIImage imageNamed:@"hierba.png"] CGImage]; // Esta CALayer contiene la imagen "hierba.png"
	
	hoja=[CALayer layer];
	hoja.bounds=CGRectMake(0.0f, 0.0f, 134.0f, 146.0f);
	hoja.position=CGPointMake(820.0f, 30.0f); // Se señala la posición con respecto a la capa que va a ocupar. (sublayer de "hierba")
	hoja.contents= (id)[[UIImage imageNamed:@"hoja_reloj.png"] CGImage];
	
	[hierba addSublayer:hoja];
	
	baba=[CALayer layer]; // "baba" es una CALayer que va insertada dentro del UIView "mascara",
	baba=mascara.layer;   // puesto que va a tener un efecto así, y no queremos que el efecto se aplique a otros UIViews.(como "hierba") 
	baba.bounds=CGRectMake(0.0f, 0.0f, 900.0f, 95.0f);
	baba.anchorPoint=CGPointMake(0.5f, 0.4f);
	baba.contents= (id)[[UIImage imageNamed:@"baba.png"] CGImage]; // Contiene la imagen propia de la baba.
	
	babamask=[CALayer layer]; // "babamask" es una CALayer que va a hacer el efecto de máscara sobre la CALayer que la coloquemos.
	// La imagen que contenga, será la forma del hueco que dejará ver.
	babamask.bounds=CGRectMake(0.0f, 0.0f, 150.0f, 95.0f);
	babamask.anchorPoint=CGPointMake(0.0f, 0.0f);
	babamask.contents=(id)[[UIImage imageNamed:@"mascara.png"] CGImage]; // contiente la imagen "mascara.png" consistente en un rectángulo.
	
	[baba setMask:babamask]; // Se aplica la máscara sólamente a la capa deseada.
	
	caracol=[CALayer layer];
	caracol=animalillo.layer;
	caracol.bounds=CGRectMake(0.0f, 0.0f, 200.0f, 174.0f);
	caracol.anchorPoint=CGPointMake(2.3f, 0.25f);
	caracol.contents= (id)[[UIImage imageNamed:@"caracolillo.png"] CGImage];
	
	cabeza=[CALayer layer];
	cabeza.bounds=CGRectMake(0.0f, 0.0f, 200.0f, 174.0f);
	cabeza.position=CGPointMake(0.0f, 174.0f);
	cabeza.anchorPoint=CGPointMake(0.0f, 1.0f);
	cabeza.contents= (id)[[UIImage imageNamed:@"cabeza_reloj.png"] CGImage];
	
	[caracol addSublayer:cabeza];
}

- (IBAction) PULSAR_START: (id) sender;
{
	mainInt=[picker_crono countDownDuration];
	cuenta_atras=[picker_crono countDownDuration];
	timer=[NSTimer scheduledTimerWithTimeInterval:(1.0/1.0) target:self selector:@selector(updateLabel) userInfo:nil repeats:YES];
    
    [self Ajustar];
    
    if (ajuste_tipo_letra<40)
    {
        [but_reloj_empezar setTitle:@"EMPEZAR" forState:normal];
    }
    else
    {
        [but_reloj_empezar setTitle:@"START" forState:normal];
    }
    
    [but_reloj_empezar setHidden:YES];
    [but_reloj_empezar setEnabled:NO];
    
    [but_reloj_volver setHidden:YES];
    [but_reloj_volver setEnabled:NO];
    
    [but_reloj_inicio_segundo setHidden:YES];
    [but_reloj_inicio_segundo setEnabled:NO];
    
    [but_reloj_parar_oculto setHidden:NO];
    [but_reloj_parar_oculto setEnabled:YES];
    
    [but_reloj_parar setHidden:YES];
    [but_reloj_parar setEnabled:NO];
    
	//Creamos la animacion del caracol
	caracolmove=[CABasicAnimation animationWithKeyPath:@"anchorPoint"];
	caracolmove.fromValue=[NSValue valueWithCGPoint: CGPointMake(2.3, 0.25)];
	caracolmove.toValue=[NSValue valueWithCGPoint: CGPointMake(-0.8, 0.25)];
	caracolmove.duration=cuenta_atras;
	caracolmove.fillMode = kCAFillModeForwards; //estas dos líneas hacen que la animación se mantenga en su posición final.
	caracolmove.removedOnCompletion = NO;
    
	maskmove=[CABasicAnimation animationWithKeyPath:@"bounds"];
	maskmove.fromValue=[NSNumber valueWithCGRect: CGRectMake(0.0f, 0.0f, 150.0f, 95.0f)];
	maskmove.toValue=[NSNumber valueWithCGRect: CGRectMake(0.0f, 0.0f, 730.0f, 95.0f)];
	maskmove.duration=cuenta_atras;
	maskmove.fillMode = kCAFillModeForwards;
	maskmove.removedOnCompletion=NO;
	
	
	// Añadimos la animación a la capa correspondiente y así la inicializamos: 
	
	babamask.speed=1.0; //Activamos la velocidad en caso de que haya sido desactivada.
	caracol.speed=1.0;
	
	[caracol addAnimation:caracolmove forKey:@"caracolmove"];
	[babamask addAnimation:maskmove forKey:@"maskmove"];
}

- (IBAction) PULSAR_STOP: (id) sender;
{	
	[timer invalidate];

	[animalillo removeFromSuperview];
	[mascara removeFromSuperview];
    
    [self Ajustar];
    
    if (ajuste_tipo_letra<40)
    {
        [but_reloj_parar setTitle:@"PARAR" forState:normal];
    }
    else
    {
        [but_reloj_parar setTitle:@"STOP" forState:normal];
    }
	
    [but_reloj_parar setHidden:YES];
    [but_reloj_parar setEnabled:NO];
    
    [but_reloj_parar_oculto setHidden:YES];
    [but_reloj_parar_oculto setEnabled:NO];
    
    [but_reloj_inicio_segundo setHidden:NO];
    [but_reloj_inicio_segundo setEnabled:YES];

}

//Actualizar label_crono y funcionamiento de reloj.

-(void) updateLabel
{
	
    // CUANDO EL LABEL LLEGA A CERO...
	
	mainInt = mainInt - 1;
	if (mainInt == 0.0) {
		
		[timer invalidate];
        
        [but_reloj_parar_oculto setHidden:YES];
        [but_reloj_parar_oculto setEnabled:NO];
        
        [but_reloj_parar setHidden:YES];
        [but_reloj_parar setEnabled:NO];
        
        [but_reloj_inicio_segundo setHidden:NO];
        [but_reloj_inicio_segundo setEnabled:YES];
		
		cabezamove=[CABasicAnimation animationWithKeyPath:@"transform.rotation.z"];
		cabezamove.fromValue = [NSNumber numberWithFloat:0];
		cabezamove.toValue = [NSNumber numberWithFloat:0.05];
		cabezamove.duration=1;
		cabezamove.autoreverses=YES;
		cabezamove.repeatCount=2;
		
		[cabeza addAnimation:cabezamove forKey:@"cabezamove"];
		hoja.contents= (id)[[UIImage imageNamed:@"hoja_mordida.png"] CGImage];
		
		//Hacemos que suene el mordisco
		SystemSoundID mordisco;  
		AudioServicesCreateSystemSoundID((CFURLRef)[NSURL fileURLWithPath:[[NSBundle mainBundle] pathForResource:@"mordisco" ofType:@"wav"]], &mordisco);  
		AudioServicesPlaySystemSound (mordisco);
	}
	
	
	NSDate *nuevaFecha = [NSDate dateWithTimeIntervalSinceReferenceDate:mainInt-3600]; 
	NSDateFormatter *df = [[NSDateFormatter alloc] init];
	[df setDateFormat:@"HH:mm:ss"];
	label_crono.text =  [df stringFromDate:nuevaFecha];
	[df release];
}

-(IBAction) PULSAR_VOLVER_RELOJ: (id) sender
{
    [self Ajustar];
    
    if (ajuste_tipo_letra<40)
    {
        [but_reloj_volver setTitle:@"VOLVER" forState:normal];
        [but_reloj_inicio_primero setTitle:@"INICIO" forState:normal];
        
        label.text=@"SELECCIONA ACTIVIDAD:";
    }
    else
    {
        [but_reloj_volver setTitle:@"BACK" forState:normal];
        [but_reloj_inicio_primero setTitle:@"HOME" forState:normal];
        
        label.text=@"SELECT ONE ACTIVITY:";
    }
    
	[self.view removeFromSuperview];
    
    //txt.hidden=YES;
    //txt.text=@"";
	[picker selectRow:0 inComponent:0 animated:NO];
	picker_crono.date=[NSDate distantPast];
	
	NSDateFormatter *format = [[NSDateFormatter alloc] init];
	[format setDateFormat:@"hh:mm:ss"];
	NSString *prod=@"00:00:00";
	NSDate *myDate = [format dateFromString: prod];
	picker_crono.date=myDate;
	
	NSDateFormatter *df = [[NSDateFormatter alloc] init];
	df.dateStyle = NSDateFormatterMediumStyle;
	[df setDateFormat:@"HH:mm:ss"];
	label_crono.text = [NSString stringWithFormat:@"%@",
						[df stringFromDate:picker_crono.date]];
	[df release];
    
}

-(IBAction) PULSAR_VOLVER_OK_RELOJ: (id) sender
{
    [but_reloj_parar setHidden:YES];
    [but_reloj_parar setEnabled:NO];
    
	[VISTA_SECUNDARIA_RELOJ removeFromSuperview];

    /*
	else if ((label.text==@"OTRO")||(label.text==@"OTRO"))
    {
		[VISTA_IMAGEN_RELOJ addSubview:VISTA_ACCION_OTRO];
	}
     */    
    
}

-(IBAction) PULSAR_VOLVER_OK_A_HOME: (id) sender
{
    [self Ajustar];
    
    if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
    {
        label.text=@"SELECCIONA ACTIVIDAD:";
        [but_reloj_inicio_segundo setTitle:@"INICIO" forState:normal];
    }
    else //IDIOMA INGLÉS
    {
        label.text=@"SELECT ONE ACTIVITY:";
        [but_reloj_inicio_segundo setTitle:@"HOME" forState:normal];
    }

    [VISTA_SECUNDARIA_RELOJ removeFromSuperview];
    [self.view removeFromSuperview];
    
	babamask.speed=0.0; //Inhabilitamos la velocidad
	caracol.speed=0.0;
	[cabeza removeFromSuperlayer];
	[hoja removeFromSuperlayer];
	
	//txt.text=@"";
	//txt.hidden=YES;
    
    [but_reloj_ok setHidden:YES];
    [but_reloj_ok setEnabled:NO];
    
	[picker selectRow:0 inComponent:0 animated:NO];
	
	NSDateFormatter *format = [[NSDateFormatter alloc] init];
	[format setDateFormat:@"hh:mm:ss"];
	NSString *prod=@"00:00:00";
	NSDate *myDate = [format dateFromString: prod];
	picker_crono.date=myDate;
    
	NSDateFormatter *df = [[NSDateFormatter alloc] init];
	df.dateStyle = NSDateFormatterMediumStyle;
	[df setDateFormat:@"HH:mm:ss"];
	label_crono.text = [NSString stringWithFormat:@"%@",
						[df stringFromDate:picker_crono.date]];
	[df release];
}

- (IBAction) PULSAR_BOTON_OCULTO_PARAR: (id) sender
{
	if (pulsacion_reloj == NO)
	{
		pulsacion_reloj = YES;
        
        [but_reloj_parar setHidden:NO];
        [but_reloj_parar setEnabled:YES];
        
        [but_reloj_empezar setHidden:YES];
        [but_reloj_empezar setEnabled:NO];
	}
	else
	{
		pulsacion_reloj = NO;
        
        [but_reloj_parar setHidden:YES];
        [but_reloj_parar setEnabled:NO];
        
        [but_reloj_empezar setHidden:NO];
        [but_reloj_empezar setEnabled:YES];
        
	}
}



@end
