//
//  VisorFotos.h
//  COMUNICADOR
//
//  Created by Elisabeth Esandia Melero on 10/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <AssetsLibrary/AssetsLibrary.h>

@class MyScrollView;
@class Ajustes;

@interface VisorFotos : UIViewController <UIScrollViewDelegate> {
    
    /////////////////////////////
    //      AJUSTES            //
    Ajustes * ControladorAjustes;
    
    int ajuste_resp_negativa;
    int ajuste_tiempo_pulsacion;
    int ajuste_tipo_letra;
    
    NSTimer *pulsacionTimer;
    
    //En Idioma irá el string correspondiente a la columna de la base de datos que quiero consultar
    NSString *Idioma;
    
    ////////////////////////////
    
    IBOutlet UIScrollView *scroll;
    
    IBOutlet UIImageView *album_fondo;
    
    NSArray *imageSet;
    int imagen_inicial;
    int NumImages;
    BOOL metodoCarga;
    
    UIImageView *nextView;
    UIImageView *view1;
	UIImageView *view2;
	
	int view1Index;
	int view2Index;
    
    IBOutlet UIButton * BotonSiguiente;
    IBOutlet UIButton * BotonAnterior;
    IBOutlet UIButton * BotonVolver;
    
    IBOutlet UILabel * pictosText1;
    IBOutlet UILabel * pictosText2;
    IBOutlet UILabel * pictosTextNext;
    
}

@property (nonatomic, retain) Ajustes *ControladorAjustes;

@property(nonatomic,retain)IBOutlet UIImageView *album_fondo;


@property(nonatomic,retain)IBOutlet UIScrollView *scroll;
@property(nonatomic,retain)IBOutlet UIButton *BotonSiguiente;
@property(nonatomic,retain)IBOutlet UIButton *BotonAnterior;
@property(nonatomic,retain)IBOutlet UIButton *BotonVolver;
@property(nonatomic,retain)IBOutlet UILabel *pictosText1;
@property(nonatomic,retain)IBOutlet UILabel *pictosText2;
@property(nonatomic,retain)IBOutlet UILabel *pictosTextNext;

-(void)Ajustar;

-(void)cargarImagen:(int)imagen_inic cargarArray:(NSMutableArray*)nuevasImagenes metodo:(BOOL)metodoDeCarga;
-(IBAction)volverFotos:(id)sender;
-(IBAction)pulsarImagSiguiente:(id)sender;
-(IBAction)pulsarImagAnterior:(id)sender;


@end
