    //
//  cargarFotos.m
//  COMUNICADOR
//
//  Created by Elisabeth Esandia Melero on 30/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "COMUNICADORAppDelegate.h"
#import "cargarFotos.h"
#import "VisorFotos.h"
#import <AssetsLibrary/AssetsLibrary.h>
#import "Ajustes.h"


@implementation cargarFotos

@synthesize activity;

@synthesize Thumbnail1;
@synthesize Thumbnail2;
@synthesize Thumbnail3;
@synthesize Thumbnail4;
@synthesize Thumbnail5;
@synthesize Thumbnail6;
@synthesize Thumbnail7;
@synthesize Thumbnail8;
@synthesize Thumbnail9;
@synthesize Thumbnail10;
@synthesize Thumbnail11;
@synthesize Thumbnail12;
@synthesize Thumbnail13;
@synthesize Thumbnail14;
@synthesize Thumbnail15;

@synthesize Label1;
@synthesize Label2;
@synthesize Label3;
@synthesize Label4;
@synthesize Label5;
@synthesize Label6;
@synthesize Label7;
@synthesize Label8;
@synthesize Label9;
@synthesize Label10;
@synthesize Label11;
@synthesize Label12;
@synthesize Label13;
@synthesize Label14;
@synthesize Label15;

@synthesize BotonSiguiente;
@synthesize BotonAnterior;
@synthesize BotonVolver;

@synthesize VisorFotosVista;
@synthesize ControladorAjustes;

@synthesize pulsacionTimer;



/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    
    ControladorAjustes =[[Ajustes alloc]init];
    [self Ajustar];
    
    if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
    {
        [BotonVolver setTitle:@"VOLVER" forState:normal];
        alertaSimplePersonalizada = [UIAlertView alloc];
        [alertaSimplePersonalizada initWithTitle:@"ALERTA" 
                            message:@"No hay pictos personalizados de esta entidad" 
                           delegate:self 
                  cancelButtonTitle:@"Aceptar" 
                  otherButtonTitles: nil];
        
        alertaSimple = [UIAlertView alloc];
        [alertaSimple initWithTitle:@"ALERTA" 
                            message:@"No hay pictos asociados" 
                           delegate:self 
                  cancelButtonTitle:@"Aceptar" 
                  otherButtonTitles: nil];
    }
    else //IDIOMA INGLÉS
    {
        [BotonVolver setTitle:@"BACK" forState:normal];
        alertaSimplePersonalizada = [UIAlertView alloc];
        [alertaSimplePersonalizada initWithTitle:@"ALERT" 
                            message:@"There are not personalized pictos for this entity" 
                           delegate:self
                  cancelButtonTitle:@"Ok" 
                  otherButtonTitles: nil];
        
        alertaSimple = [UIAlertView alloc];
        [alertaSimple initWithTitle:@"ALERT" 
                            message:@"There are not personalized pictos for this entity" 
                           delegate:self 
                  cancelButtonTitle:@"Ok" 
                  otherButtonTitles: nil];
    }
    
    [activity startAnimating];
    
    assets = [[NSMutableArray alloc] init];
    library  = [[ALAssetsLibrary alloc] init];
    
    objects = [[NSArray alloc] init];
    objectsCogidos =[[NSMutableArray alloc]init];
    
    appDelegate = [[UIApplication sharedApplication] delegate];
    context = [appDelegate managedObjectContext];
    
    appDelegate_per = [[UIApplication sharedApplication] delegate]; // Parte de la BD
    context_per = [appDelegate_per managedObjectContext]; // Parte de la BD
    
    thumbnail_table = [[NSMutableArray alloc]  initWithObjects:Thumbnail1, Thumbnail2, Thumbnail3, Thumbnail4, Thumbnail5, Thumbnail6, Thumbnail7, Thumbnail8, Thumbnail9, Thumbnail10, Thumbnail11, Thumbnail12, Thumbnail13, Thumbnail14, Thumbnail15, nil];
    
    label_table=[[NSMutableArray alloc] initWithObjects:Label1, Label2, Label3, Label4, Label5, Label6, Label7, Label8, Label9, Label10, Label11, Label12, Label13, Label14, Label15, nil];

    for (int i=0; i<[thumbnail_table count]; i++) 
    {
        [[thumbnail_table objectAtIndex:i] setHidden:YES];    
    }
    
    for (int i=0; i<[label_table count]; i++) 
    {
        [[label_table objectAtIndex:i] setText:@""];    
    }
    
    num_pag_view = 0;
    [BotonAnterior setEnabled:NO];
    [BotonAnterior setHidden:YES];
    [BotonSiguiente setEnabled:NO];
    [BotonSiguiente setHidden:YES];
    
    VisorFotosVista=[[VisorFotos alloc] initWithNibName:@"VisorFotos" bundle:[NSBundle mainBundle]]; //Eli

    [super viewDidLoad];
}

- (void)alertView:(UIAlertView *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex {
    // the user clicked one of the OK/Cancel buttons
    if (buttonIndex == 0)
    {
        [self.view removeFromSuperview];
    }
}

- (void)Ajustar
{
    [ControladorAjustes viewDidLoad];
    ajuste_resp_negativa=ControladorAjustes.resp_negativa;
    ajuste_tiempo_pulsacion=ControladorAjustes.tiempo_pulsacion;
    ajuste_tipo_letra=ControladorAjustes.tipo_letra;
    
    if (ajuste_tipo_letra==20)
    {
        Idioma=@"nombre";
    }
    else if (ajuste_tipo_letra==30)
    {
        Idioma=@"nombre_may";
    }
    else if (ajuste_tipo_letra==50)
    {
        Idioma=@"nombre_ing";
    }
    else if (ajuste_tipo_letra==60)
    {
        Idioma=@"nombre_may_ing";
    }
    
    NSLog(@"respuesta negativa %i, tiempo pulsacion %i, tipo letra %i",ajuste_resp_negativa,ajuste_tiempo_pulsacion,ajuste_tipo_letra);
}

-(IBAction)touchDown:(id)sender
{
	self.pulsacionTimer = [NSTimer scheduledTimerWithTimeInterval:ajuste_tiempo_pulsacion target:self selector:@selector(showVista) userInfo:sender repeats:NO];
}

-(IBAction)touchUp:(id)sender
{
	[pulsacionTimer invalidate];
}

-(void)showVista
{
    [self.view addSubview:VisorFotosVista.view];
    
    NSInteger ButtonTagInteger= [pulsacionTimer.userInfo tag];
    NSLog(@"Imagen seleccionada = %i",ButtonTagInteger);
    
    NSMutableArray*nuevasImagenes=[[NSMutableArray alloc]init];
    
    if (metodoCarga==0) 
    {
        nuevasImagenes=assets;
    }
    else
    {
        nuevasImagenes=objectsCogidos;
    }
    
    //[VisorFotosVista viewDidLoad];
    [VisorFotosVista cargarImagen:((num_pag_view*[thumbnail_table count])+ButtonTagInteger) cargarArray:nuevasImagenes metodo:metodoCarga];      
}

- (void)onVerPersonalizado:(BOOL)verPersonalizado
{
    
    ONPersonalizado=verPersonalizado;
    NSLog(@"ESTOY VIENDO PERSONALIZADOS %i", ONPersonalizado);
}

- (void)cargarDatosEnArray:(int)tipo_album
{    
    dispatch_async(dispatch_get_main_queue(), ^
                 {
                       NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    
	NSLog(@"Estoy cargando Datos");
                     NSLog(@"ESTOY VIENDO PERSONALIZADOS %i", ONPersonalizado);
                     
    switch (tipo_album) 
    {
        case 0:
        {
        [library enumerateGroupsWithTypes:ALAssetsGroupAll 
                               usingBlock:
                            // Group enumerator Block
                                ^(ALAssetsGroup *group, BOOL *stop) 
                            {
                                   if(group != nil)
                                   {
                                       [group enumerateAssetsUsingBlock:
                          
                                        // Asset enumerate Block            
                                        ^(ALAsset *result, NSUInteger index, BOOL *stop) 
                                       {
                                            if(result != NULL) 
                                            { 
                                                [assets addObject:result];
                                            };
                                        }
                                         ];
                                   };      
                                [self.activity stopAnimating];
                                [self.activity setHidden:YES];
                                metodoCarga=0;
                                [self reloadRenderPics];
                            }
                             failureBlock: 
                                ^(NSError *error) {
                                    NSLog(@"Failure");}
         ];
        [library release];
        }
            break;
        case 1:
        {
            [activity startAnimating];
            
            if (ONPersonalizado)  // LLAMAREMOS A LOS PERSONALIZADOS
            {
                //////////////////////////////////////////////////////////////
                // LLAMADA A LA BD ENTIDAD PERSONALIZADA
                //////////////////////////////////////////////////////////////
                NSLog(@"Se está cargando el álbum LUGARES PERSONALIZADOS");
                entityDesc_per=[NSEntityDescription entityForName:@"Lugar" inManagedObjectContext:context_per];
                request_personalizado=[[NSFetchRequest alloc]init];
                [request_personalizado setEntity:entityDesc_per];
                pred_personalizado = [NSPredicate predicateWithFormat:@"ANY album_personalizado like '1'"];
                [request_personalizado setPredicate:pred_personalizado];
                objects =[context_per executeFetchRequest:request_personalizado error:&error_per];
                
                if ([objects count] == 0) 
                {
                    [alertaSimplePersonalizada show];
                } 
                else 
                {
                    [self.activity stopAnimating];
                    [self.activity setHidden:YES];
                    metodoCarga=1;
                    [objectsCogidos setArray:objects];
                    [self reloadRenderPics];
                    [self.activity stopAnimating];
                    [request_personalizado release];
                }
            }
            else
            {
                //////////////////////////////////////////////////////////////
                // LLAMADA A LA BD ENTIDAD ORIGINAL
                //////////////////////////////////////////////////////////////
                NSLog(@"Se está cargando el álbum LUGARES");
                entityDesc = [NSEntityDescription entityForName:@"Lugar" inManagedObjectContext:context];
                request = [[NSFetchRequest alloc] init];
                [request setEntity:entityDesc];
                objects = [context executeFetchRequest:request error:&error];
                
                if ([objects count] == 0) 
                {
                    [alertaSimple show];
                } 
                else 
                {
                    [self.activity stopAnimating];
                    [self.activity setHidden:YES];
                    metodoCarga=1;
                    [objectsCogidos setArray:objects];
                    
                    [self reloadRenderPics];
                    [self.activity stopAnimating];
                    [request release];
                } 
            }
            break;
                 
        }
        case 2:
        {
            [activity startAnimating];
            if (ONPersonalizado)  // LLAMAREMOS A LOS PERSONALIZADOS
            {
                //////////////////////////////////////////////////////////////
                // LLAMADA A LA BD ENTIDAD PERSONALIZADA
                //////////////////////////////////////////////////////////////
                NSLog(@"Se está cargando el álbum SUBLUGARES PERSONALIZADOS");
                entityDesc_per=[NSEntityDescription entityForName:@"Sublugar" inManagedObjectContext:context_per];
                request_personalizado=[[NSFetchRequest alloc]init];
                [request_personalizado setEntity:entityDesc_per];
                pred_personalizado = [NSPredicate predicateWithFormat:@"ANY album_personalizado like '1'"];
                [request_personalizado setPredicate:pred_personalizado];
                objects =[context_per executeFetchRequest:request_personalizado error:&error_per];
                
                if ([objects count] == 0) 
                {
                    [alertaSimplePersonalizada show];
                } 
                else 
                {
                    [self.activity stopAnimating];
                    [self.activity setHidden:YES];
                    metodoCarga=1;
                    [objectsCogidos setArray:objects];
                    [self reloadRenderPics];
                    [self.activity stopAnimating];
                    [request_personalizado release];
                }
            }
            else
            {
                //////////////////////////////////////////////////////////////
                // LLAMADA A LA BD ENTIDAD ORIGINAL
                //////////////////////////////////////////////////////////////
                NSLog(@"Se está cargando el álbum SUBLUGARES");
                entityDesc = [NSEntityDescription entityForName:@"Sublugar" inManagedObjectContext:context];
                request = [[NSFetchRequest alloc] init];
                [request setEntity:entityDesc];
                objects = [context executeFetchRequest:request error:&error];
                
                if ([objects count] == 0) 
                {
                    [alertaSimple show];
                } 
                else 
                {
                    [self.activity stopAnimating];
                    [self.activity setHidden:YES];
                    metodoCarga=1;
                    [objectsCogidos setArray:objects];
                    
                    [self reloadRenderPics];
                    [self.activity stopAnimating];
                    [request release];
                }   
            }
            
        }
            break;
        case 3:
        {
            [activity startAnimating];
            if (ONPersonalizado)  // LLAMAREMOS A LOS PERSONALIZADOS
            {
                //////////////////////////////////////////////////////////////
                // LLAMADA A LA BD ENTIDAD PERSONALIZADA
                //////////////////////////////////////////////////////////////
                NSLog(@"Se está cargando el álbum PERSONAS PERSONALIZADOS");
                entityDesc_per=[NSEntityDescription entityForName:@"Personas" inManagedObjectContext:context_per];
                request_personalizado=[[NSFetchRequest alloc]init];
                [request_personalizado setEntity:entityDesc_per];
                pred_personalizado = [NSPredicate predicateWithFormat:@"ANY album_personalizado like '1'"];
                [request_personalizado setPredicate:pred_personalizado];
                objects =[context_per executeFetchRequest:request_personalizado error:&error_per];
                
                if ([objects count] == 0) 
                {
                    [alertaSimplePersonalizada show];
                } 
                else 
                {
                    [self.activity stopAnimating];
                    [self.activity setHidden:YES];
                    metodoCarga=1;
                    [objectsCogidos setArray:objects];
                    [self reloadRenderPics];
                    [self.activity stopAnimating];
                    [request_personalizado release];
                }
            }
            else
            {
                //////////////////////////////////////////////////////////////
                // LLAMADA A LA BD ENTIDAD ORIGINAL
                //////////////////////////////////////////////////////////////
                NSLog(@"Se está cargando el álbum PERSONAS");
                entityDesc = [NSEntityDescription entityForName:@"Personas" inManagedObjectContext:context];
                request = [[NSFetchRequest alloc] init];
                [request setEntity:entityDesc];
                objects = [context executeFetchRequest:request error:&error];
                
                if ([objects count] == 0) 
                {
                    [alertaSimple show];
                } 
                else 
                {
                    [self.activity stopAnimating];
                    [self.activity setHidden:YES];
                    metodoCarga=1;
                    [self.activity stopAnimating];
                    [self.activity setHidden:YES];
                    metodoCarga=1;
                    [objectsCogidos setArray:objects];
                    
                    [self reloadRenderPics];
                    [self.activity stopAnimating];
                    [request release];
                    
                } 
            }
            
        }
            break;
        case 4:
        {
            [activity startAnimating];
            if (ONPersonalizado)  // LLAMAREMOS A LOS PERSONALIZADOS
            {
                //////////////////////////////////////////////////////////////
                // LLAMADA A LA BD ENTIDAD PERSONALIZADA
                //////////////////////////////////////////////////////////////
                NSLog(@"Se está cargando el álbum VERBOS PERSONALIZADOS");
                entityDesc_per=[NSEntityDescription entityForName:@"Verbos" inManagedObjectContext:context_per];
                request_personalizado=[[NSFetchRequest alloc]init];
                [request_personalizado setEntity:entityDesc_per];
                pred_personalizado = [NSPredicate predicateWithFormat:@"ANY album_personalizado like '1'"];
                [request_personalizado setPredicate:pred_personalizado];
                objects =[context_per executeFetchRequest:request_personalizado error:&error_per];
                
                if ([objects count] == 0) 
                {
                    [alertaSimplePersonalizada show];
                } 
                else 
                {
                    [self.activity stopAnimating];
                    [self.activity setHidden:YES];
                    metodoCarga=1;
                    [objectsCogidos setArray:objects];
                    [self reloadRenderPics];
                    [self.activity stopAnimating];
                    [request_personalizado release];
                }
            }
            else
            {
                //////////////////////////////////////////////////////////////
                // LLAMADA A LA BD ENTIDAD ORIGINAL
                //////////////////////////////////////////////////////////////
                NSLog(@"Se está cargando el álbum VERBOS");
                entityDesc = [NSEntityDescription entityForName:@"Verbos" inManagedObjectContext:context];
                request = [[NSFetchRequest alloc] init];
                [request setEntity:entityDesc];
                objects = [context executeFetchRequest:request error:&error];
                
                if ([objects count] == 0) 
                {
                    [alertaSimple show];
                } 
                else 
                {
                    [self.activity stopAnimating];
                    [self.activity setHidden:YES];
                    metodoCarga=1;
                    [objectsCogidos setArray:objects];
                    
                    [self reloadRenderPics];
                    [self.activity stopAnimating];
                    [request release];
                }
            }
            
        }
            break;
        case 5:
        {
            [activity startAnimating];
            if (ONPersonalizado)  // LLAMAREMOS A LOS PERSONALIZADOS
            {
                //////////////////////////////////////////////////////////////
                // LLAMADA A LA BD ENTIDAD PERSONALIZADA
                //////////////////////////////////////////////////////////////
                NSLog(@"Se está cargando el álbum COMPLEMENTOS PERSONALIZADOS");
                entityDesc_per=[NSEntityDescription entityForName:@"Complementos" inManagedObjectContext:context_per];
                request_personalizado=[[NSFetchRequest alloc]init];
                [request_personalizado setEntity:entityDesc_per];
                pred_personalizado = [NSPredicate predicateWithFormat:@"ANY album_personalizado like '1'"];
                [request_personalizado setPredicate:pred_personalizado];
                objects =[context_per executeFetchRequest:request_personalizado error:&error_per];
                
                if ([objects count] == 0) 
                {
                    [alertaSimplePersonalizada show];
                } 
                else 
                {
                    [self.activity stopAnimating];
                    [self.activity setHidden:YES];
                    metodoCarga=1;
                    [objectsCogidos setArray:objects];
                    [self reloadRenderPics];
                    [self.activity stopAnimating];
                    [request_personalizado release];
                }
            }
            else
            {
                //////////////////////////////////////////////////////////////
                // LLAMADA A LA BD ENTIDAD ORIGINAL
                //////////////////////////////////////////////////////////////
                NSLog(@"Se está cargando el álbum COMPLEMENTOS");
                entityDesc = [NSEntityDescription entityForName:@"Complementos" inManagedObjectContext:context];
                request = [[NSFetchRequest alloc] init];
                [request setEntity:entityDesc];
                objects = [context executeFetchRequest:request error:&error];
                
                if ([objects count] == 0) 
                {
                    [alertaSimple show];
                } 
                else 
                {
                    [self.activity stopAnimating];
                    [self.activity setHidden:YES];
                    metodoCarga=1;
                    [objectsCogidos setArray:objects];
                    
                    [self reloadRenderPics];
                    [self.activity stopAnimating];
                    [request release];
                } 
            }
            
        }
            break;
        default:
            break;
    }

    [pool release];
        });
}

-(void)reloadRenderPics
{	
    indice=num_pag_view*[thumbnail_table count];
    
    NSLog(@"indice= %i;num_pag_view= %i; thumbnail_table count= %i; metodoCarga = %i", indice, num_pag_view, [thumbnail_table count], metodoCarga);
    
    objects=nil;
    
    if (metodoCarga==0) 
    {
        int contar=[assets count];
        NSLog(@"imagenes que tenemos %i ",contar);
        
        for (int i=0; i<[thumbnail_table count]; i++) 
        {
            if ((i+indice)<[assets count]) 
            {
                [[thumbnail_table objectAtIndex:i] setImage:[UIImage imageWithCGImage:[[assets objectAtIndex:(i+indice)] thumbnail] 
                                                      scale:0.5 orientation:UIImageOrientationUp] forState:UIControlStateNormal];
                [[thumbnail_table objectAtIndex:i] setHidden:NO];
                [BotonSiguiente setEnabled:YES];
                [BotonSiguiente setHidden:NO];
            }
            else 
            {
                //Hide the button
                [[thumbnail_table objectAtIndex:i] setHidden:YES]; 
                [BotonSiguiente setEnabled:NO];
                [BotonSiguiente setHidden:YES];
                if (indice!=0) 
                {
                    [BotonAnterior setEnabled:YES];
                    [BotonAnterior setHidden:NO];
                }
                else
                {
                    NSLog(@"Estoy en la primera página!");
                }
            }
        } 
    }
    else
    {        
        int contar2=[objectsCogidos count];
        NSLog(@"imagenes que tenemos %i ",contar2);

        for (int i=0; i<[thumbnail_table count]; i++) 
        {
            NSLog(@"i= %i; indice= %i",i,indice);
            if ((i+indice)<[objectsCogidos count]) 
            {   
                [[thumbnail_table objectAtIndex:i] setImage:[UIImage imageNamed:[[objectsCogidos objectAtIndex:(i+indice)] 
                                                                                 valueForKey:@"nombre"]]forState:UIControlStateNormal];
                [[label_table objectAtIndex:i] setText:[[objectsCogidos objectAtIndex:i+indice]valueForKey:Idioma]];
                [[thumbnail_table objectAtIndex:i] setHidden:NO];
                [BotonSiguiente setEnabled:YES];
                [BotonSiguiente setHidden:NO];
            }
            else 
            {
                //Hide the button
                [[thumbnail_table objectAtIndex:i] setHidden:YES];
                [[label_table objectAtIndex:i]setText:@""];
                [BotonSiguiente setEnabled:NO];
                [BotonSiguiente setHidden:YES];
                if (indice!=0) 
                {
                    [BotonAnterior setEnabled:YES];
                    [BotonAnterior setHidden:NO];
                }
                else
                {
                    NSLog(@"Estoy en la primera página!");
                }
            }
        }  
    }

    
}


-(IBAction)volverAlbum:(id)sender
{
    num_pag_view=0;
    
    [BotonAnterior setHidden:YES];
    [BotonAnterior setEnabled:NO];
    [BotonSiguiente setHidden:YES];
    [BotonSiguiente setEnabled:NO];
	[self.view removeFromSuperview];
}

-(IBAction)pulsarPagSiguiente:(id)sender
{
    num_pag_view +=1;

    [self reloadRenderPics];
                       
    [BotonAnterior setEnabled:YES];
    [BotonAnterior setHidden:NO];

}

-(IBAction)pulsarPagAnterior:(id)sender
{
    [BotonSiguiente setEnabled:YES];
    [BotonSiguiente setHidden:NO];
                       
    if (num_pag_view>0) {
        num_pag_view -=1;    
    }
    if(num_pag_view==0)
    {
        [BotonAnterior setEnabled:NO];
        [BotonAnterior setHidden:YES];
    }
    [self reloadRenderPics];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Overriden to allow any orientation.
    return NO;
}
# pragma mark -
# pragma mark Memory Management

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}


- (void)viewDidUnload {
        
    self.activity=nil;
    
    self.Thumbnail1=nil;
    self.Thumbnail2=nil;
    self.Thumbnail3=nil;
    self.Thumbnail4=nil;
    self.Thumbnail5=nil;
    self.Thumbnail6=nil;
    self.Thumbnail7=nil;
    self.Thumbnail8=nil;
    self.Thumbnail9=nil;
    self.Thumbnail10=nil;
    self.Thumbnail11=nil;
    self.Thumbnail12=nil;
    self.Thumbnail13=nil;
    self.Thumbnail14=nil;
    self.Thumbnail15=nil;
    
    self.Label1=nil;
    self.Label2=nil;
    self.Label3=nil;
    self.Label4=nil;
    self.Label5=nil;
    self.Label6=nil;
    self.Label7=nil;
    self.Label8=nil;
    self.Label9=nil;
    self.Label10=nil;
    self.Label11=nil;
    self.Label12=nil;
    self.Label13=nil;
    self.Label14=nil;
    self.Label15=nil;
    
    self.BotonAnterior=nil;
    self.BotonSiguiente=nil;
    self.VisorFotosVista=nil;
    
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    
    [assets release];
    [library release];
    
    [objects release];
    [objectsCogidos release];
    //[request release];
    
    [activity release];
    
    [thumbnail_table release];
    [label_table release];
    
    [BotonSiguiente release];
    [BotonAnterior release];
    [VisorFotosVista release];

    [super dealloc];
}


@end
