    //
//  seleccionAlbum.m
//  COMUNICADOR
//
//  Created by Elisabeth Esandia Melero on 29/03/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "seleccionAlbum.h"
#import "cargarFotos.h"
#import "seleccionEntidadPictos.h"
#import "Ajustes.h"

@implementation seleccionAlbum

@synthesize cargarFotosVista;
@synthesize EntidadPictosVista;
@synthesize ControladorAjustes;

@synthesize pulsacionTimer;

@synthesize butPredeterminado;
@synthesize butVolver;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
		    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    ControladorAjustes =[[Ajustes alloc]init];
    cargarFotosVista=[[cargarFotos alloc] initWithNibName:@"cargarFotos" bundle:Nil];
    EntidadPictosVista=[[seleccionEntidadPictos alloc] initWithNibName:@"seleccionEntidadPictos" bundle:Nil]; //Eli


    [self Ajustar];
    
    if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
    {
        [butVolver setTitle:@"INICIO" forState:normal];
    }
    else //IDIOMA INGLÉS
    {
        [butVolver setTitle:@"HOME" forState:normal];
    }

	//cargarFotosVista=[[cargarFotos alloc] initWithNibName:@"cargarFotos" bundle:[NSBundle mainBundle]]; //Eli
	//EntidadPictosVista=[[seleccionEntidadPictos alloc] initWithNibName:@"seleccionEntidadPictos" bundle:[NSBundle mainBundle]]; //Eli
    //EditarAlbumFavoritoVista=[[EditarAlbumFavorito alloc] initWithNibName:@"EditarAlbumFavorito" bundle:[NSBundle mainBundle]];

    [super viewDidLoad];
}

- (void)Ajustar
{
    [ControladorAjustes viewDidLoad];
    ajuste_resp_negativa=ControladorAjustes.resp_negativa;
    ajuste_tiempo_pulsacion=ControladorAjustes.tiempo_pulsacion;
    ajuste_tipo_letra=ControladorAjustes.tipo_letra;
    
    NSLog(@"respuesta negativa %i, tiempo pulsacion %i, tipo letra %i",ajuste_resp_negativa,ajuste_tiempo_pulsacion,ajuste_tipo_letra);
}

-(IBAction)touchDown:(id)sender
{
	self.pulsacionTimer = [NSTimer scheduledTimerWithTimeInterval:ajuste_tiempo_pulsacion target:self selector:@selector(showVista) userInfo:sender repeats:NO];
}

-(IBAction)touchUp:(id)sender
{
	[pulsacionTimer invalidate];
}

-(void)showVista
{
    switch([pulsacionTimer.userInfo  tag]){
            
            /*
             Caso 0: Fotos & pizarra
             Caso 1: Pictos
             Caso 2: Album Favorito
             */
            
		case 0:
            [cargarFotosVista viewDidLoad];
            [cargarFotosVista cargarDatosEnArray:0];
            [self.view addSubview:cargarFotosVista.view];
            NSLog(@"Estoy cambiando la vista");
			break;
            
		case 1:
            [EntidadPictosVista onVerPersonalizado:NO];    
            [EntidadPictosVista viewDidLoad];
            [self.view addSubview:EntidadPictosVista.view]; 
            break;
        case 2:
            [EntidadPictosVista onVerPersonalizado:YES];
            [EntidadPictosVista viewDidLoad];
            [self.view addSubview:EntidadPictosVista.view];
            break;
        default:
			break;
	}
}

-(IBAction)volverPpal:(id)sender
{
	[self.view removeFromSuperview];	
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Overriden to allow any orientation.
    return YES;
}

# pragma mark -
# pragma mark Memory Management

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}


- (void)viewDidUnload {
    self.cargarFotosVista=nil;
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [cargarFotosVista release];
    [EntidadPictosVista release];
    [super dealloc];
}


@end
