//
//  seleccionEntidadPictos.m
//  COMUNICADOR
//
//  Created by Elisabeth Esandia Melero on 26/05/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "seleccionEntidadPictos.h"
#import "cargarFotos.h"
#import "Ajustes.h"

@implementation seleccionEntidadPictos;

@synthesize label_lugar;
@synthesize label_sublugar;
@synthesize label_personas;
@synthesize label_verbos;
@synthesize label_complementos;

@synthesize tipo_entidad;
@synthesize cargarFotosVista;
@synthesize VerPersonalizado;
@synthesize ControladorAjustes;

@synthesize pulsacionTimer;
@synthesize butVolver;


/*
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}
 */

- (void)dealloc
{
    [cargarFotosVista release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    ControladorAjustes =[[Ajustes alloc]init];
    cargarFotosVista=[[cargarFotos alloc] initWithNibName:@"cargarFotos" bundle:[NSBundle mainBundle]]; //Eli

    if (ONPersonalizado) 
    {
        [tipo_entidad setHidden:NO];
    }
    else
    {
        [tipo_entidad setHidden:YES];
        
    }
    
    [self Ajustar];
    
    if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
    {
        [butVolver setTitle:@"VOLVER" forState:normal];
        label_lugar.text=@"LUGARES";
        label_sublugar.text=@"SUBLUGARES";
        label_personas.text=@"PERSONAS";
        label_verbos.text=@"VERBOS";
        label_complementos.text=@"COMPLEMENTOS";
        tipo_entidad.text=@"ENTIDADES PERSONALIZADAS";
    }
    else //IDIOMA INGLÉS
    {
        [butVolver setTitle:@"BACK" forState:normal];
        label_lugar.text=@"PLACES";
        label_sublugar.text=@"SUB-PLACES";
        label_personas.text=@"PERSONS";
        label_verbos.text=@"VERBS";
        label_complementos.text=@"COMPLEMENTS";
        tipo_entidad.text=@"PERSONALIZED ENTITIES";

    }
    
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

-(void)onVerPersonalizado:(BOOL)verPersonalizado
{
    ONPersonalizado=verPersonalizado;
}

- (void)Ajustar
{
    [ControladorAjustes viewDidLoad];
    ajuste_resp_negativa=ControladorAjustes.resp_negativa;
    ajuste_tiempo_pulsacion=ControladorAjustes.tiempo_pulsacion;
    ajuste_tipo_letra=ControladorAjustes.tipo_letra;
    
    NSLog(@"respuesta negativa %i, tiempo pulsacion %i, tipo letra %i",ajuste_resp_negativa,ajuste_tiempo_pulsacion,ajuste_tipo_letra);
}

-(IBAction)touchDown:(id)sender
{
	self.pulsacionTimer = [NSTimer scheduledTimerWithTimeInterval:ajuste_tiempo_pulsacion target:self selector:@selector(showVista) userInfo:sender repeats:NO];
}

-(IBAction)touchUp:(id)sender
{
	[pulsacionTimer invalidate];
}

-(void)showVista
{
    [cargarFotosVista viewDidLoad];
    if (ONPersonalizado) 
    {
        [cargarFotosVista onVerPersonalizado:YES];
    }
    else
    {
        [cargarFotosVista onVerPersonalizado:NO];
        
    }
    NSInteger ButtonTagInteger= [pulsacionTimer.userInfo tag];
    NSLog(@"Entidad seleccionada = %i onverpersonalizado %i",ButtonTagInteger, ONPersonalizado);
    

    [cargarFotosVista cargarDatosEnArray:ButtonTagInteger];
    [self.view addSubview:cargarFotosVista.view];
}

-(IBAction)volverAlbum:(id)sender
{
    [self.view removeFromSuperview];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return NO;
}

@end
