//
//  COMUNICADORViewController.h
//  COMUNICADOR
//
//  Created by JOSE CRUZ PEREZ PI on 09/06/10.
//  Copyright 2010 UNIVERSIDAD PUBLICA DE NAVARRA. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>
#import <CoreData/CoreData.h>

@class Pizarra;
@class Reloj;
@class Ajustes;
@class Personalizacion;

@class seleccionAlbum;
@class controlAgenda;


@interface COMUNICADORViewController : UIViewController 
{ 
	
	//PANTALLA INICIAL	
	IBOutlet UIView *VISTA_PRIMERA;
	NSTimer *pulsacionTimer;
	
	//-------------------------------------AGENDA------------------------------------------------
    
    controlAgenda *controladorAgenda; //Instancia de la clase "control Agenda"
    
	//-------------------------------------ALBUM-------------------------------------------------
	
	
	seleccionAlbum *controladorAlbum; //Instancia de la clase "seleccion Album"	
    
	//------------------------------------PIZARRA------------------------------------------------

    Pizarra *controladorPizarra;

	//------------------------------------RELOJ------------------------------------------------
    
    Reloj *controladorReloj;
    
    //------------------------------------AJUSTES-----------------------------------------------
    
    Ajustes *controladorAjustes;
    
    //------------------------------------PERSONALIZACION----------------------------------------
    
    Personalizacion *controladorPersonalizacion;
	//-----------------------------------------------------------------------------------------
	//---------------------------------COMUNICADOR---------------------------------------------
	//-----------------------------------------------------------------------------------------
	
	IBOutlet UIView *VISTA_PRINCIPAL;
	
	//vistas base del comunicador contenidas en vista principal
	
	IBOutlet UIView *VISTA_MEDIO_BASE;
	IBOutlet UIView *VISTA_ABAJO_IZQUIERDA_BASE;
	IBOutlet UIView *VISTA_ABAJO_BORRAR_BASE;
	IBOutlet UIView *VISTA_ABAJO_BOTONES_BASE;
	IBOutlet UIView *VISTA_ARRIBA_BASE;
	IBOutlet UIView *VISTA_ARRIBA_BOTON_BASE;
    
    //AJUSTAR
    int ajuste_resp_negativa;
    int ajuste_tiempo_pulsacion;
    int ajuste_tipo_letra;
	
	
	//elementos que se superponen en la vista superior (Vista Arriba Base)
	
	IBOutlet UIView *VISTA_ARRIBA_BOTON;
	IBOutlet UIView *VISTA_ARRIBA;
	
	//elementos que se superponen en la vista inferior (Vista Abajo Base)
	
	IBOutlet UIView *VISTA_ABAJO_IZQUIERDA;
	IBOutlet UIView *VISTA_ABAJO_BORRAR;
	IBOutlet UIView *VISTA_ABAJO_BOTONES;
	IBOutlet UIView *VISTA_ABAJO_IZQUIERDA_NO_PREGUNTA;
	
	//AJUSTAR
    
    IBOutlet UIButton *inicio_boton_quiero_estoy;
    
    IBOutlet UIButton * BOTON_BORRAR;
    IBOutlet UIButton * ajuste_bot_inicio;
    IBOutlet UIButton * ajuste_bot_decirno;
    IBOutlet UIButton * ajuste_bot_final;
	
	//Botones izquierda y derecha correspondientes a Vista Abajo Botones
	
	IBOutlet id BOTON_PAGINA_DERECHA;
	IBOutlet id BOTON_PAGINA_IZQUIERDA;
	
    //elementos que se superponen a la vista del medio (Vista Medio Base)
	
	IBOutlet UIView *VISTA_MEDIO;
	IBOutlet UIView *VISTA_MEDIO_SUBLUGARES;
	IBOutlet UIView *VISTA_MEDIO_QUIERO_ESTOY;

	//Pantalla final donde sale la frase
	
	IBOutlet UIView *VISTA_SECUNDARIA;
	
	//Vista base y vista que muestra o no el boton que niega dentro de Vista Secundaria
	
	IBOutlet UIView *VISTA_BASE_BOTON_NO;

	IBOutlet UIView *VISTA_BOTON_NO;
		
	//Vista que muestra el no
	
	IBOutlet UIView *VISTA_NO;
	
	//Vista para salir de la vista secundaria
	
	IBOutlet id BOTON_SALIR;
	
	//Diseño Core Data
	
	UIButton *Imagen1;
	UIButton *Imagen2;
	UIButton *Imagen3;
	UIButton *Imagen4;
	UIButton *Imagen5;
	UIButton *Imagen6;
	UILabel *Label1;
	UILabel *Label2;
	UILabel *Label3;
	UILabel *Label4;
	UILabel *Label5;
	UILabel *Label6;

    
    UIButton *Boton_quiero;
	UIButton *Boton_estoy;
	UILabel *Label_quiero;
	UILabel *Label_estoy;
    
    UIButton *Imagen_lugar1;
	UIButton *Imagen_lugar2;
	UIButton *Imagen_lugar3;
	UIButton *Imagen_lugar4;
	UILabel *Label_lugar1;
	UILabel *Label_lugar2;
	UILabel *Label_lugar3;
	UILabel *Label_lugar4;

	
	//Predicados para sublugares
	
	NSString *entidad;
	NSString *entidad1;
    NSString *entidad_a_modificar;
	NSString *predicado_base;
	NSString *predicado_sublugar;
	NSString *predicado1;
	NSString *predicado2;
	NSString *predicado3;
	NSString *predicado4;
	NSString *predicado5;
	NSString *predicado6;

	//Imagenes de la frase
	
	UIImageView *Imagen_frase1;
	UIImageView *Imagen_frase2;
	UIImageView *Imagen_frase3;
	UILabel *Label_frase1;
	UILabel *Label_frase2;
	UILabel *Label_frase3;
	UIImageView *Imagen_frase_interrogante;
	
	//Imagenes de la Vista secundaria
	
	UIImageView *Imagen_secundaria1;
	UIImageView *Imagen_secundaria2;
	UIImageView *Imagen_secundaria3;
	UIImageView *Imagen_secundaria_interrogante;
	UILabel *Label_secundaria1;
	UILabel *Label_secundaria2;
	UILabel *Label_secundaria3;
	
	
	NSUInteger INDICE;
	int INDICE_PAGINAS;
	
	NSUInteger DERECHA;
	NSUInteger MENU;
	NSUInteger NEGAR;
	NSUInteger INTERROGANTE;
	NSUInteger QUIEROESTOY;
    NSUInteger QE;
	
	IBOutlet UIButton *BOTON_NEGAR;
	CALayer *negacion;
	CALayer *negacion_secundaria;
	
    //Strings para asignar el idioma a las imágenes del comunicador
    NSString *Etiqueta1;
    NSString *Etiqueta2;
    NSString *Etiqueta3;
    NSString *Etiqueta4;
    NSString *Etiqueta5;
    NSString *Etiqueta6;
    
    
    //En Idiomam irá el string correspondiente a la columna de la base de datos que quiero consultar
    NSString *Idioma;
    
    UIImage *btnImage1;	
    UIImage *btnImage2;	
    UIImage *btnImage3;	
    UIImage *btnImage4;	
    UIImage *btnImage5;	
    UIImage *btnImage6;	
    
    NSInteger CONTADOR_ANTERIOR;
    NSInteger FILA_A_CAMBIAR;
    
    NSInteger PK_1;
    NSInteger PK_2;
    NSInteger PK_3;
    NSInteger PK_4;
    NSInteger PK_5;
    NSInteger PK_6;
    
    NSInteger EsNuevo_1;
    NSInteger EsNuevo_2;
    NSInteger EsNuevo_3;
    NSInteger EsNuevo_4;
    NSInteger EsNuevo_5;
    NSInteger EsNuevo_6;
    
    NSInteger VALOR_ANTIGUO_CONTADOR_1;
    NSInteger VALOR_ANTIGUO_CONTADOR_2;
    NSInteger VALOR_ANTIGUO_CONTADOR_3;
    NSInteger VALOR_ANTIGUO_CONTADOR_4;
    NSInteger VALOR_ANTIGUO_CONTADOR_5;
    NSInteger VALOR_ANTIGUO_CONTADOR_6;
    
    NSInteger recorrido;

	}


@property (nonatomic, retain) NSTimer *pulsacionTimer;

@property (nonatomic, retain) IBOutlet UIButton *Imagen1;
@property (nonatomic, retain) IBOutlet UIButton *Imagen2;
@property (nonatomic, retain) IBOutlet UIButton *Imagen3;
@property (nonatomic, retain) IBOutlet UIButton *Imagen4;
@property (nonatomic, retain) IBOutlet UIButton *Imagen5;
@property (nonatomic, retain) IBOutlet UIButton *Imagen6;
@property (nonatomic, retain) IBOutlet UILabel *Label1;
@property (nonatomic, retain) IBOutlet UILabel *Label2;
@property (nonatomic, retain) IBOutlet UILabel *Label3;
@property (nonatomic, retain) IBOutlet UILabel *Label4;
@property (nonatomic, retain) IBOutlet UILabel *Label5;
@property (nonatomic, retain) IBOutlet UILabel *Label6;
@property (nonatomic, retain) IBOutlet UILabel *Label_quiero;
@property (nonatomic, retain) IBOutlet UILabel *Label_estoy;
@property (nonatomic, retain) IBOutlet UIButton *Boton_quiero;
@property (nonatomic, retain) IBOutlet UIButton *Boton_estoy;
@property (nonatomic, retain) IBOutlet UIButton *Imagen_lugar1;
@property (nonatomic, retain) IBOutlet UIButton *Imagen_lugar2;
@property (nonatomic, retain) IBOutlet UIButton *Imagen_lugar3;
@property (nonatomic, retain) IBOutlet UIButton *Imagen_lugar4;
@property (nonatomic, retain) IBOutlet UILabel *Label_lugar1;
@property (nonatomic, retain) IBOutlet UILabel *Label_lugar2;
@property (nonatomic, retain) IBOutlet UILabel *Label_lugar3;
@property (nonatomic, retain) IBOutlet UILabel *Label_lugar4;
@property (nonatomic, retain) IBOutlet UIImageView *Imagen_frase1;
@property (nonatomic, retain) IBOutlet UIImageView *Imagen_frase2;
@property (nonatomic, retain) IBOutlet UIImageView *Imagen_frase3;
@property (nonatomic, retain) IBOutlet UIImageView *Imagen_frase_interrogante;
@property (nonatomic, retain) IBOutlet UILabel *Label_frase1;
@property (nonatomic, retain) IBOutlet UILabel *Label_frase2;
@property (nonatomic, retain) IBOutlet UILabel *Label_frase3;
@property (nonatomic, retain) IBOutlet UIImageView *Imagen_secundaria1;
@property (nonatomic, retain) IBOutlet UIImageView *Imagen_secundaria2;
@property (nonatomic, retain) IBOutlet UIImageView *Imagen_secundaria3;
@property (nonatomic, retain) IBOutlet UIImageView *Imagen_secundaria_interrogante;
@property (nonatomic, retain) IBOutlet UILabel *Label_secundaria1;
@property (nonatomic, retain) IBOutlet UILabel *Label_secundaria2;
@property (nonatomic, retain) IBOutlet UILabel *Label_secundaria3;

@property (nonatomic, retain) IBOutlet UIView *VISTA_BASE_BOTON_NO;
@property (nonatomic, retain) IBOutlet UIView *VISTA_BOTON_NO;

@property (nonatomic, retain) Pizarra *controladorPizarra;
@property (nonatomic, retain) Reloj *controladorReloj;
@property (nonatomic, retain) Ajustes *controladorAjustes;
@property (nonatomic, retain) Personalizacion *controladorPersonalizacion;
@property (nonatomic, retain) seleccionAlbum *controladorAlbum;
@property (nonatomic, retain) controlAgenda *controladorAgenda;

//Ajustes
@property (nonatomic, retain)IBOutlet UIButton *inicio_boton_quiero_estoy;

@property (nonatomic, retain)IBOutlet UIButton * BOTON_BORRAR;
@property (nonatomic, retain)IBOutlet UIButton * ajuste_bot_inicio;
@property (nonatomic, retain)IBOutlet UIButton * ajuste_bot_decirno;
@property (nonatomic, retain)IBOutlet UIButton * ajuste_bot_final;

- (IBAction) PULSAR_VOLVER_COMUNICADOR: (id) sender;

- (void)showVista;
- (IBAction)touchDown:(id)sender;
- (IBAction)touchUp:(id)sender;

//-------------------------------------COMUNICADOR---------------------------------------------


- (IBAction) PULSAR_BOTON_PAGINA_DERECHA: (id) sender;
- (IBAction) PULSAR_BOTON_PAGINA_IZQUIERDA: (id) sender;
- (IBAction) PULSAR_BOTON_BORRAR: (id) sender;
- (IBAction) PULSAR_BOTON_SALIR: (id) sender;

- (IBAction) PULSAR_BOTON_ARRIBA_OK: (id) sender;

- (IBAction) PULSAR_BOTON_AJUSTES: (id) sender;
- (IBAction) PULSAR_BOTON_NO: (id) sender;
- (IBAction) PULSAR_BOTON_SALIR_NO: (id) sender;
- (IBAction) PULSAR_BOTON_NEGAR: (id) sender;
- (IBAction) PULSAR_BOTON_INTERROGANTE: (id) sender;

- (void)Ajustar;

- (void) BusquedaLugares:(NSString *)entidad_busqueda;
- (void) BusquedaYSituacion:(NSString *) entidad_busqueda Predicado:(NSString*)predicado_busqueda;
- (void) BusquedaYSituacionFrase:(NSString *)entidad_busqueda Predicado:(NSString*)predicado_busqueda;
- (void) BusquedaYSituacionBorrar:(NSString *)entidad_busqueda Predicado:(NSString*)predicado_busqueda;
- (void) PonerLugares:(NSArray *)objects Objeto:(NSManagedObject *)matches Numero:(int)valor;
- (void) PonerImagenes:(NSArray *)objects Objeto:(NSManagedObject *)matches Numero:(int) valor;
- (void) IniciarImagenes;
- (void) DeshabilitarImagenesYEtiquetas;
- (void) HabilitarImagenes;
- (void) HabilitarEtiquetas;
- (void) BusquedaBotonesPaginas;
- (void) ModificarContadores: (int) fila_a_cambiar ValorAnterior: (int) valor_contador_anterior Entidad: (NSString *) entidad_modificar;

/*
 Para poner a cero los contadores en SQLite, hay que poner esto:
 
 UPDATE ZPERSONAS SET Z_OPT=1
 
 */


	
@end
