//
//  COMUNICADORViewController.m
//  COMUNICADOR
//
//  Created by JOSE CRUZ PEREZ PI on 09/06/10.
//  Copyright 2010 UNIVERSIDAD PUBLICA DE NAVARRA. All rights reserved.
//

#import "COMUNICADORAppDelegate.h"
#import "COMUNICADORViewController.h"
#import <QuartzCore/QuartzCore.h>
#import <AudioToolbox/AudioServices.h>
#import "Pizarra.h"
#import "Reloj.h"
#import "Ajustes.h"
#import "Personalizacion.h"
#import "seleccionAlbum.h"
#import "controlAgenda.h"

@implementation COMUNICADORViewController

@synthesize inicio_boton_quiero_estoy;

@synthesize BOTON_BORRAR;
@synthesize ajuste_bot_inicio;
@synthesize ajuste_bot_decirno;
@synthesize ajuste_bot_final;

@synthesize controladorAlbum;
@synthesize controladorAgenda;
@synthesize controladorPizarra;
@synthesize controladorReloj;
@synthesize controladorAjustes;
@synthesize controladorPersonalizacion;

@synthesize pulsacionTimer;
@synthesize VISTA_BASE_BOTON_NO, VISTA_BOTON_NO;
@synthesize Imagen_lugar1, Imagen_lugar2, Imagen_lugar3, Imagen_lugar4, Label_lugar1, Label_lugar2, Label_lugar3, Label_lugar4, Boton_estoy, Boton_quiero, Label_estoy, Label_quiero;

@synthesize Imagen1, Imagen2, Imagen3, Imagen4, Imagen5, Imagen6, Label1, Label2, Label3, Label4, Label5, Label6;
@synthesize Imagen_frase1, Imagen_frase2, Imagen_frase3, Imagen_frase_interrogante;
@synthesize Label_frase1, Label_frase2, Label_frase3;
@synthesize Imagen_secundaria1, Imagen_secundaria2, Imagen_secundaria3, Imagen_secundaria_interrogante;
@synthesize Label_secundaria1, Label_secundaria2, Label_secundaria3;



//Inicializo el picker, la etiqueta label y el arrayDatos

- (void)viewDidLoad {
	
    QUIEROESTOY=0;
    QE=0;
    
    [self Ajustar];
   
    controladorAlbum=[[seleccionAlbum alloc] initWithNibName:@"seleccionAlbum" bundle:nil]; //Eli. Iniciamos el archivo xib de la siguiente pantalla.
    controladorAgenda=[[controlAgenda alloc] initWithNibName:@"controlAgenda" bundle:nil]; //Eli. Iniciamos el archivo xib de la siguiente pantalla.
    
    //controladorAjustes.pulsacion=NO;
    controladorPizarra=[[Pizarra alloc] initWithNibName:@"Pizarra" bundle:nil];
    controladorReloj=[[Reloj alloc] initWithNibName:@"Reloj" bundle:nil];
    controladorAjustes=[[Ajustes alloc] initWithNibName:@"Ajustes" bundle:nil];
    controladorPersonalizacion=[[Personalizacion alloc] initWithNibName:@"Personalizacion" bundle:nil];
    //controladorAjustes.tipo_letra=20;
    if (controladorAjustes.tipo_letra<40)
    {
        NSLog(@"imagen_castellano");
        [inicio_boton_quiero_estoy setImage:[UIImage imageNamed:[NSString stringWithFormat:@"inicio_quiero_estoy.png"]]forState:UIControlStateNormal];
        [BOTON_BORRAR setTitle:@"BORRAR" forState:normal];
        [ajuste_bot_decirno setTitle:@"DECIR NO" forState:normal];
        [ajuste_bot_inicio setTitle:@"INICIO" forState:normal];
        [ajuste_bot_final setTitle:@"INICIO" forState:normal];
    }
    else
    {        NSLog(@"imagen_ing");

        [inicio_boton_quiero_estoy setImage:[UIImage imageNamed:[NSString stringWithFormat:@"inicio_want_am.png"]]forState:UIControlStateNormal];
        [BOTON_BORRAR setTitle:@"DELETE" forState:normal];
        [ajuste_bot_decirno setTitle:@"SAY NO" forState:normal];
        [ajuste_bot_inicio setTitle:@"HOME" forState:normal];
        [ajuste_bot_final setTitle:@"HOME" forState:normal];
    }
    [super viewDidLoad];
}

- (void)Ajustar
{
    [controladorAjustes viewDidLoad];
    
    ajuste_resp_negativa=controladorAjustes.resp_negativa;
    ajuste_tiempo_pulsacion=controladorAjustes.tiempo_pulsacion;
    ajuste_tipo_letra=controladorAjustes.tipo_letra;
    
    
    controladorAjustes.resp_negativa=ajuste_resp_negativa;
    controladorAjustes.tipo_letra=ajuste_tipo_letra;
    controladorAjustes.tiempo_pulsacion=ajuste_tiempo_pulsacion;
    
    
    NSLog(@"respuesta negativa %i, tiempo pulsacion %i, tipo letra %i",ajuste_resp_negativa,ajuste_tiempo_pulsacion,ajuste_tipo_letra);
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	if((interfaceOrientation==UIInterfaceOrientationLandscapeLeft)||(interfaceOrientation==UIInterfaceOrientationLandscapeRight))
		return YES;
	return NO;
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}



//Configuración pulsación pantalla inicial

-(IBAction)touchDown:(id)sender{
	self.pulsacionTimer = [NSTimer scheduledTimerWithTimeInterval:controladorAjustes.tiempo_pulsacion target:self selector:@selector(showVista) userInfo:sender repeats:NO];
}

-(IBAction)touchUp:(id)sender{
	[pulsacionTimer invalidate];
}

-(void)showVista{
	
    [self Ajustar];
    
	switch([pulsacionTimer.userInfo  tag]){
            
            /*
             Caso 0: Comunicador
             Caso 1: Reloj
             Caso 2: 
             Caso 3: QuieroEstoy
             Caso 4: Pizarra
             Caso 5: Álbum
             */
            
            if (controladorAjustes.tipo_letra<40)
            {
                [BOTON_BORRAR setTitle:@"BORRAR" forState:normal];
                [ajuste_bot_decirno setTitle:@"DECIR NO" forState:normal];
                [ajuste_bot_inicio setTitle:@"INICIO" forState:normal];
                [ajuste_bot_final setTitle:@"INICIO" forState:normal];
                
            }
            else
            {
                [BOTON_BORRAR setTitle:@"DELETE" forState:normal];
                [ajuste_bot_decirno setTitle:@"SAY NO" forState:normal];
                [ajuste_bot_inicio setTitle:@"HOME" forState:normal];
                [ajuste_bot_final setTitle:@"HOME" forState:normal];
                
                
            }
            
            
		case 0:
			
            if (controladorAjustes.tipo_letra<40)
            {
                [BOTON_BORRAR setTitle:@"BORRAR" forState:normal];
                [ajuste_bot_decirno setTitle:@"DECIR NO" forState:normal];
                [ajuste_bot_inicio setTitle:@"INICIO" forState:normal];
                [ajuste_bot_final setTitle:@"INICIO" forState:normal];
                
            }
            else
            {
                [BOTON_BORRAR setTitle:@"DELETE" forState:normal];
                [ajuste_bot_decirno setTitle:@"SAY NO" forState:normal];
                [ajuste_bot_inicio setTitle:@"HOME" forState:normal];
                [ajuste_bot_final setTitle:@"HOME" forState:normal];
                
                
            }
            
			[self.view addSubview:VISTA_PRINCIPAL];
			[VISTA_PRINCIPAL addSubview:VISTA_ABAJO_IZQUIERDA_BASE];
			[VISTA_PRINCIPAL addSubview:VISTA_MEDIO_BASE];
			[VISTA_PRINCIPAL addSubview:VISTA_ABAJO_BORRAR_BASE];
			[VISTA_PRINCIPAL addSubview:VISTA_ABAJO_BOTONES_BASE];
			[VISTA_PRINCIPAL addSubview:VISTA_ARRIBA_BASE];
			[VISTA_PRINCIPAL addSubview:VISTA_ARRIBA_BOTON_BASE];
			
			[VISTA_ARRIBA_BASE addSubview:VISTA_ARRIBA];
			
			[VISTA_MEDIO_BASE addSubview:VISTA_MEDIO];
			
			[BOTON_PAGINA_IZQUIERDA removeFromSuperview];
			
			[VISTA_ABAJO_IZQUIERDA_BASE addSubview:VISTA_ABAJO_IZQUIERDA];
			
			[VISTA_SECUNDARIA addSubview:VISTA_BASE_BOTON_NO];
			Label_frase1.hidden=YES;
            Label_frase2.hidden=YES;
            Label_frase3.hidden=YES;
            
			[self HabilitarImagenes];
            [self HabilitarEtiquetas];
			[self BusquedaLugares:@"Lugar"];
			
			INDICE=0;
			DERECHA=0;
			MENU=0;
			NEGAR=0;
			INTERROGANTE=0;
			QUIEROESTOY=0;
			INDICE_PAGINAS=6;
            CONTADOR_ANTERIOR=0;
            FILA_A_CAMBIAR=5;
			
			break;
            
		case 1:
            [controladorReloj viewDidLoad];
			[self.view addSubview:controladorReloj.view];
            
            break;
        
        case 2:
            [self.view addSubview:controladorAgenda.view];//añadimos la vista del controlador de la agenda. Eli
			
			NSLog(@"Estoy pulsando la agenda");
            break;
            
        case 3:
			
            if (controladorAjustes.tipo_letra<40)
            {
                [BOTON_BORRAR setTitle:@"BORRAR" forState:normal];
                [ajuste_bot_decirno setTitle:@"DECIR NO" forState:normal];
                [ajuste_bot_inicio setTitle:@"INICIO" forState:normal];
                [ajuste_bot_final setTitle:@"INICIO" forState:normal];
                
            }
            else
            {
                [BOTON_BORRAR setTitle:@"DELETE" forState:normal];
                [ajuste_bot_decirno setTitle:@"SAY NO" forState:normal];
                [ajuste_bot_inicio setTitle:@"HOME" forState:normal];
                [ajuste_bot_final setTitle:@"HOME" forState:normal];
                
                
            }
            
			
			[self.view addSubview:VISTA_PRINCIPAL];
			[VISTA_PRINCIPAL addSubview:VISTA_ABAJO_IZQUIERDA_BASE];
			[VISTA_PRINCIPAL addSubview:VISTA_MEDIO_BASE];
			[VISTA_PRINCIPAL addSubview:VISTA_ABAJO_BORRAR_BASE];
			[VISTA_PRINCIPAL addSubview:VISTA_ABAJO_BOTONES_BASE];
			[VISTA_PRINCIPAL addSubview:VISTA_ARRIBA_BASE];
			[VISTA_PRINCIPAL addSubview:VISTA_ARRIBA_BOTON_BASE];
			
			[VISTA_ARRIBA_BASE addSubview:VISTA_ARRIBA];
			
			[VISTA_MEDIO_BASE addSubview:VISTA_MEDIO_QUIERO_ESTOY];
			
			[BOTON_PAGINA_IZQUIERDA removeFromSuperview];
			
			[VISTA_ABAJO_IZQUIERDA_BASE addSubview:VISTA_ABAJO_IZQUIERDA];
			
			[VISTA_SECUNDARIA addSubview:VISTA_BASE_BOTON_NO];
			
            QE=1;
			[self HabilitarImagenes];
            [self HabilitarEtiquetas];
            [self BusquedaLugares:@"Parte1"];
            Label_frase1.hidden=YES;
            Label_frase2.hidden=YES;
            Label_frase3.hidden=YES;
			
			
            
			INDICE=0;
			DERECHA=0;
			MENU=0;
			NEGAR=0;
			INTERROGANTE=0;
			QUIEROESTOY=0;
			INDICE_PAGINAS=6;
            CONTADOR_ANTERIOR=0;
            FILA_A_CAMBIAR=0;
			break;
			
		case 4:
            
			[VISTA_PRIMERA addSubview:controladorPizarra.view];
            
            break;
		case 5:
			//[VISTA_PRIMERA addSubview:VISTA_PRIMERA_ALBUM];
            [self.view addSubview:controladorAlbum.view];//añadimos la vista del controlador del álbum. Eli
			
			NSLog(@"Estoy pulsando el álbum");
			break;

            
            
             case 6:
             
             //[VISTA_PRIMERA addSubview:controladorPersonalizacion.view];
             
             
             break;
             
            /*
             Caso 11: Casa
             Caso 12: Colegio
             Caso 13: Ciudad
             Caso 14: Vacaciones
             Caso 15: Quiero
             Caso 16: Estoy
             */
            
		case 11:
				
				predicado_base=@"ANY SublugarLugar like '1' AND activo=1";
				predicado1=@"ANY FraseSublugar like '2' AND activo=1";
				predicado2=@"ANY FraseSublugar like '6' AND activo=1";
				predicado3=@"ANY FraseSublugar like '7' AND activo=1";
				predicado4=@"ANY FraseSublugar like '11' AND activo=1";
				predicado5=@"ANY FraseSublugar like '19' AND activo=1";
				predicado6=@"ANY FraseSublugar like '21' AND activo=1";
				INDICE=1;
				
                //Hago Busqueda de Sublugares de Lugar=1 (Casa). Funcion BusquedaYSituacion
            
                [self BusquedaYSituacion:@"Sublugar" Predicado:@"ANY SublugarLugar like '1' AND activo=1"];
            
            
			break;
			case 12:
			
				predicado_base=@"ANY SublugarLugar like '2' AND activo=1";
				predicado1=@"ANY FraseSublugar like '3' AND activo=1";
				predicado2=@"ANY FraseSublugar like '4' AND activo=1";
				predicado3=@"ANY FraseSublugar like '8' AND activo=1";
				predicado4=@"ANY FraseSublugar like '12' AND activo=1";
				predicado5=@"ANY FraseSublugar like '18' AND activo=1";
				predicado6=@"ANY FraseSublugar like '22' AND activo=1";
				INDICE=1;
                
                //Hago Busqueda de Sublugares de Lugar=2 (Colegio). Funcion BusquedaYSituacion
            
                [self BusquedaYSituacion:@"Sublugar" Predicado:@"ANY SublugarLugar like '2' AND activo=1"];
            
			break;
			
			case 13:
			
				predicado_base=@"ANY SublugarLugar like '3' AND activo=1";
				predicado1=@"ANY FraseSublugar like '1' AND activo=1";
				predicado2=@"ANY FraseSublugar like '9' AND activo=1";
				predicado3=@"ANY FraseSublugar like '13' AND activo=1";
				predicado4=@"ANY FraseSublugar like '14' AND activo=1";
				predicado5=@"ANY FraseSublugar like '15' AND activo=1";
				predicado6=@"ANY FraseSublugar like '16' AND activo=1";
				
				INDICE=1;
				
                //Hago Busqueda de Sublugares de Lugar=3 (Ciudad). Funcion BusquedaYSituacion
            
                [self BusquedaYSituacion:@"Sublugar" Predicado:@"ANY SublugarLugar like '3' AND activo=1"];
            
			break;
			
		case 14:
				
				predicado_base=@"ANY SublugarLugar like '4' AND activo=1";
				predicado1=@"ANY FraseSublugar like '5' AND activo=1";
				predicado2=@"ANY FraseSublugar like '10' AND activo=1";
				predicado3=@"ANY FraseSublugar like '16' AND activo=1";
				predicado4=@"ANY FraseSublugar like '17' AND activo=1";
				predicado5=@"ANY FraseSublugar like '20' AND activo=1";
				predicado6=@"ANY FraseSublugar like '23' AND activo=1";
				
				INDICE=1;
				
                //Hago Busqueda de Sublugares de Lugar=4 (Vacaciones). Funcion BusquedaYSituacion
            
                [self BusquedaYSituacion:@"Sublugar" Predicado:@"ANY SublugarLugar like '4' AND activo=1"];
            
            break;
			
		case 15:
			
            Label_frase1.hidden=NO;
            Imagen_frase1.image=btnImage1;
            NSLog(@"label_quiero.text %@",Label_quiero.text);
			//Imagen_frase1.image=[UIImage imageNamed:Label_quiero.text];
            Label_frase1.text=Label_quiero.text;
            
			
			predicado1=@"ANY Parte3Con2 like '1' AND activo=1";
			predicado2=@"ANY Parte3Con2 like '2' AND activo=1";
			predicado3=@"ANY Parte3Con2 like '3' AND activo=1";
			predicado4=@"ANY Parte3Con2 like '4' AND activo=1";
			predicado5=@"ANY Parte3Con2 like '5' AND activo=1";
			predicado6=@"ANY Parte3Con2 like '6' AND activo=1";
			
			
			DERECHA=0;
			QUIEROESTOY=1;

			[VISTA_ABAJO_IZQUIERDA_BASE addSubview:VISTA_ABAJO_IZQUIERDA_NO_PREGUNTA];
			
			
			[BOTON_PAGINA_IZQUIERDA removeFromSuperview];
			[BOTON_PAGINA_DERECHA removeFromSuperview];
			
            [self IniciarImagenes];
            
            entidad=@"Parte2";
			predicado_sublugar=@"ANY Parte2Con1 like '1' AND activo=1";
						
			INDICE=3;
			
            //Hago Busqueda de Sublugares de Lugar=5 (Quiero). Funcion BusquedaYSituacion
            
            [self BusquedaYSituacion:entidad Predicado:predicado_sublugar];

			break;

		case 16:
			
            Label_frase2.hidden=NO;

            Imagen_frase2.image=btnImage2;
            NSLog(@"label_estoy.text %@",Label_estoy.text);

            //Imagen_frase2.image=[UIImage imageNamed:Label_estoy.text];
            Label_frase2.text=Label_estoy.text;
            
			
			QUIEROESTOY=2;
			
			[VISTA_ABAJO_IZQUIERDA_BASE addSubview:VISTA_ABAJO_IZQUIERDA_NO_PREGUNTA];
			
			DERECHA=0;
			
			[BOTON_PAGINA_IZQUIERDA removeFromSuperview];
			[BOTON_PAGINA_DERECHA removeFromSuperview];
			
            [self IniciarImagenes];
           
            entidad=@"Parte2";
			predicado_sublugar=@"ANY Parte2Con1 like '2' AND activo=1";
			
			INDICE=4;
						
            //Hago Busqueda de Sublugares de Lugar=6 (Estoy). Funcion BusquedaYSituacion
            
            [self BusquedaYSituacion:entidad Predicado:predicado_sublugar];
            
			break;
			
            /*
             Caso 21: Primer botón Frase
             Caso 22: Segundo botón Frase
             Caso 23: Tercer botón Frase
             Caso 24: Cuarto botón Frase
             Caso 25: Quinto botón Frase
             Caso 26: Sexto botón Frase
             */
		case 21:
			
				DERECHA=0;
				[BOTON_PAGINA_IZQUIERDA removeFromSuperview];
				[BOTON_PAGINA_DERECHA removeFromSuperview];
                FILA_A_CAMBIAR=PK_1;
                CONTADOR_ANTERIOR=VALOR_ANTIGUO_CONTADOR_1;
				
                [self IniciarImagenes];
               
				if (INDICE==1){
					
					predicado_sublugar=predicado1;
					entidad=@"Personas";
					[VISTA_ABAJO_IZQUIERDA_BASE addSubview:VISTA_ABAJO_IZQUIERDA_NO_PREGUNTA];
					
					
				}
				else if (INDICE==2){
					
					entidad=@"Verbos";
                    Label_frase1.hidden=NO;
					Imagen_frase1.image=btnImage1;
                    Label_frase1.text=Label1.text;
                    
                    
                    [self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: @"Personas"];

                    /*
                    COMUNICADORAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
                    NSManagedObjectContext *context = [appDelegate managedObjectContext];
                    
                    NSEntityDescription *entityDesc = [NSEntityDescription entityForName:@"Personas" inManagedObjectContext:context];
                    NSFetchRequest *request = [[NSFetchRequest alloc] init];
                    
                    [request setEntity:entityDesc];
                    
                    NSError *error;
                    
                    NSArray *items=[context executeFetchRequest:request error:&error];
                    [request release];
                    
                    
                    NSManagedObject *micontador= [items objectAtIndex:(FILA_A_CAMBIAR-1)];
                    
                    [micontador setValue:[NSNumber numberWithInt: (VALOR_ANTIGUO_CONTADOR_1+1)] forKey:@"contador"];
                    
                    
                    if (![context save:&error]) {
                        NSLog(@"error de coredata %@, %@", error, [error userInfo]);
                        exit(-1);
                    }
                    
                    NSLog(@"LLego");
                    */
                    
					
				}
				else if (INDICE==3){
					
					entidad=@"Complementos";
                    entidad_a_modificar=@"Verbos";
                    Label_frase2.hidden=NO;
					Imagen_frase2.image=btnImage1;
					Label_frase2.text=Label1.text;
					if (QUIEROESTOY==1) {
                        entidad=@"Parte3";
						predicado_sublugar=predicado1;
					}
                    else{
                    [self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: entidad_a_modificar];
                    }
					
				}
				else if (INDICE==4){
					
                    entidad_a_modificar=@"Complementos";
                    if (QUIEROESTOY==1){
                        entidad_a_modificar=@"Parte3";
                    }
                    Label_frase3.hidden=NO;
					Imagen_frase3.image=btnImage1;
					Label_frase3.text=Label1.text;
					[VISTA_ARRIBA_BOTON_BASE addSubview:VISTA_ARRIBA_BOTON];
					[self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: entidad_a_modificar];
                    [self DeshabilitarImagenesYEtiquetas];					
				}
				
                [self BusquedaYSituacionFrase:entidad Predicado:predicado_sublugar];
            
                                				
			break;

		case 22:
			
				DERECHA=0;
				[BOTON_PAGINA_IZQUIERDA removeFromSuperview];
				[BOTON_PAGINA_DERECHA removeFromSuperview];
                FILA_A_CAMBIAR=PK_2;
                CONTADOR_ANTERIOR=VALOR_ANTIGUO_CONTADOR_2;
            
				
                [self IniciarImagenes];
               
				if (INDICE==1){
					
					predicado_sublugar=predicado2;
					entidad=@"Personas";
					[VISTA_ABAJO_IZQUIERDA_BASE addSubview:VISTA_ABAJO_IZQUIERDA_NO_PREGUNTA];
					
				}
				else if (INDICE==2){
					
					entidad=@"Verbos";
                    Label_frase1.hidden=NO;
                    Imagen_frase1.image=btnImage2;
					Label_frase1.text=Label2.text;
                    [self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: @"Personas"];
					
				}
				else if (INDICE==3){
					
					entidad=@"Complementos";
                    entidad_a_modificar=@"Verbos";
                    Label_frase2.hidden=NO;
					Imagen_frase2.image=btnImage2;
					Label_frase2.text=Label2.text;
					if (QUIEROESTOY==1) {
                        
                        entidad=@"Parte3";
						predicado_sublugar=predicado2;
					}
                    else{
                    [self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: entidad_a_modificar];
					}
				}
				else if (INDICE==4){
					
                    entidad_a_modificar=@"Complementos";
                    if (QUIEROESTOY==1){
                        entidad_a_modificar=@"Parte3";
                    }
                    Label_frase3.hidden=NO;
					Imagen_frase3.image=btnImage2;
					Label_frase3.text=Label2.text;
					[VISTA_ARRIBA_BOTON_BASE addSubview:VISTA_ARRIBA_BOTON];
					[self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: entidad_a_modificar];
                    [self DeshabilitarImagenesYEtiquetas];					
				}
				
                [self BusquedaYSituacionFrase:entidad Predicado:predicado_sublugar];

			break;
		case 23:
			
				DERECHA=0;
				[BOTON_PAGINA_IZQUIERDA removeFromSuperview];
				[BOTON_PAGINA_DERECHA removeFromSuperview];
                FILA_A_CAMBIAR=PK_3;
                CONTADOR_ANTERIOR=VALOR_ANTIGUO_CONTADOR_3;
            
				
                [self IniciarImagenes];
               
				if (INDICE==1){
					
					predicado_sublugar=predicado3;
					entidad=@"Personas";
					[VISTA_ABAJO_IZQUIERDA_BASE addSubview:VISTA_ABAJO_IZQUIERDA_NO_PREGUNTA];
					
				}
				else if (INDICE==2){
					
					entidad=@"Verbos";
                    Label_frase1.hidden=NO;
                    Imagen_frase1.image=btnImage3;
					Label_frase1.text=Label3.text;
                    [self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: @"Personas"];
					
				}
				else if (INDICE==3){
					
					entidad=@"Complementos";
                    entidad_a_modificar=@"Verbos";
                    Label_frase2.hidden=NO;
					Imagen_frase2.image=btnImage3;
					Label_frase2.text=Label3.text;
					if (QUIEROESTOY==1) {
                        
                        entidad=@"Parte3";
						predicado_sublugar=predicado3;
					}
                    else{
                    [self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: entidad_a_modificar];
					}
				}
				else if (INDICE==4){
					
                    entidad_a_modificar=@"Complementos";
                    if (QUIEROESTOY==1){
                        entidad_a_modificar=@"Parte3";
                    }
                    Label_frase3.hidden=NO;
					Imagen_frase3.image=btnImage3;
					Label_frase3.text=Label3.text;
					[VISTA_ARRIBA_BOTON_BASE addSubview:VISTA_ARRIBA_BOTON];
					[self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: entidad_a_modificar];
                    [self DeshabilitarImagenesYEtiquetas];
					
				}
				
                [self BusquedaYSituacionFrase:entidad Predicado:predicado_sublugar];

			break;
			
		case 24:
				DERECHA=0;
				[BOTON_PAGINA_IZQUIERDA removeFromSuperview];
				[BOTON_PAGINA_DERECHA removeFromSuperview];
                FILA_A_CAMBIAR=PK_4;
                CONTADOR_ANTERIOR=VALOR_ANTIGUO_CONTADOR_4;
            
				
                [self IniciarImagenes];
              
				if (INDICE==1){
					
					predicado_sublugar=predicado4;
					entidad=@"Personas";
					[VISTA_ABAJO_IZQUIERDA_BASE addSubview:VISTA_ABAJO_IZQUIERDA_NO_PREGUNTA];
					
				}
				else if (INDICE==2){
					
					entidad=@"Verbos";
                    Label_frase1.hidden=NO;
                    Imagen_frase1.image=btnImage4;
					Label_frase1.text=Label4.text;
                    [self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: @"Personas"];
					
				}
				else if (INDICE==3){
					
					entidad=@"Complementos";
                    entidad_a_modificar=@"Verbos";
                    Label_frase2.hidden=NO;
                    Imagen_frase2.image=btnImage4;
					Label_frase2.text=Label4.text;
					if (QUIEROESTOY==1) {
                        
                        entidad=@"Parte3";
						predicado_sublugar=predicado4;
					}
                    else{
                    [self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: entidad_a_modificar];
					}
				}
				else if (INDICE==4){
					
                    entidad_a_modificar=@"Complementos";
                    if (QUIEROESTOY==1){
                        entidad_a_modificar=@"Parte3";
                    }
                    Label_frase3.hidden=NO;
					Imagen_frase3.image=btnImage4;
					Label_frase3.text=Label4.text;
					[VISTA_ARRIBA_BOTON_BASE addSubview:VISTA_ARRIBA_BOTON];
					[self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: entidad_a_modificar];
                    [self DeshabilitarImagenesYEtiquetas];
					
				}
				
                [self BusquedaYSituacionFrase:entidad Predicado:predicado_sublugar];

			break;
		case 25:
			
				DERECHA=0;
				[BOTON_PAGINA_IZQUIERDA removeFromSuperview];
				[BOTON_PAGINA_DERECHA removeFromSuperview];
                FILA_A_CAMBIAR=PK_5;
                CONTADOR_ANTERIOR=VALOR_ANTIGUO_CONTADOR_5;
            
            
                [self IniciarImagenes];
               
				if (INDICE==1){
					
					predicado_sublugar=predicado5;
					entidad=@"Personas";
					[VISTA_ABAJO_IZQUIERDA_BASE addSubview:VISTA_ABAJO_IZQUIERDA_NO_PREGUNTA];
					
				}
				else if (INDICE==2){
					
					entidad=@"Verbos";
                    Label_frase1.hidden=NO;
                    Imagen_frase1.image=btnImage5;
					Label_frase1.text=Label5.text;
                    [self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: @"Personas"];
					
				}
				else if (INDICE==3){
					
					entidad=@"Complementos";
                    entidad_a_modificar=@"Verbos";
                    Label_frase2.hidden=NO;
					Imagen_frase2.image=btnImage5;
					Label_frase2.text=Label5.text;
					if (QUIEROESTOY==1) {
                        
                        entidad=@"Parte3";
						predicado_sublugar=predicado5;
					}
                    else{
                    [self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: entidad_a_modificar];
					}
				}
				else if (INDICE==4){
					
                    entidad_a_modificar=@"Complementos";
                    if (QUIEROESTOY==1){
                        entidad_a_modificar=@"Parte3";
                    }
                    Label_frase3.hidden=NO;
					Imagen_frase3.image=btnImage5;
					Label_frase3.text=Label5.text;
					[VISTA_ARRIBA_BOTON_BASE addSubview:VISTA_ARRIBA_BOTON];
					[self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: entidad_a_modificar];
                    [self DeshabilitarImagenesYEtiquetas];
					
				}
				
                [self BusquedaYSituacionFrase:entidad Predicado:predicado_sublugar];

                break;
		case 26:
			
				DERECHA=0;
				[BOTON_PAGINA_IZQUIERDA removeFromSuperview];
				[BOTON_PAGINA_DERECHA removeFromSuperview];
                FILA_A_CAMBIAR=PK_6;
                CONTADOR_ANTERIOR=VALOR_ANTIGUO_CONTADOR_6;
            
				
                [self IniciarImagenes];
               
				if (INDICE==1){
					
					predicado_sublugar=predicado6;
					entidad=@"Personas";
					[VISTA_ABAJO_IZQUIERDA_BASE addSubview:VISTA_ABAJO_IZQUIERDA_NO_PREGUNTA];
					
				}
				else if (INDICE==2){
					
					entidad=@"Verbos";
                    Label_frase1.hidden=NO;
					Imagen_frase1.image=btnImage6;
					Label_frase1.text=Label6.text;
                    [self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: @"Personas"];
					
				}
				else if (INDICE==3){
					
					entidad=@"Complementos";
                    entidad_a_modificar=@"Verbos";
                    Label_frase2.hidden=NO;
                    Imagen_frase2.image=btnImage6;
					Label_frase2.text=Label6.text;
					if (QUIEROESTOY==1) {
                        
                        entidad=@"Parte3";
						predicado_sublugar=predicado6;
					}
                    else{
                    [self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: entidad_a_modificar];
					}
				}
				else if (INDICE==4){
					
                    entidad_a_modificar=@"Complementos";
                    if (QUIEROESTOY==1){
                        entidad_a_modificar=@"Parte3";
                    }
                    Label_frase3.hidden=NO;
					Imagen_frase3.image=btnImage6;
					Label_frase3.text=Label6.text;
					[VISTA_ARRIBA_BOTON_BASE addSubview:VISTA_ARRIBA_BOTON];
					[self ModificarContadores: FILA_A_CAMBIAR ValorAnterior: CONTADOR_ANTERIOR Entidad: entidad_a_modificar];
                    [self DeshabilitarImagenesYEtiquetas];
					
				}
				
            [self BusquedaYSituacionFrase:entidad Predicado:predicado_sublugar];

            break;
			
		default:
			break;
	}
}




//-------------------------------------------------------------------------------------------------
//-------------------------------------------COMUNICADOR-------------------------------------------
//-------------------------------------------------------------------------------------------------


//Hacemos la búsqueda de los sublugares en función del lugar pulsado. Solo sirve para la primera búsqueda.
- (void) BusquedaLugares:(NSString *)entidad_busqueda {

    
    COMUNICADORAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    
    NSManagedObjectContext *context = [appDelegate managedObjectContext];
    
    NSEntityDescription *entityDesc = [NSEntityDescription entityForName:entidad_busqueda inManagedObjectContext:context];
    
    NSFetchRequest *request = [[[NSFetchRequest alloc] init]autorelease];
    
    [request setEntity:entityDesc];
    

    NSError *error;
    
    NSArray *objects = [context executeFetchRequest:request error:&error];
    
    NSManagedObject *matches = nil;

    [self PonerLugares:objects Objeto:matches Numero:0];    

}

- (void) BusquedaYSituacion:(NSString *)entidad_busqueda Predicado:(NSString*)predicado_busqueda{
    
    [VISTA_MEDIO removeFromSuperview];
    [VISTA_ABAJO_IZQUIERDA removeFromSuperview];
    [VISTA_ABAJO_BORRAR_BASE addSubview:VISTA_ABAJO_BORRAR];
    [VISTA_MEDIO_BASE addSubview:VISTA_MEDIO_SUBLUGARES];


    COMUNICADORAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    
    NSManagedObjectContext *context = [appDelegate managedObjectContext];
    
    
    NSEntityDescription *entityDesc = [NSEntityDescription entityForName:entidad_busqueda inManagedObjectContext:context];
    
    NSFetchRequest *request = [[NSFetchRequest alloc] init];
    
    [request setEntity:entityDesc];
    
    
    NSPredicate *pred = [NSPredicate predicateWithFormat:predicado_busqueda];
    
    
    [request setPredicate:pred];
    
    NSSortDescriptor *sortDescriptor = [[[NSSortDescriptor alloc] initWithKey:@"contador" ascending:NO]autorelease];
    
    [request setSortDescriptors:[NSArray arrayWithObject:sortDescriptor]];

    
    NSError *error;
    
    NSArray *objects = [context executeFetchRequest:request error:&error];
    
    NSManagedObject *matches = nil;
    
    [self PonerImagenes:objects Objeto:matches Numero:0];    
    
    [request release];

}


//Hacemos la búsqueda de los elementos de la frase en función del sublugar pulsado. Segunda búsqueda.

- (void) BusquedaYSituacionFrase:(NSString *)entidad_busqueda Predicado:(NSString*)predicado_busqueda{

    COMUNICADORAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    
    NSManagedObjectContext *context = [appDelegate managedObjectContext];
    
    NSEntityDescription *entityDesc = [NSEntityDescription entityForName:entidad_busqueda inManagedObjectContext:context];
    
    NSFetchRequest *request = [[NSFetchRequest alloc] init];
    
    [request setEntity:entityDesc];
    
    
    
    NSPredicate *pred = [NSPredicate predicateWithFormat:predicado_busqueda];
    
    NSError *error;
    
    [request setPredicate:pred];
    
    NSSortDescriptor *sortDescriptor = [[[NSSortDescriptor alloc] initWithKey:@"contador" ascending:NO]autorelease];
    
    [request setSortDescriptors:[NSArray arrayWithObject:sortDescriptor]];
    
    NSArray *objects = [context executeFetchRequest:request error:&error];
    
    NSManagedObject *matches = nil;
    
    [self PonerImagenes:objects Objeto:matches Numero:0];
    
    if ([objects count] > 6) {
            
            if (INDICE<4) {
                
                
                DERECHA=1;
                [VISTA_ABAJO_BOTONES_BASE addSubview:VISTA_ABAJO_BOTONES];
                [VISTA_ABAJO_BOTONES addSubview:BOTON_PAGINA_DERECHA];
                [BOTON_PAGINA_IZQUIERDA removeFromSuperview];
                            }
            
            else if (INDICE==4){
                DERECHA=1;
            }
        }
    
    
    INDICE=INDICE+1;
    INDICE_PAGINAS=6;
    [request release];
    NSLog(@"Hay %i elementos",[objects count]);


}

    

//Búsqueda hacia atrás, al pulsar Borrar. Parece igual que la anterior pero no inicializa DERECHA
- (void) BusquedaYSituacionBorrar:(NSString *)entidad_busqueda Predicado:(NSString*)predicado_busqueda{

    COMUNICADORAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    
    NSManagedObjectContext *context = [appDelegate managedObjectContext];
    
    NSEntityDescription *entityDesc = [NSEntityDescription entityForName:entidad_busqueda inManagedObjectContext:context];
    
    NSFetchRequest *request = [[NSFetchRequest alloc] init];
    
    [request setEntity:entityDesc];
    
    NSPredicate *pred = [NSPredicate predicateWithFormat:predicado_busqueda];
    
    
    [request setPredicate:pred];
    
    NSSortDescriptor *sortDescriptor = [[[NSSortDescriptor alloc] initWithKey:@"contador" ascending:NO]autorelease];
    
    [request setSortDescriptors:[NSArray arrayWithObject:sortDescriptor]];

    
    NSError *error;
    
    NSArray *objects = [context executeFetchRequest:request error:&error];
    
    NSManagedObject *matches = nil;
    
    [self PonerImagenes:objects Objeto:matches Numero:0];
    
           if ([objects count] > 6) {
            
            if (INDICE<4) {
                
                
                DERECHA=1;
                [VISTA_ABAJO_BOTONES_BASE addSubview:VISTA_ABAJO_BOTONES];
                [VISTA_ABAJO_BOTONES addSubview:BOTON_PAGINA_DERECHA];
                [BOTON_PAGINA_IZQUIERDA removeFromSuperview];
            }
        }
    
    [request release];


}


- (void) PonerLugares:(NSArray *)objects Objeto:(NSManagedObject *)matches Numero:(int)valor{

    Idioma=@"nombre";
    if (controladorAjustes.tipo_letra==20){
        Idioma=@"nombre";
    }
    else if (controladorAjustes.tipo_letra==30){
        Idioma=@"nombre_may";
    }
    else if (controladorAjustes.tipo_letra==50){
        Idioma=@"nombre_ing";
    }
    else if (controladorAjustes.tipo_letra==60){
        Idioma=@"nombre_may_ing";
    }
    
    if (QE==1) {
        
        if ([objects count] == 0) {
            
            //Label4.text = @"No hay coincidencias";
        } 
        
        else if ([objects count] == 2){
            
            matches = [objects objectAtIndex:valor];
            Etiqueta1=[matches valueForKey:@"nombre"];
            PK_1=[[matches valueForKey:@"pk"]intValue];
            VALOR_ANTIGUO_CONTADOR_1=[[matches valueForKey:@"contador"]intValue];
            Label_quiero.text=[matches valueForKey:Idioma];
            //UIImage *btnImage1;	
            btnImage1 = [UIImage imageNamed:Etiqueta1];
            [Boton_quiero setImage:btnImage1 forState:UIControlStateNormal];
            
            matches = [objects objectAtIndex:valor+1];
            Etiqueta2=[matches valueForKey:@"nombre"];
            PK_2=[[matches valueForKey:@"pk"]intValue];
            VALOR_ANTIGUO_CONTADOR_2=[[matches valueForKey:@"contador"]intValue];
            Label_estoy.text=[matches valueForKey:Idioma];
            //UIImage *btnImage2;	
            btnImage2 = [UIImage imageNamed:Etiqueta2];
            [Boton_estoy setImage:btnImage2 forState:UIControlStateNormal];
        
                                        }
                }
    else {
    
        if ([objects count] == 0) {
        
        //Label4.text = @"No hay coincidencias";
                                    } 
    
    else if ([objects count] == 4){
        
        matches = [objects objectAtIndex:valor];
        Etiqueta1=[matches valueForKey:@"nombre"];
        PK_1=[[matches valueForKey:@"pk"]intValue];
        VALOR_ANTIGUO_CONTADOR_1=[[matches valueForKey:@"contador"]intValue];
        Label_lugar1.text=[matches valueForKey:Idioma];
        //UIImage *btnImage1;	
        btnImage1 = [UIImage imageNamed:Etiqueta1];
        [Imagen_lugar1 setImage:btnImage1 forState:UIControlStateNormal];
        
        matches = [objects objectAtIndex:valor+1];
        Etiqueta2=[matches valueForKey:@"nombre"];
        PK_2=[[matches valueForKey:@"pk"]intValue];
        VALOR_ANTIGUO_CONTADOR_2=[[matches valueForKey:@"contador"]intValue];
        Label_lugar2.text=[matches valueForKey:Idioma];
        //UIImage *btnImage2;	
        btnImage2 = [UIImage imageNamed:Etiqueta2];
        [Imagen_lugar2 setImage:btnImage2 forState:UIControlStateNormal];
    
        matches = [objects objectAtIndex:valor+2];
        Etiqueta3=[matches valueForKey:@"nombre"];
        PK_3=[[matches valueForKey:@"pk"]intValue];
        VALOR_ANTIGUO_CONTADOR_3=[[matches valueForKey:@"contador"]intValue];
        Label_lugar3.text=[matches valueForKey:Idioma];
        //UIImage *btnImage3;	
        btnImage3 = [UIImage imageNamed:Etiqueta3];
        [Imagen_lugar3 setImage:btnImage3 forState:UIControlStateNormal];
    
        matches = [objects objectAtIndex:valor+3];
        Etiqueta4=[matches valueForKey:@"nombre"];
        PK_4=[[matches valueForKey:@"pk"]intValue];
        VALOR_ANTIGUO_CONTADOR_4=[[matches valueForKey:@"contador"]intValue];
        Label_lugar4.text=[matches valueForKey:Idioma];
        //UIImage *btnImage4;	
        btnImage4 = [UIImage imageNamed:Etiqueta4];
        [Imagen_lugar4 setImage:btnImage4 forState:UIControlStateNormal];
    
                            }
        }

}

//Después de una búsqueda, coloca las imágenes en su sitio comprobando si hay más de 6 o no
//Si hay menos, deshabilita el botón. La variable valor, la utilizo para los botones página izquierda
//y página derecha, para que haya un control de los elementos del array que vamos sacando en las diferentes pantallas.
- (void) PonerImagenes:(NSArray *)objects Objeto:(NSManagedObject *)matches Numero:(int)valor{
    
    Label1.hidden=NO;
    Label2.hidden=NO;
    Label3.hidden=NO;
    Label4.hidden=NO;
    Label5.hidden=NO;
    Label6.hidden=NO;
    
    if (controladorAjustes.tipo_letra==20){
        Idioma=@"nombre";
    }
    else if (controladorAjustes.tipo_letra==30){
        Idioma=@"nombre_may";
    }
    else if (controladorAjustes.tipo_letra==50){
        Idioma=@"nombre_ing";
    }
    else if (controladorAjustes.tipo_letra==60){
        Idioma=@"nombre_may_ing";
    }
    
    
    if ([objects count] == 0) {
        //Label4.text = @"No hay coincidencias";
    } 
    
    else if ([objects count] == (valor+1)){
        
        matches = [objects objectAtIndex:valor];
        Etiqueta1=[matches valueForKey:@"nombre"];
        PK_1=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_1=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_1=[[matches valueForKey:@"contador"]intValue];
        Label1.text=[matches valueForKey:Idioma];
        //UIImage *btnImage1;
        if (EsNuevo_1==1){
            btnImage1 = [controladorPersonalizacion loadImage:Etiqueta1];        }
        else{
            btnImage1 = [UIImage imageNamed:Etiqueta1];
            
        } 
        [Imagen1 setImage:btnImage1 forState:UIControlStateNormal];
        
        Imagen2.hidden=YES;
        Imagen2.enabled=NO;
        Label2.hidden=YES;
        [Imagen2 setImage:nil forState:UIControlStateNormal];
        Label2.text=nil;
        
        Imagen3.hidden=YES;
        Imagen3.enabled=NO;
        Label3.hidden=YES;
        [Imagen3 setImage:nil forState:UIControlStateNormal];
        Label3.text=nil;
        
        Imagen4.hidden=YES;
        Imagen4.enabled=NO;
        [Imagen4 setImage:nil forState:UIControlStateNormal];
        Label4.hidden=YES;
        Label4.text=nil;
        
        Imagen5.hidden=YES;
        Imagen5.enabled=NO;
        Label5.hidden=YES;
        [Imagen5 setImage:nil forState:UIControlStateNormal];
        Label5.text=nil;
        
        Imagen6.hidden=YES;
        Imagen6.enabled=NO;
        Label6.hidden=YES;
        [Imagen6 setImage:nil forState:UIControlStateNormal];
        Label6.text=nil;
        
    }
    else if ([objects count] == (valor+2)){
        
        matches = [objects objectAtIndex:valor];
        Etiqueta1=[matches valueForKey:@"nombre"];
        PK_1=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_1=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_1=[[matches valueForKey:@"contador"]intValue];
        Label1.text=[matches valueForKey:Idioma];
        //UIImage *btnImage1;	
        if (EsNuevo_1==1){
            btnImage1 = [controladorPersonalizacion loadImage:Etiqueta1];        }
        else{
            btnImage1 = [UIImage imageNamed:Etiqueta1];
            
        }  
        [Imagen1 setImage:btnImage1 forState:UIControlStateNormal];
        
        matches = [objects objectAtIndex:valor+1];
        Etiqueta2=[matches valueForKey:@"nombre"];
        PK_2=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_2=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_2=[[matches valueForKey:@"contador"]intValue];
        Label2.text=[matches valueForKey:Idioma];
        //UIImage *btnImage2;	
        if (EsNuevo_2==1){
            btnImage2 = [controladorPersonalizacion loadImage:Etiqueta2];
        }
        else{
            btnImage2 = [UIImage imageNamed:Etiqueta2];
            
        }
        [Imagen2 setImage:btnImage2 forState:UIControlStateNormal];
        
        Imagen3.hidden=YES;
        Imagen3.enabled=NO;
        Label3.hidden=YES;
        [Imagen3 setImage:nil forState:UIControlStateNormal];
        Label3.text=nil;
        
        Imagen4.hidden=YES;
        Imagen4.enabled=NO;
        Label4.hidden=YES;
        [Imagen4 setImage:nil forState:UIControlStateNormal];
        Label4.text=nil;
        
        Imagen5.hidden=YES;
        Imagen5.enabled=NO;
        Label5.hidden=YES;
        [Imagen5 setImage:nil forState:UIControlStateNormal];
        Label5.text=nil;
        
        Imagen6.hidden=YES;
        Imagen6.enabled=NO;
        Label6.hidden=YES;
        [Imagen6 setImage:nil forState:UIControlStateNormal];
        Label6.text=nil;
        
    }
    else if ([objects count] == (valor+3)){
        
        matches = [objects objectAtIndex:valor];
        Etiqueta1=[matches valueForKey:@"nombre"];
        PK_1=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_1=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_1=[[matches valueForKey:@"contador"]intValue];
        Label1.text=[matches valueForKey:Idioma];
        //UIImage *btnImage1;	
        if (EsNuevo_1==1){
            btnImage1 = [controladorPersonalizacion loadImage:Etiqueta1];        }
        else{
            btnImage1 = [UIImage imageNamed:Etiqueta1];
            
        } 
        [Imagen1 setImage:btnImage1 forState:UIControlStateNormal];
        
        matches = [objects objectAtIndex:valor+1];
        Etiqueta2=[matches valueForKey:@"nombre"];
        PK_2=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_2=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_2=[[matches valueForKey:@"contador"]intValue];
        Label2.text=[matches valueForKey:Idioma];
        //UIImage *btnImage2;	
        if (EsNuevo_2==1){
            btnImage2 = [controladorPersonalizacion loadImage:Etiqueta2];
        }
        else{
            btnImage2 = [UIImage imageNamed:Etiqueta2];
            
        }
        [Imagen2 setImage:btnImage2 forState:UIControlStateNormal];

        
        matches = [objects objectAtIndex:valor+2];
        Etiqueta3=[matches valueForKey:@"nombre"];
        PK_3=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_3=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_3=[[matches valueForKey:@"contador"]intValue];
        Label3.text=[matches valueForKey:Idioma];
        //UIImage *btnImage3;	
        if (EsNuevo_3==1){
            btnImage3 = [controladorPersonalizacion loadImage:Etiqueta3];
        }
        else{
            btnImage3 = [UIImage imageNamed:Etiqueta3];
            
        }
        [Imagen3 setImage:btnImage3 forState:UIControlStateNormal];


        Imagen4.hidden=YES;
        Imagen4.enabled=NO;
        Label4.hidden=YES;
        [Imagen4 setImage:nil forState:UIControlStateNormal];
        Label4.text=nil;
        
        Imagen5.hidden=YES;
        Imagen5.enabled=NO;
        Label5.hidden=YES;
        [Imagen5 setImage:nil forState:UIControlStateNormal];
        Label5.text=nil;
        
        Imagen6.hidden=YES;
        Imagen6.enabled=NO;
        Label6.hidden=YES;
        [Imagen6 setImage:nil forState:UIControlStateNormal];
        Label6.text=nil;
        
    }
    else if ([objects count] == (valor+4)){
        
        matches = [objects objectAtIndex:valor];
        Etiqueta1=[matches valueForKey:@"nombre"];
        PK_1=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_1=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_1=[[matches valueForKey:@"contador"]intValue];
        Label1.text=[matches valueForKey:Idioma];
        //UIImage *btnImage1;	
        if (EsNuevo_1==1){
            btnImage1 = [controladorPersonalizacion loadImage:Etiqueta1];        }
        else{
            btnImage1 = [UIImage imageNamed:Etiqueta1];
            
        } 
        [Imagen1 setImage:btnImage1 forState:UIControlStateNormal];
        
        matches = [objects objectAtIndex:valor+1];
        Etiqueta2=[matches valueForKey:@"nombre"];
        PK_2=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_2=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_2=[[matches valueForKey:@"contador"]intValue];
        Label2.text=[matches valueForKey:Idioma];
        //UIImage *btnImage2;	
        if (EsNuevo_2==1){
            btnImage2 = [controladorPersonalizacion loadImage:Etiqueta2];
        }
        else{
            btnImage2 = [UIImage imageNamed:Etiqueta2];
            
        }
        [Imagen2 setImage:btnImage2 forState:UIControlStateNormal];

        
        matches = [objects objectAtIndex:valor+2];
        Etiqueta3=[matches valueForKey:@"nombre"];
        PK_3=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_3=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_3=[[matches valueForKey:@"contador"]intValue];
        Label3.text=[matches valueForKey:Idioma];
        //UIImage *btnImage3;	
        if (EsNuevo_3==1){
            btnImage3 = [controladorPersonalizacion loadImage:Etiqueta3];
        }
        else{
            btnImage3 = [UIImage imageNamed:Etiqueta3];
            
        }
        [Imagen3 setImage:btnImage3 forState:UIControlStateNormal];

        
        matches = [objects objectAtIndex:valor+3];
        Etiqueta4=[matches valueForKey:@"nombre"];
        PK_4=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_4=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_4=[[matches valueForKey:@"contador"]intValue];
        Label4.text=[matches valueForKey:Idioma];
        //UIImage *btnImage4;	
        if (EsNuevo_4==1){
            btnImage4 = [controladorPersonalizacion loadImage:Etiqueta4];
        }
        else{
            btnImage4 = [UIImage imageNamed:Etiqueta4];
            
        }
        [Imagen4 setImage:btnImage4 forState:UIControlStateNormal];
        
        Imagen5.hidden=YES;
        Imagen5.enabled=NO;
        Label5.hidden=YES;
        [Imagen5 setImage:nil forState:UIControlStateNormal];
        Label5.text=nil;
        
        Imagen6.hidden=YES;
        Imagen6.enabled=NO;
        Label6.hidden=YES;
        [Imagen6 setImage:nil forState:UIControlStateNormal];
        Label6.text=nil;
        
    }
    else if ([objects count] == (valor+5)){
        
        matches = [objects objectAtIndex:valor];
        Etiqueta1=[matches valueForKey:@"nombre"];
        PK_1=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_1=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_1=[[matches valueForKey:@"contador"]intValue];
        Label1.text=[matches valueForKey:Idioma];
        //UIImage *btnImage1;	
        if (EsNuevo_1==1){
            btnImage1 = [controladorPersonalizacion loadImage:Etiqueta1];        }
        else{
            btnImage1 = [UIImage imageNamed:Etiqueta1];
            
        } 
        [Imagen1 setImage:btnImage1 forState:UIControlStateNormal];
        
        matches = [objects objectAtIndex:valor+1];
        Etiqueta2=[matches valueForKey:@"nombre"];
        PK_2=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_2=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_2=[[matches valueForKey:@"contador"]intValue];
        Label2.text=[matches valueForKey:Idioma];
        //UIImage *btnImage2;	
        if (EsNuevo_2==1){
            btnImage2 = [controladorPersonalizacion loadImage:Etiqueta2];
        }
        else{
            btnImage2 = [UIImage imageNamed:Etiqueta2];
            
        }
        [Imagen2 setImage:btnImage2 forState:UIControlStateNormal];

        
        matches = [objects objectAtIndex:valor+2];
        Etiqueta3=[matches valueForKey:@"nombre"];
        PK_3=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_3=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_3=[[matches valueForKey:@"contador"]intValue];
        Label3.text=[matches valueForKey:Idioma];
        //UIImage *btnImage3;	
        if (EsNuevo_3==1){
            btnImage3 = [controladorPersonalizacion loadImage:Etiqueta3];
        }
        else{
            btnImage3 = [UIImage imageNamed:Etiqueta3];
            
        }
        [Imagen3 setImage:btnImage3 forState:UIControlStateNormal];
        
        matches = [objects objectAtIndex:valor+3];
        Etiqueta4=[matches valueForKey:@"nombre"];
        PK_4=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_4=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_4=[[matches valueForKey:@"contador"]intValue];
        Label4.text=[matches valueForKey:Idioma];
        //UIImage *btnImage4;	
        if (EsNuevo_4==1){
            btnImage4 = [controladorPersonalizacion loadImage:Etiqueta4];
        }
        else{
            btnImage4 = [UIImage imageNamed:Etiqueta4];
            
        }
        [Imagen4 setImage:btnImage4 forState:UIControlStateNormal];
        
        matches = [objects objectAtIndex:valor+4];
        Etiqueta5=[matches valueForKey:@"nombre"];
        PK_5=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_5=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_5=[[matches valueForKey:@"contador"]intValue];
        Label5.text=[matches valueForKey:Idioma];
        //UIImage *btnImage5;	
        if (EsNuevo_5==1){
            btnImage5 = [controladorPersonalizacion loadImage:Etiqueta5];
        }
        else{
            btnImage5 = [UIImage imageNamed:Etiqueta5];
            
        }
        [Imagen5 setImage:btnImage5 forState:UIControlStateNormal];
        
        Imagen6.hidden=YES;
        Imagen6.enabled=NO;
        Label6.hidden=YES;
        [Imagen6 setImage:nil forState:UIControlStateNormal];
        Label6.text=nil;
    }
    else if ([objects count] >= (valor+6)){
        
        matches = [objects objectAtIndex:valor];
        Etiqueta1=[matches valueForKey:@"nombre"];
        PK_1=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_1=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_1=[[matches valueForKey:@"contador"]intValue];
        Label1.text=[matches valueForKey:Idioma];
        //UIImage *btnImage1;	
        if (EsNuevo_1==1){
            btnImage1 = [controladorPersonalizacion loadImage:Etiqueta1];        }
        else{
            btnImage1 = [UIImage imageNamed:Etiqueta1];
            
        }        
        [Imagen1 setImage:btnImage1 forState:UIControlStateNormal];
        
        matches = [objects objectAtIndex:valor+1];
        Etiqueta2=[matches valueForKey:@"nombre"];
        PK_2=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_2=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_2=[[matches valueForKey:@"contador"]intValue];
        Label2.text=[matches valueForKey:Idioma];
        //UIImage *btnImage2;	
        if (EsNuevo_2==1){
            btnImage2 = [controladorPersonalizacion loadImage:Etiqueta2];
        }
        else{
            btnImage2 = [UIImage imageNamed:Etiqueta2];
            
        }
        [Imagen2 setImage:btnImage2 forState:UIControlStateNormal];
        
        matches = [objects objectAtIndex:valor+2];
        Etiqueta3=[matches valueForKey:@"nombre"];
        PK_3=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_3=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_3=[[matches valueForKey:@"contador"]intValue];
        Label3.text=[matches valueForKey:Idioma];
        //UIImage *btnImage3;	
        if (EsNuevo_3==1){
            btnImage3 = [controladorPersonalizacion loadImage:Etiqueta3];
        }
        else{
        btnImage3 = [UIImage imageNamed:Etiqueta3];
        
        }
        [Imagen3 setImage:btnImage3 forState:UIControlStateNormal];
        
        matches = [objects objectAtIndex:valor+3];
        Etiqueta4=[matches valueForKey:@"nombre"];
        PK_4=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_4=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_4=[[matches valueForKey:@"contador"]intValue];
        Label4.text=[matches valueForKey:Idioma];
        //UIImage *btnImage4;	
        if (EsNuevo_4==1){
            btnImage4 = [controladorPersonalizacion loadImage:Etiqueta4];
        }
        else{
        btnImage4 = [UIImage imageNamed:Etiqueta4];
        
        }
        [Imagen4 setImage:btnImage4 forState:UIControlStateNormal];
        
        matches = [objects objectAtIndex:valor+4];
        Etiqueta5=[matches valueForKey:@"nombre"];
        PK_5=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_5=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_5=[[matches valueForKey:@"contador"]intValue];
        Label5.text=[matches valueForKey:Idioma];
        //UIImage *btnImage5;	
        if (EsNuevo_5==1){
            btnImage5 = [controladorPersonalizacion loadImage:Etiqueta5];
        }
        else{
        btnImage5 = [UIImage imageNamed:Etiqueta5];
        
        }
        [Imagen5 setImage:btnImage5 forState:UIControlStateNormal];
        
        matches = [objects objectAtIndex:valor+5];
        Etiqueta6=[matches valueForKey:@"nombre"];
        PK_6=[[matches valueForKey:@"pk"]intValue];
        EsNuevo_6=[[matches valueForKey:@"nuevo"]intValue];
        VALOR_ANTIGUO_CONTADOR_6=[[matches valueForKey:@"contador"]intValue];
        Label6.text=[matches valueForKey:Idioma];
        //UIImage *btnImage6;	
        if (EsNuevo_6==1){
            btnImage6 = [controladorPersonalizacion loadImage:Etiqueta6];
        }
        else{
        btnImage6 = [UIImage imageNamed:Etiqueta6];
    
        }
        [Imagen6 setImage:btnImage6 forState:UIControlStateNormal];
        }

}


//Selecciona la fila que quiere cambiar, que será la primary key del objeto pulsado anteriormente, y 
//aumenta en una unidad el valor del contador de ese elemento pulsado para que luego aparezca en
//orden de elementos más utilizados.
- (void) ModificarContadores: (int) fila_a_cambiar ValorAnterior: (int) valor_contador_anterior Entidad: (NSString *) entidad_modificar{
    
    COMUNICADORAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    NSManagedObjectContext *context = [appDelegate managedObjectContext];
    
    NSEntityDescription *entityDesc = [NSEntityDescription entityForName:entidad_modificar inManagedObjectContext:context];
    NSFetchRequest *request = [[NSFetchRequest alloc] init];
    
    [request setEntity:entityDesc];
    
    NSError *error;
    
    NSArray *items=[context executeFetchRequest:request error:&error];
    [request release];
    
    NSManagedObject *micontador= [items objectAtIndex:(fila_a_cambiar-1)];
    
    [micontador setValue:[NSNumber numberWithInt: (valor_contador_anterior+1)] forKey:@"contador"];
    
    
    if (![context save:&error]) {
        NSLog(@"error de coredata %@, %@", error, [error userInfo]);
        exit(-1);
    }
    
    NSLog(@"LLego");
    
    
}



- (void) IniciarImagenes{
    
    Imagen1.enabled=YES;
    Imagen2.enabled=YES;
    Imagen3.enabled=YES;
    Imagen4.enabled=YES;
    Imagen5.enabled=YES;
    Imagen6.enabled=YES;
    Imagen1.hidden=NO;
    Imagen2.hidden=NO;
    Imagen3.hidden=NO;
    Imagen4.hidden=NO;
    Imagen5.hidden=NO;
    Imagen6.hidden=NO;
    
}

- (void) DeshabilitarImagenesYEtiquetas{

    Imagen1.enabled=NO;
    Imagen2.enabled=NO;
    Imagen3.enabled=NO;
    Imagen4.enabled=NO;
    Imagen5.enabled=NO;
    Imagen6.enabled=NO;
    Label1.enabled=NO;
    Label2.enabled=NO;
    Label3.enabled=NO;
    Label4.enabled=NO;
    Label5.enabled=NO;
    Label6.enabled=NO;
}

- (void) HabilitarImagenes {
    Imagen1.enabled=YES;
    Imagen2.enabled=YES;
    Imagen3.enabled=YES;
    Imagen4.enabled=YES;
    Imagen5.enabled=YES;
    Imagen6.enabled=YES;
}

- (void) HabilitarEtiquetas {

    Label1.enabled=YES;
    Label2.enabled=YES;
    Label3.enabled=YES;
    Label4.enabled=YES;
    Label5.enabled=YES;
    Label6.enabled=YES;

}

-(IBAction) PULSAR_VOLVER_COMUNICADOR: (id) sender
{
	[VISTA_PRINCIPAL removeFromSuperview];
	QE=0;

}


- (IBAction) PULSAR_BOTON_ARRIBA_OK: (id) sender{
	
	[self.view addSubview:VISTA_SECUNDARIA];
    
    if (controladorAjustes.resp_negativa==0){
        [VISTA_BASE_BOTON_NO addSubview: VISTA_BOTON_NO];
    }
    else if (controladorAjustes.resp_negativa==1){
        [VISTA_BOTON_NO removeFromSuperview];
    }

	Imagen_secundaria1.image=Imagen_frase1.image;
	Imagen_secundaria2.image=Imagen_frase2.image;
	Imagen_secundaria3.image=Imagen_frase3.image;
	Label_secundaria1.text=Label_frase1.text;
	Label_secundaria2.text=Label_frase2.text;
	Label_secundaria3.text=Label_frase3.text;
	Imagen_frase1.image=nil;
	Imagen_frase2.image=nil;
	Imagen_frase3.image=nil;
	Label_frase1.text=nil;
	Label_frase2.text=nil;
	Label_frase3.text=nil;
    if (QUIEROESTOY==2){
        Label_secundaria1.hidden=YES;
        
    }
    else{
        Label_secundaria1.hidden=NO;
    }
	 
}


//Cuando hay posibilidad de dos paginas, este es el boton de pasar pagina a la derecha

-(IBAction) PULSAR_BOTON_PAGINA_DERECHA: (id) sender
{
	/* PASAR A MAYUSCULAS
	NSString *caca;
	caca=[Label4.text uppercaseString];
	Label4.text=caca;
	*/
	if (DERECHA>0) {
		
		[BOTON_PAGINA_DERECHA removeFromSuperview];
		[VISTA_ABAJO_BOTONES addSubview:BOTON_PAGINA_IZQUIERDA];
	}
    
    [self BusquedaBotonesPaginas];

	COMUNICADORAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	
	NSManagedObjectContext *context = [appDelegate managedObjectContext];
	
	NSEntityDescription *entityDesc = [NSEntityDescription entityForName:entidad inManagedObjectContext:context];
	
	NSFetchRequest *request = [[NSFetchRequest alloc] init];
	
	[request setEntity:entityDesc];
	
	NSPredicate *pred = [NSPredicate predicateWithFormat:predicado_sublugar];
	
	
	[request setPredicate:pred];
    
    NSSortDescriptor *sortDescriptor = [[[NSSortDescriptor alloc] initWithKey:@"contador" ascending:NO]autorelease];
    
    [request setSortDescriptors:[NSArray arrayWithObject:sortDescriptor]];

	
	NSError *error;
	
	NSArray *objects = [context executeFetchRequest:request error:&error];
	
	NSManagedObject *matches = nil;
	
    [self PonerImagenes:objects Objeto:matches Numero:INDICE_PAGINAS];

		if ([objects count] > INDICE_PAGINAS+6) {
			
			
			[VISTA_ABAJO_BOTONES addSubview:BOTON_PAGINA_DERECHA];
		
		}
		
		INDICE_PAGINAS=INDICE_PAGINAS+6;
     
}

//Cuando hay posibilidad de dos paginas, este es el boton de pasar pagina a la izquierda

-(IBAction) PULSAR_BOTON_PAGINA_IZQUIERDA: (id) sender
{
	INDICE_PAGINAS=INDICE_PAGINAS-6;
	
	if (DERECHA>0) {
		
		[BOTON_PAGINA_IZQUIERDA removeFromSuperview];
		[VISTA_ABAJO_BOTONES addSubview:BOTON_PAGINA_DERECHA];
	}
    
    [self BusquedaBotonesPaginas];
 
	COMUNICADORAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	
	NSManagedObjectContext *context = [appDelegate managedObjectContext];
	
	NSEntityDescription *entityDesc = [NSEntityDescription entityForName:entidad inManagedObjectContext:context];
	
	NSFetchRequest *request = [[NSFetchRequest alloc] init];
	
	[request setEntity:entityDesc];
	
	NSPredicate *pred = [NSPredicate predicateWithFormat:predicado_sublugar];
	
	
	[request setPredicate:pred];
    
    NSSortDescriptor *sortDescriptor = [[[NSSortDescriptor alloc] initWithKey:@"contador" ascending:NO]autorelease];
    
    [request setSortDescriptors:[NSArray arrayWithObject:sortDescriptor]];

	
	NSError *error;
	
	NSArray *objects = [context executeFetchRequest:request error:&error];
	
	NSManagedObject *matches = nil;
	
    [self PonerImagenes:objects Objeto:matches Numero:(INDICE_PAGINAS-6)];

		if (INDICE_PAGINAS > 6) {
			
			
			[VISTA_ABAJO_BOTONES addSubview:BOTON_PAGINA_IZQUIERDA];

		}
	
}

-(void) BusquedaBotonesPaginas{
   
    [self IniciarImagenes];
	
	if (INDICE==2) {
		entidad=@"Personas";
	}
	
	else if (INDICE==3){
		
		if (QUIEROESTOY>0){
            
            entidad=@"Parte2";
            
        }
        else{
            entidad=@"Verbos";
        }
		
	}
	else if (INDICE==4){
		
		if (QUIEROESTOY>0){
            entidad=@"Parte3";
            
        }
        else{
            entidad=@"Complementos";
        }
		
	}
	
	
    
}

//Pulsa boton para elegir si quieres que salga la pantalla NO despues de la frase

/*
-(IBAction) PULSAR_BOTON_OPCIONES: (id) sender
{
    //NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    //pulsacion = [defaults boolForKey:@"Respuesta negativa"];
    
	if (pulsacion == NO)
	{
		[BOTON_AJUSTES setTitle:@"ON" forState:0];
		pulsacion = YES;
		[VISTA_BASE_BOTON_NO addSubview:VISTA_BOTON_NO];
	}
	else
	{
		[BOTON_AJUSTES setTitle:@"OFF" forState:0];
		pulsacion = NO;
		[VISTA_BOTON_NO removeFromSuperview];
	}
}
*/
//Botones negar e interrogante

- (IBAction) PULSAR_BOTON_NEGAR: (id) sender{
	if (NEGAR==0) {
		
	negacion=[CALayer layer];
	//negacion=Imagen_frase2.layer;
	negacion.bounds=CGRectMake(405.0f, 10.0f, 90.0f, 90.0f);
	negacion.position=CGPointMake(0.0f, 0.0f);
	negacion.anchorPoint=CGPointMake(0.0f, 0.0f);
	negacion.contents= (id)[[UIImage imageNamed:@"negacion.gif"] CGImage];
	
	if (QUIEROESTOY==1) {
			[Imagen_frase1.layer addSublayer:negacion];

		}
	else {	
	[Imagen_frase2.layer addSublayer:negacion];
	}
		
	negacion_secundaria=[CALayer layer];
	//negacion=Imagen_frase2.layer;
	negacion_secundaria.bounds=CGRectMake(360.0f, 279.0f, 200.0f, 200.0f);
	negacion_secundaria.position=CGPointMake(0.0f, 0.0f);
	negacion_secundaria.anchorPoint=CGPointMake(0.0f, 0.0f);
	negacion_secundaria.contents= (id)[[UIImage imageNamed:@"negacion.gif"] CGImage];
		
		if (QUIEROESTOY==1) {
			[Imagen_secundaria1.layer addSublayer:negacion_secundaria];
			
		}
		else {	
			[Imagen_secundaria2.layer addSublayer:negacion_secundaria];
		}
	
		
		[BOTON_NEGAR setTitle:@"SI" forState:0];
		NEGAR=1;
	}
	else if (NEGAR==1){
		
		[negacion removeFromSuperlayer];
		[negacion_secundaria removeFromSuperlayer];
		[BOTON_NEGAR setTitle:@"NO" forState:0];
		NEGAR=0;
	}
}


- (IBAction) PULSAR_BOTON_INTERROGANTE: (id) sender{
	if (INTERROGANTE==0) {
		
		Imagen_frase_interrogante.image=[UIImage imageNamed: @"interrogante_blanco.png"];
		Imagen_secundaria_interrogante.image=[UIImage imageNamed: @"interrogante.png"];
		INTERROGANTE=1;
	}
	else if (INTERROGANTE==1){
		Imagen_frase_interrogante.image=nil;
		Imagen_secundaria_interrogante.image=nil;
		INTERROGANTE=0;
	}
}

//Boton oculto esquina superior izquierda de ajustes

-(IBAction) PULSAR_BOTON_AJUSTES: (id) sender
{
	[VISTA_PRIMERA addSubview:controladorAjustes.view];
}

//Boton de salir del menu ajustes
/*
-(IBAction) PULSAR_BOTON_SALIR_AJUSTES: (id) sender
{
	[VISTA_AJUSTES removeFromSuperview];
}
*/
//Niega la frase del usuario

-(IBAction) PULSAR_BOTON_NO: (id) sender
{
	[self.view addSubview:VISTA_NO];
}

//Sale de la pantalla NO

-(IBAction) PULSAR_BOTON_SALIR_NO: (id) sender
{
	[VISTA_NO removeFromSuperview];
}

//Boton salir de la pantalla de la frase final

-(IBAction) PULSAR_BOTON_SALIR: (id) sender
{
	if (NEGAR==1){
		
		[negacion removeFromSuperlayer];
		[negacion_secundaria removeFromSuperlayer];
		[BOTON_NEGAR setTitle:@"NO" forState:0];
		NEGAR=0;
	}
	
	[VISTA_SECUNDARIA removeFromSuperview];
	[VISTA_ARRIBA_BOTON removeFromSuperview];
	[VISTA_MEDIO_SUBLUGARES removeFromSuperview];
	if (QUIEROESTOY>0) {
        
		[VISTA_MEDIO_BASE addSubview:VISTA_MEDIO_QUIERO_ESTOY];
        [self BusquedaLugares:@"Parte1"];
        
	}
	else{
        [self BusquedaLugares:@"Lugar"];
        
        [VISTA_MEDIO_BASE addSubview:VISTA_MEDIO];
	}
	[VISTA_ABAJO_BORRAR removeFromSuperview];
	[VISTA_ABAJO_IZQUIERDA_BASE addSubview:VISTA_ABAJO_IZQUIERDA];
	[VISTA_ABAJO_IZQUIERDA_NO_PREGUNTA removeFromSuperview];
	
	QUIEROESTOY=0;
	INDICE=0;
	DERECHA=0;
	INTERROGANTE=0;
	INDICE_PAGINAS=6;
	
    [self IniciarImagenes];
    
	[self HabilitarEtiquetas];
    
	Imagen_secundaria1.image=nil;
	Imagen_secundaria2.image=nil;
	Imagen_secundaria3.image=nil;
	Label_secundaria1.text=nil;
	Label_secundaria2.text=nil;
	Label_secundaria3.text=nil;	
	
	Imagen_frase_interrogante.image=nil;
	Imagen_secundaria_interrogante.image=nil;
    Label_frase1.hidden=YES;
    Label_frase2.hidden=YES;
    Label_frase3.hidden=YES;
}


//Pulsar los botones de los pictos


//Pulsar BORRAR para deshacer frases

-(IBAction) PULSAR_BOTON_BORRAR: (id) sender
{
	[self IniciarImagenes];
	
	if (INDICE==1) {
		[VISTA_MEDIO_SUBLUGARES removeFromSuperview];
        [self BusquedaLugares:@"Lugar"];
		[VISTA_MEDIO_BASE addSubview:VISTA_MEDIO];
		INDICE=INDICE-1;
		[VISTA_ABAJO_BORRAR removeFromSuperview];
		[VISTA_ABAJO_IZQUIERDA_BASE addSubview:VISTA_ABAJO_IZQUIERDA];
	}
	else if (INDICE==2){
		
		INDICE=INDICE-1;
		if (DERECHA==1) {
			
			[BOTON_PAGINA_IZQUIERDA removeFromSuperview];
			[BOTON_PAGINA_DERECHA removeFromSuperview];
			DERECHA=0;
			INDICE_PAGINAS=6;
			
		}
		INTERROGANTE=0;
		if (NEGAR==1){
			
			[negacion removeFromSuperlayer];
			[negacion_secundaria removeFromSuperlayer];
			[BOTON_NEGAR setTitle:@"NO" forState:0];
			NEGAR=0;
		}
		Imagen_frase_interrogante.image=nil;
		Imagen_secundaria_interrogante.image=nil;
		[VISTA_ABAJO_IZQUIERDA_NO_PREGUNTA removeFromSuperview];
	
        [self BusquedaYSituacionBorrar:@"Sublugar" Predicado:predicado_base];
    }
	else if (INDICE==3){
		
        Label_frase1.hidden=YES;
		Imagen_frase1.image=nil;
		Label_frase1.text=nil;
		INDICE=INDICE-1;
		if (QUIEROESTOY==1) {
            entidad=@"Parte1";
			[VISTA_MEDIO_SUBLUGARES removeFromSuperview];
			[VISTA_ABAJO_BORRAR removeFromSuperview];
			[VISTA_ABAJO_IZQUIERDA_BASE addSubview:VISTA_ABAJO_IZQUIERDA];
			if (NEGAR==1){
				
				[negacion removeFromSuperlayer];
				[negacion_secundaria removeFromSuperlayer];
				[BOTON_NEGAR setTitle:@"NO" forState:0];
				NEGAR=0;
			}
			Imagen_frase_interrogante.image=nil;
			Imagen_secundaria_interrogante.image=nil;
			INTERROGANTE=0;
		}
		else {
		if (DERECHA==1) {
			
			[BOTON_PAGINA_IZQUIERDA removeFromSuperview];
			[BOTON_PAGINA_DERECHA removeFromSuperview];
			DERECHA=0;
			INDICE_PAGINAS=6;
            
		}
          entidad=@"Personas";  
        [self BusquedaYSituacionBorrar:entidad Predicado:predicado_sublugar];
    
		}
	}
	else if (INDICE==4){
		
        Label_frase2.hidden=YES;
		Imagen_frase2.image=nil;
		Label_frase2.text=nil;
		INDICE=INDICE-1;
		if (QUIEROESTOY==2) {
			[VISTA_MEDIO_SUBLUGARES removeFromSuperview];
			[VISTA_ABAJO_BORRAR removeFromSuperview];
			[VISTA_ABAJO_IZQUIERDA_BASE addSubview:VISTA_ABAJO_IZQUIERDA];
			if (NEGAR==1){
				
				[negacion removeFromSuperlayer];
				[negacion_secundaria removeFromSuperlayer];
				[BOTON_NEGAR setTitle:@"NO" forState:0];
				NEGAR=0;
			}
			Imagen_frase_interrogante.image=nil;
			Imagen_secundaria_interrogante.image=nil;
			INTERROGANTE=0;
            entidad=@"Parte2";
            predicado_sublugar=@"ANY Parte2Con1 like '2' AND activo=1";
		}
		else {
			
            if (DERECHA==1) {
			
                [BOTON_PAGINA_IZQUIERDA removeFromSuperview];
                [BOTON_PAGINA_DERECHA removeFromSuperview];
                DERECHA=0;
                INDICE_PAGINAS=6;
                }
		
		
            if (QUIEROESTOY==1) {
			
                entidad=@"Parte2";
                predicado_sublugar=@"ANY Parte2Con1 like '1' AND activo=1";
            }
            else if (QUIEROESTOY==0){
			
                entidad=@"Verbos";
                
            }
		
            [self BusquedaYSituacionBorrar:entidad Predicado:predicado_sublugar];

            }
    }

	else if (INDICE==5){
		
		[self IniciarImagenes];
		[self HabilitarEtiquetas];
		
        Label_frase3.hidden=YES;
		Imagen_frase3.image=nil;
		Label_frase3.text=nil;
		INDICE=INDICE-1;
		INDICE_PAGINAS=6;
		[VISTA_ARRIBA_BOTON removeFromSuperview];
		if (DERECHA==1){
			[VISTA_ABAJO_BOTONES addSubview:BOTON_PAGINA_DERECHA];
		}
		
	}
}



- (void)viewDidUnload {
	
	Imagen1.imageView.image = nil;
	Imagen2.imageView.image = nil;
	Imagen3.imageView.image = nil;
	Imagen4.imageView.image = nil;
	Imagen5.imageView.image = nil;
	Imagen6.imageView.image = nil;
	
    Imagen_lugar1.imageView.image = nil;
	Imagen_lugar2.imageView.image = nil;
	Imagen_lugar3.imageView.image = nil;
	Imagen_lugar4.imageView.image = nil;
	
    Boton_estoy.imageView.image = nil;
    Boton_quiero.imageView.image = nil;

    Label_lugar1.text = nil;
	Label_lugar2.text = nil;
	Label_lugar3.text = nil;
	Label_lugar4.text = nil;

    Label1.text = nil;
	Label2.text = nil;
	Label3.text = nil;
	Label4.text = nil;
	Label5.text = nil;
	Label6.text = nil;
	Label_quiero.text = nil;
	Label_estoy.text = nil;
	Label_frase1.text = nil;
	Label_frase2.text = nil;
	Label_frase3.text = nil;
	Imagen_frase1.image=nil;
	Imagen_frase2.image=nil;
	Imagen_frase3.image=nil;
	Label_secundaria1.text = nil;
	Label_secundaria2.text = nil;
	Label_secundaria3.text = nil;
	Imagen_secundaria1.image=nil;
	Imagen_secundaria2.image=nil;
	Imagen_secundaria3.image=nil;
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	
     
    [Imagen1 release];
	[Imagen2 release];
	[Imagen3 release];
	[Imagen4 release];
	
    [Imagen5 release];
	[Imagen6 release];
	[Imagen_lugar1 release];
	[Imagen_lugar2 release];
	[Imagen_lugar3 release];
	[Imagen_lugar4 release];

    [Label_lugar1 release];
	[Label_lugar2 release];
	[Label_lugar3 release];
	[Label_lugar4 release];

    [Label1 release];
	[Label2 release];
	[Label3 release];
	[Label4 release];
	[Label5 release];
	[Label6 release];
	[Label_quiero release];
	[Label_estoy release];
    [Boton_quiero release];
    [Boton_estoy release];
	[Label_frase1 release];
	[Label_frase2 release];
	[Label_frase3 release];
	[Imagen_frase1 release];
	[Imagen_frase2 release];
	[Imagen_frase3 release];
	[Label_secundaria1 release];
	[Label_secundaria2 release];
	[Label_secundaria3 release];
	[Imagen_secundaria1 release];
	[Imagen_secundaria2 release];
	[Imagen_secundaria3 release];
	
    [super dealloc];
}



@end
