//
//  EditarAlbumFavorito.h
//  COMUNICADOR
//
//  Created by Elisabeth Esandia Melero on 07/06/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "COMUNICADORAppDelegate.h"
#import <UIKit/UIKit.h>

@class Ajustes;

@interface EditarAlbumFavorito : UIViewController 
{
    /////////////////////////////
    //      AJUSTES            //
    Ajustes * ControladorAjustes;
    
    int ajuste_resp_negativa;
    int ajuste_tiempo_pulsacion;
    int ajuste_tipo_letra;
    
    //En Idioma irá el string correspondiente a la columna de la base de datos que quiero consultar
    NSString *Idioma;
    ////////////////////////////
    
    NSArray *objects_entidad;               // Objetos cogidos(entidad completa) de la llamada a la BD.
    NSMutableArray *objectsCogidos_entidad; // Objetos almacenados de "objects_entidad" para trabajar con ellos en la recarga.
    NSArray *objects_favoritos;               // Objetos cogidos (favoritos) de la llamada a la BD.
    NSMutableArray *objectsCogidos_favoritos; // Objetos almacenados de "objects_favoritos" para trabajar con ellos en la recarga.
    
    NSMutableArray *Entidad_table;          // Tabla de miniaturas de Entidad.
    NSMutableArray *Favorito_table;   // Tabla de miniaturas de Favorito.
    NSMutableArray *EntidadLabel_table;
    NSMutableArray *FavoritoLabel_table;
    int EntidadActual;
    int num_pag_view;                       // Índice de la página que estamos visualizando de objetos de entidad.
    int indice;                             // Índice del objeto que estamos viendo de la entidad.
    int num_pag_view_per;                   // Índice de la página que estamos visualizando de objetos de entidad personalizada.
    int indice_per;                         // Índice del objeto que estamos viendo de la entidad personalizada.
    
    NSMutableArray *selecc_originales;      // Array de elementos que se van seleccionando de cada entidad.
    NSMutableArray *selecc_favoritos;  // Array de elementos que se van seleccionando en la entidad personalizada.
    NSMutableArray *datos_favoritos;   // Array de elementos que aparecerán en cada entidad personalizada.
    
    //NSInteger *ButtonTag;                   // Valor del tag del botón miniatura que se pulsa.
    
    //////////////////////  LLAMADA A LA BD 
    
    COMUNICADORAppDelegate *appDelegate;
    NSManagedObjectContext *context;
    NSEntityDescription *entityDesc;
    NSFetchRequest *request;
    NSError *error;
    
    COMUNICADORAppDelegate *appDelegate_per;
    NSManagedObjectContext *context_per;
    NSEntityDescription *entityDesc_per;
    NSFetchRequest *request_favorito;
    NSPredicate *pred_favorito;
    NSError *error_per;
    
    UIAlertView *alertaSimple;              // Alerta simple por si no hay objetos.
    UIAlertView *alertaSimplePersonalizada;
    UIAlertView *alertaSimpleGuardar;
    
    /////////////////////   BOTONES EDICIÓN
    
    IBOutlet UIButton *butAgregar;
    IBOutlet UIButton *butQuitar;
    IBOutlet UIButton *butGuardar;
    
    /////////////////////   BOTONES MINIATURAS
    
	IBOutlet UIButton * EntidadPicto0;
	IBOutlet UIButton * EntidadPicto1;
	IBOutlet UIButton * EntidadPicto2;
	IBOutlet UIButton * EntidadPicto3;
	IBOutlet UIButton * EntidadPicto4;
	IBOutlet UIButton * EntidadPicto5;
	IBOutlet UIButton * EntidadPicto6;
	IBOutlet UIButton * EntidadPicto7;
	IBOutlet UIButton * EntidadPicto8;
	IBOutlet UIButton * EntidadPicto9;
	IBOutlet UIButton * EntidadPicto10;
	IBOutlet UIButton * EntidadPicto11;
	IBOutlet UIButton * EntidadPicto12;
	IBOutlet UIButton * EntidadPicto13;
    
    IBOutlet UIButton * FavoritoPicto1;
	IBOutlet UIButton * FavoritoPicto2;
	IBOutlet UIButton * FavoritoPicto3;
	IBOutlet UIButton * FavoritoPicto4;
	IBOutlet UIButton * FavoritoPicto5;
	IBOutlet UIButton * FavoritoPicto6;
	IBOutlet UIButton * FavoritoPicto7;
	IBOutlet UIButton * FavoritoPicto8;
	IBOutlet UIButton * FavoritoPicto9;
	IBOutlet UIButton * FavoritoPicto10;
	IBOutlet UIButton * FavoritoPicto11;
	IBOutlet UIButton * FavoritoPicto12;
	IBOutlet UIButton * FavoritoPicto13;
	IBOutlet UIButton * FavoritoPicto14;
    
    IBOutlet UILabel * Label1;
	IBOutlet UILabel * Label2;
	IBOutlet UILabel * Label3;
	IBOutlet UILabel * Label4;
	IBOutlet UILabel * Label5;
	IBOutlet UILabel * Label6;
	IBOutlet UILabel * Label7;
	IBOutlet UILabel * Label8;
	IBOutlet UILabel * Label9;
	IBOutlet UILabel * Label10;
	IBOutlet UILabel * Label11;
	IBOutlet UILabel * Label12;
	IBOutlet UILabel * Label13;
	IBOutlet UILabel * Label14;
    
	IBOutlet UILabel * Label15;
    IBOutlet UILabel * Label16;
	IBOutlet UILabel * Label17;
	IBOutlet UILabel * Label18;
	IBOutlet UILabel * Label19;
	IBOutlet UILabel * Label20;
	IBOutlet UILabel * Label21;
	IBOutlet UILabel * Label22;
	IBOutlet UILabel * Label23;
	IBOutlet UILabel * Label24;
	IBOutlet UILabel * Label25;
	IBOutlet UILabel * Label26;
	IBOutlet UILabel * Label27;
	IBOutlet UILabel * Label28;
    
    
    
    /////////////////////   BOTONES NAVEGACIÓN
    
    IBOutlet UILabel *label_lugar;
    IBOutlet UILabel *label_sublugar;
    IBOutlet UILabel *label_personas;
    IBOutlet UILabel *label_verbos;
    IBOutlet UILabel *label_complementos;
    
    IBOutlet UIButton * BotonEntidadSiguiente;
    IBOutlet UIButton * BotonEntidadAnterior;
    
    IBOutlet UIButton * BotonFavoritoSiguiente;
    IBOutlet UIButton * BotonFavoritoAnterior;
    
    IBOutlet UIButton *butVolver;
    
    
    IBOutlet UILabel *EntidadTitle;     // Label controlador del título.
    IBOutlet UILabel *EntidadFavoritoTitle; 
    
    BOOL onFavorito;
}

@property (nonatomic, retain) Ajustes *ControladorAjustes;

@property(nonatomic,retain)IBOutlet UILabel *label_lugar;
@property(nonatomic,retain)IBOutlet UILabel *label_sublugar;
@property(nonatomic,retain)IBOutlet UILabel *label_personas;
@property(nonatomic,retain)IBOutlet UILabel *label_verbos;
@property(nonatomic,retain)IBOutlet UILabel *label_complementos;

@property(nonatomic,retain)IBOutlet UIButton *butAgregar;
@property(nonatomic,retain)IBOutlet UIButton *butQuitar;
@property(nonatomic,retain)IBOutlet UIButton *butGuardar;

@property(nonatomic,retain)IBOutlet UIButton *EntidadPicto0;
@property(nonatomic,retain)IBOutlet UIButton *EntidadPicto1;
@property(nonatomic,retain)IBOutlet UIButton *EntidadPicto2;
@property(nonatomic,retain)IBOutlet UIButton *EntidadPicto3;
@property(nonatomic,retain)IBOutlet UIButton *EntidadPicto4;
@property(nonatomic,retain)IBOutlet UIButton *EntidadPicto5;
@property(nonatomic,retain)IBOutlet UIButton *EntidadPicto6;
@property(nonatomic,retain)IBOutlet UIButton *EntidadPicto7;
@property(nonatomic,retain)IBOutlet UIButton *EntidadPicto8;
@property(nonatomic,retain)IBOutlet UIButton *EntidadPicto9;
@property(nonatomic,retain)IBOutlet UIButton *EntidadPicto10;
@property(nonatomic,retain)IBOutlet UIButton *EntidadPicto11;
@property(nonatomic,retain)IBOutlet UIButton *EntidadPicto12;
@property(nonatomic,retain)IBOutlet UIButton *EntidadPicto13;

@property(nonatomic,retain)IBOutlet UIButton *FavoritoPicto1;
@property(nonatomic,retain)IBOutlet UIButton *FavoritoPicto2;
@property(nonatomic,retain)IBOutlet UIButton *FavoritoPicto3;
@property(nonatomic,retain)IBOutlet UIButton *FavoritoPicto4;
@property(nonatomic,retain)IBOutlet UIButton *FavoritoPicto5;
@property(nonatomic,retain)IBOutlet UIButton *FavoritoPicto6;
@property(nonatomic,retain)IBOutlet UIButton *FavoritoPicto7;
@property(nonatomic,retain)IBOutlet UIButton *FavoritoPicto8;
@property(nonatomic,retain)IBOutlet UIButton *FavoritoPicto9;
@property(nonatomic,retain)IBOutlet UIButton *FavoritoPicto10;
@property(nonatomic,retain)IBOutlet UIButton *FavoritoPicto11;
@property(nonatomic,retain)IBOutlet UIButton *FavoritoPicto12;
@property(nonatomic,retain)IBOutlet UIButton *FavoritoPicto13;
@property(nonatomic,retain)IBOutlet UIButton *FavoritoPicto14;

@property(nonatomic,retain)IBOutlet UILabel * Label1;
@property(nonatomic,retain)IBOutlet UILabel * Label2;
@property(nonatomic,retain)IBOutlet UILabel * Label3;
@property(nonatomic,retain)IBOutlet UILabel * Label4;
@property(nonatomic,retain)IBOutlet UILabel * Label5;
@property(nonatomic,retain)IBOutlet UILabel * Label6;
@property(nonatomic,retain)IBOutlet UILabel * Label7;
@property(nonatomic,retain)IBOutlet UILabel * Label8;
@property(nonatomic,retain)IBOutlet UILabel * Label9;
@property(nonatomic,retain)IBOutlet UILabel * Label10;
@property(nonatomic,retain)IBOutlet UILabel * Label11;
@property(nonatomic,retain)IBOutlet UILabel * Label12;
@property(nonatomic,retain)IBOutlet UILabel * Label13;
@property(nonatomic,retain)IBOutlet UILabel * Label14;

@property(nonatomic,retain)IBOutlet UILabel * Label15;
@property(nonatomic,retain)IBOutlet UILabel * Label16;
@property(nonatomic,retain)IBOutlet UILabel * Label17;
@property(nonatomic,retain)IBOutlet UILabel * Label18;
@property(nonatomic,retain)IBOutlet UILabel * Label19;
@property(nonatomic,retain)IBOutlet UILabel * Label20;
@property(nonatomic,retain)IBOutlet UILabel * Label21;
@property(nonatomic,retain)IBOutlet UILabel * Label22;
@property(nonatomic,retain)IBOutlet UILabel * Label23;
@property(nonatomic,retain)IBOutlet UILabel * Label24;
@property(nonatomic,retain)IBOutlet UILabel * Label25;
@property(nonatomic,retain)IBOutlet UILabel * Label26;
@property(nonatomic,retain)IBOutlet UILabel * Label27;
@property(nonatomic,retain)IBOutlet UILabel * Label28;

@property(nonatomic,retain)IBOutlet UILabel *EntidadTitle; 
@property(nonatomic,retain)IBOutlet UILabel *EntidadFavoritoTitle; 

@property(nonatomic,retain)IBOutlet UIButton *BotonEntidadSiguiente;
@property(nonatomic,retain)IBOutlet UIButton *BotonEntidadAnterior;

@property(nonatomic,retain)IBOutlet UIButton *BotonFavoritoSiguiente;
@property(nonatomic,retain)IBOutlet UIButton *BotonFavoritoAnterior;

@property(nonatomic,retain)IBOutlet UIButton *butVolver;


-(void) Ajustar;

-(void)reloadEntidadPics;
-(void)pasoPictosfavoritos;
-(void)reloadfavoritoPics;

-(IBAction)volverEntidadPictos:(id)sender;      // Volver a la pantalla anterior.

-(IBAction)onEntidad:(id)sender;                // Pulsación de la elección de entidad.
-(IBAction)onEntidadPicto:(id)sender;           // Pulsación del picto de la entidad seleccionada.
-(IBAction)onFavoritoPicto:(id)sender;    // Pulsación del picto configurado en la entidad "Favorito"

////////////////////////// ACCIONES DE NAVEGACIÓN

-(IBAction)onEntidadSiguiente:(id)sender;
-(IBAction)onEntidadAnterior:(id)sender;

-(IBAction)onFavoritoSiguiente:(id)sender;
-(IBAction)onFavoritoAnterior:(id)sender;

////////////////////////// ACCIONES DE EDICIÓN

-(IBAction)pulsarButAgregar:(id)sender;
-(IBAction)pulsarButQuitar:(id)sender;
-(IBAction)pulsarButGuardar:(id)sender;


@end
