//
//  EditarAlbumFavorito.m
//  COMUNICADOR
//
//  Created by Elisabeth Esandia Melero on 07/06/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "EditarAlbumFavorito.h"
#import "Ajustes.h"

@implementation EditarAlbumFavorito

@synthesize ControladorAjustes;

@synthesize label_lugar;
@synthesize label_sublugar;
@synthesize label_personas;
@synthesize label_verbos;
@synthesize label_complementos;

@synthesize butAgregar;
@synthesize butQuitar;
@synthesize butGuardar;

@synthesize EntidadPicto0;
@synthesize EntidadPicto1;
@synthesize EntidadPicto2;
@synthesize EntidadPicto3;
@synthesize EntidadPicto4;
@synthesize EntidadPicto5;
@synthesize EntidadPicto6;
@synthesize EntidadPicto7;
@synthesize EntidadPicto8;
@synthesize EntidadPicto9;
@synthesize EntidadPicto10;
@synthesize EntidadPicto11;
@synthesize EntidadPicto12;
@synthesize EntidadPicto13;

@synthesize FavoritoPicto1;
@synthesize FavoritoPicto2;
@synthesize FavoritoPicto3;
@synthesize FavoritoPicto4;
@synthesize FavoritoPicto5;
@synthesize FavoritoPicto6;
@synthesize FavoritoPicto7;
@synthesize FavoritoPicto8;
@synthesize FavoritoPicto9;
@synthesize FavoritoPicto10;
@synthesize FavoritoPicto11;
@synthesize FavoritoPicto12;
@synthesize FavoritoPicto13;
@synthesize FavoritoPicto14;

@synthesize Label1;
@synthesize Label2;
@synthesize Label3;
@synthesize Label4;
@synthesize Label5;
@synthesize Label6;
@synthesize Label7;
@synthesize Label8;
@synthesize Label9;
@synthesize Label10;
@synthesize Label11;
@synthesize Label12;
@synthesize Label13;
@synthesize Label14;

@synthesize Label15;
@synthesize Label16;
@synthesize Label17;
@synthesize Label18;
@synthesize Label19;
@synthesize Label20;
@synthesize Label21;
@synthesize Label22;
@synthesize Label23;
@synthesize Label24;
@synthesize Label25;
@synthesize Label26;
@synthesize Label27;
@synthesize Label28;

@synthesize EntidadTitle;
@synthesize EntidadFavoritoTitle;

@synthesize BotonEntidadSiguiente;
@synthesize BotonEntidadAnterior;

@synthesize BotonFavoritoSiguiente;
@synthesize BotonFavoritoAnterior;

@synthesize butVolver;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    [objects_entidad release];
    [objectsCogidos_entidad release];
    //[request release];
    
    [Entidad_table release];
    [Favorito_table release];
    [EntidadLabel_table release];
    [FavoritoLabel_table release];
    
    [BotonEntidadAnterior release];
    [BotonFavoritoAnterior release];
    [BotonEntidadSiguiente release];
    [BotonFavoritoSiguiente release];
    
    //[VisorFotosVista release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}
- (void)viewDidLoad
{
    ControladorAjustes =[[Ajustes alloc]init];

    [self Ajustar];
    
    if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
    {
        [butVolver setTitle:@"VOLVER" forState:normal];
        label_lugar.text=@"LUGARES";
        label_sublugar.text=@"SUBLUGARES";
        label_personas.text=@"PERSONAS";
        label_verbos.text=@"VERBOS";
        label_complementos.text=@"COMPLEMENTOS";
        
        EntidadTitle.text=@"ENTIDAD COMPLETA";
        EntidadFavoritoTitle.text=@"ENTIDAD PERSONALIZADA";
        
        alertaSimplePersonalizada = [UIAlertView alloc];
        [alertaSimplePersonalizada initWithTitle:@"ALERTA" 
                                         message:@"No hay pictos personalizados de esta entidad" 
                                        delegate:self 
                               cancelButtonTitle:@"Aceptar" 
                               otherButtonTitles: nil];
        
        alertaSimple = [UIAlertView alloc];
        [alertaSimple initWithTitle:@"ALERTA" 
                            message:@"No hay pictos asociados" 
                           delegate:self 
                  cancelButtonTitle:@"Aceptar" 
                  otherButtonTitles: nil];
        
        alertaSimpleGuardar = [UIAlertView alloc];
        [alertaSimpleGuardar initWithTitle:@"ENTIDAD PERSONALIZADA GUARDADA" 
                            message:@"Sus datos han sido guardados correctamente" 
                           delegate:self 
                  cancelButtonTitle:@"Aceptar" 
                  otherButtonTitles: nil];
    }
    else //IDIOMA INGLÉS
    {
        [butVolver setTitle:@"BACK" forState:normal];
        label_lugar.text=@"PLACES";
        label_sublugar.text=@"SUB-PLACES";
        label_personas.text=@"PERSONS";
        label_verbos.text=@"VERBS";
        label_complementos.text=@"COMPLEMENTS";
        
        EntidadTitle.text=@"WHOLE ENTITY";
        EntidadFavoritoTitle.text=@"PERSONALIZED ENTITY";
        
        alertaSimplePersonalizada = [UIAlertView alloc];
        [alertaSimplePersonalizada initWithTitle:@"ALERT" 
                                         message:@"There are not personalized pictos for this entity" 
                                        delegate:self
                               cancelButtonTitle:@"Ok" 
                               otherButtonTitles: nil];
        
        alertaSimple = [UIAlertView alloc];
        [alertaSimple initWithTitle:@"ALERT" 
                            message:@"There are not personalized pictos for this entity" 
                           delegate:self 
                  cancelButtonTitle:@"Ok" 
                  otherButtonTitles: nil];
        
        alertaSimpleGuardar = [UIAlertView alloc];
        [alertaSimpleGuardar initWithTitle:@"EPERSONALIZED ENTITY SAVED" 
                                   message:@"Your data has been saved correctly" 
                                  delegate:self 
                         cancelButtonTitle:@"Ok" 
                         otherButtonTitles: nil];
    }
    
    objects_entidad = [[NSArray alloc] init]; // Inicializamos el array que hará la llamada de los objetos a la BD.
    objectsCogidos_entidad =[[NSMutableArray alloc]init];   // Inicializamos el array que almacenará los "objects_entidad" para trabajar con ellos.
    
    objects_favoritos =[[NSArray alloc]init];
    objectsCogidos_favoritos=[[NSMutableArray alloc]init];
    
    // Inicializamos el array que leerá los elementos que se van seleccionando en cada página de cada entidad.
    selecc_originales =[[NSMutableArray alloc]init]; 
    // Inicializamos el array que leerá los elementos que se van seleccionando en cada página de cada entidad personalizada.
    selecc_favoritos =[[NSMutableArray alloc] init];
    
    // Inicializamos el array que dispondrá de los elementos de cada entidad personalizada.
    datos_favoritos =[[NSMutableArray alloc]init];
    
    appDelegate = [[UIApplication sharedApplication] delegate]; // Parte de la BD
    context = [appDelegate managedObjectContext];   // Parte de la BD
    
    appDelegate_per = [[UIApplication sharedApplication] delegate]; // Parte de la BD
    context_per = [appDelegate_per managedObjectContext]; // Parte de la BD
    
    // Inicializamos la tabla de botones de entidad.
    Entidad_table = [[NSMutableArray alloc]  initWithObjects:EntidadPicto0, EntidadPicto1, EntidadPicto2, EntidadPicto3, EntidadPicto4, EntidadPicto5, EntidadPicto6, EntidadPicto7, EntidadPicto8, EntidadPicto9, EntidadPicto10, EntidadPicto11, EntidadPicto12, EntidadPicto13, nil];
    
    Favorito_table =[[NSMutableArray alloc] initWithObjects:FavoritoPicto1, FavoritoPicto2, FavoritoPicto3, FavoritoPicto4, FavoritoPicto5, FavoritoPicto6, FavoritoPicto7, FavoritoPicto8, FavoritoPicto9, FavoritoPicto10, FavoritoPicto11, FavoritoPicto12, FavoritoPicto13, FavoritoPicto14, nil];
    
    EntidadLabel_table =[[NSMutableArray alloc] initWithObjects:Label1, Label2, Label3, Label4, Label5,Label6, Label7, Label8, Label9, Label10, Label11, Label12, Label13, Label14, nil];
    
    FavoritoLabel_table =[[NSMutableArray alloc] initWithObjects:Label15, Label16, Label17, Label18, Label19, Label20, Label21, Label22, Label23, Label24, Label25, Label26, Label27, Label28, nil];
    
    
    for (int i=0; i<[Entidad_table count]; i++) 
    {
        [[Entidad_table objectAtIndex:i] setHidden:YES];    
    }
    for (int i=0; i<[Favorito_table count]; i++) 
    {
        [[Favorito_table objectAtIndex:i] setHidden:YES];    
    }
    
    for (int i=0; i<[EntidadLabel_table count]; i++) 
    {
        [[EntidadLabel_table objectAtIndex:i] setText:@""]; 
    }
    
    for (int i=0; i<[FavoritoLabel_table count]; i++) 
    {
        [[FavoritoLabel_table objectAtIndex:i] setText:@""];    
    }
    
    num_pag_view = 0; // Establecemos el valor de la página inicial.
    num_pag_view_per =0;
    
    
    // Ocultamos e inhabilitamos los botones de navegación.
    [BotonEntidadSiguiente setEnabled:NO];
    [BotonEntidadAnterior setEnabled:NO];
    [BotonEntidadSiguiente setHidden:YES];
    [BotonEntidadAnterior setHidden:YES]; 
    
    ///////////////////
    // IF --> Si no hay fotos cargadas en Favorito--> evalúa
    ///////////////////
    [BotonFavoritoSiguiente setEnabled:NO];
    [BotonFavoritoAnterior setEnabled:NO];
    [BotonFavoritoSiguiente setHidden:YES];
    [BotonFavoritoAnterior setHidden:YES];
    ///////////////////
    
    
    //VisorFotosVista=[[VisorFotos alloc] initWithNibName:@"VisorFotos" bundle:[NSBundle mainBundle]]; //Eli
    
    [super viewDidLoad];
}

- (void)Ajustar
{
    [ControladorAjustes viewDidLoad];
    ajuste_resp_negativa=ControladorAjustes.resp_negativa;
    ajuste_tiempo_pulsacion=ControladorAjustes.tiempo_pulsacion;
    ajuste_tipo_letra=ControladorAjustes.tipo_letra;
    
    if (ajuste_tipo_letra==20){
        Idioma=@"nombre";
    }
    else if (ajuste_tipo_letra==30){
        Idioma=@"nombre_may";
    }
    else if (ajuste_tipo_letra==50){
        Idioma=@"nombre_ing";
    }
    else if (ajuste_tipo_letra==60){
        Idioma=@"nombre_may_ing";
    }
    
    NSLog(@"respuesta negativa %i, tiempo pulsacion %i, tipo letra %i",ajuste_resp_negativa,ajuste_tiempo_pulsacion,ajuste_tipo_letra);
}

-(IBAction)onEntidad:(id)sender
{
    [selecc_originales removeAllObjects];
    [selecc_favoritos removeAllObjects];
    [datos_favoritos removeAllObjects];
    
    for (int i=0; i<[Favorito_table count]; i++) 
    {
        [[Favorito_table objectAtIndex:i] setHidden:YES];    
    }
    for (int i=0; i<[FavoritoLabel_table count]; i++) 
    {
        [[FavoritoLabel_table objectAtIndex:i] setText:@""];    
    }
    
    NSLog(@"Ahora hay %i objetos en datos favoritos", [datos_favoritos count]);
    
    [BotonEntidadAnterior setHidden:YES];
    [BotonEntidadAnterior setEnabled:NO];
    num_pag_view=0;
    NSInteger ButtonTagEntidad= [sender tag];
    
    dispatch_async(dispatch_get_main_queue(), ^
                   {
                       NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
                       
                       NSLog(@"Estoy cargando Datos");
                       
                       switch (ButtonTagEntidad) 
                       {
                           case 1:
                           {
                               NSLog(@"Se está cargando el álbum LUGARES");
                               if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
                               {
                                   [EntidadTitle setText:@"LUGARES"];
                                   [EntidadFavoritoTitle setText:@"LUGARES PERSONALIZADOS"];
                               }
                               else // IDIOMA INGLÉS
                               {
                                   [EntidadTitle setText:@"PLACES"];
                                   [EntidadFavoritoTitle setText:@"PERSONALIZED PLACES"]; 
                               }
                               EntidadActual=1;
                               
                               //////////////////////////////////////////////////////////////
                               // LLAMADA A LA BD ENTIDAD ORIGINAL
                               //////////////////////////////////////////////////////////////
                               
                               entityDesc = [NSEntityDescription entityForName:@"Lugar" inManagedObjectContext:context];
                               request = [[NSFetchRequest alloc] init];
                               [request setEntity:entityDesc];
                               objects_entidad = [context executeFetchRequest:request error:&error];
                               
                               if ([objects_entidad count] == 0) 
                               {
                                   [alertaSimple show];
                               } 
                               else 
                               {
                                   [objectsCogidos_entidad setArray:objects_entidad];
                                   [self reloadEntidadPics];
                                   [request release];
                               }
                               
                               //////////////////////////////////////////////////////////////
                               // LLAMADA A LA BD ENTIDAD PERSONALIZADA
                               //////////////////////////////////////////////////////////////
                               
                               entityDesc_per=[NSEntityDescription entityForName:@"Lugar" inManagedObjectContext:context_per];
                               request_favorito=[[NSFetchRequest alloc]init];
                               [request_favorito setEntity:entityDesc_per];
                               pred_favorito = [NSPredicate predicateWithFormat:@"ANY album_personalizado like '1'"];
                               [request_favorito setPredicate:pred_favorito];
                               objects_favoritos =[context_per executeFetchRequest:request_favorito error:&error_per];
                               
                               if ([objects_favoritos count] == 0) 
                               {
                                   [alertaSimplePersonalizada show];
                               } 
                               else 
                               {
                                   [objectsCogidos_favoritos setArray:objects_favoritos];
                                   [self pasoPictosfavoritos];
                                   [request_favorito release];
                               }
                           }
                               break;
                           case 2:
                           {
                               NSLog(@"Se está cargando el álbum SUBLUGARES");
                               if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
                               {
                                   [EntidadTitle setText:@"SUBLUGARES"];
                                   [EntidadFavoritoTitle setText:@"SUBLUGARES PERSONALIZADOS"];
                               }
                               else // IDIOMA INGLÉS
                               {
                                   [EntidadTitle setText:@"SUB-PLACES"];
                                   [EntidadFavoritoTitle setText:@"PERSONALIZED SUB-PLACES"]; 
                               }
                               EntidadActual=2;
                               
                               //////////////////////////////////////////////////////////////
                               // LLAMADA A LA BD ENTIDAD ORIGINAL
                               //////////////////////////////////////////////////////////////
                               
                               entityDesc = [NSEntityDescription entityForName:@"Sublugar" inManagedObjectContext:context];
                               request = [[NSFetchRequest alloc] init];
                               [request setEntity:entityDesc];
                               objects_entidad = [context executeFetchRequest:request error:&error];
                               if ([objects_entidad count] == 0) 
                               {
                                   [alertaSimple show];
                               } 
                               else 
                               {
                                   [objectsCogidos_entidad setArray:objects_entidad];
                                   [self reloadEntidadPics];
                                   [request release];
                               }
                               //////////////////////////////////////////////////////////////
                               // LLAMADA A LA BD ENTIDAD PERSONALIZADA
                               //////////////////////////////////////////////////////////////
                               
                               entityDesc_per=[NSEntityDescription entityForName:@"Sublugar" inManagedObjectContext:context_per];
                               request_favorito=[[NSFetchRequest alloc]init];
                               [request_favorito setEntity:entityDesc_per];
                               pred_favorito = [NSPredicate predicateWithFormat:@"ANY album_personalizado like '1'"];
                               [request_favorito setPredicate:pred_favorito];
                               objects_favoritos =[context_per executeFetchRequest:request_favorito error:&error_per];
                               
                               if ([objects_favoritos count] == 0) 
                               {
                                   [alertaSimplePersonalizada show];
                               } 
                               else 
                               {
                                   [objectsCogidos_favoritos setArray:objects_favoritos];
                                   [self pasoPictosfavoritos];
                                   [request_favorito release];
                               }
                           }
                               break;
                               
                           case 3:
                           {
                               NSLog(@"Se está cargando el álbum PERSONAS");
                               if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
                               {
                                   [EntidadTitle setText:@"PERSONAS"];
                                   [EntidadFavoritoTitle setText:@"PERSONAS PERSONALIZADAS"];
                               }
                               else // IDIOMA INGLÉS
                               {
                                   [EntidadTitle setText:@"PERSONS"];
                                   [EntidadFavoritoTitle setText:@"PERSONALIZED PERSONS"]; 
                               }
                               EntidadActual=3;
                               
                               //////////////////////////////////////////////////////////////
                               // LLAMADA A LA BD ENTIDAD ORIGINAL
                               //////////////////////////////////////////////////////////////
                               
                               entityDesc = [NSEntityDescription entityForName:@"Personas" inManagedObjectContext:context];
                               request = [[NSFetchRequest alloc] init];
                               [request setEntity:entityDesc];
                               objects_entidad = [context executeFetchRequest:request error:&error];
                               if ([objects_entidad count] == 0) 
                               {
                                   [alertaSimple show];
                               } 
                               else 
                               {
                                   [objectsCogidos_entidad setArray:objects_entidad];
                                   [self reloadEntidadPics];
                                   [request release];
                               }
                               //////////////////////////////////////////////////////////////
                               // LLAMADA A LA BD ENTIDAD PERSONALIZADA
                               //////////////////////////////////////////////////////////////
                               
                               entityDesc_per=[NSEntityDescription entityForName:@"Personas" inManagedObjectContext:context_per];
                               request_favorito=[[NSFetchRequest alloc]init];
                               [request_favorito setEntity:entityDesc_per];
                               pred_favorito = [NSPredicate predicateWithFormat:@"ANY album_personalizado like '1'"];
                               [request_favorito setPredicate:pred_favorito];
                               objects_favoritos =[context_per executeFetchRequest:request_favorito error:&error_per];
                               
                               if ([objects_favoritos count] == 0) 
                               {
                                   [alertaSimplePersonalizada show];
                               } 
                               else 
                               {
                                   [objectsCogidos_favoritos setArray:objects_favoritos];
                                   [self pasoPictosfavoritos];
                                   [request_favorito release];
                               }
                           }
                               break;
                               
                           case 4:
                           {
                               NSLog(@"Se está cargando el álbum VERBOS");
                               if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
                               {
                                   [EntidadTitle setText:@"VERBOS"];
                                   [EntidadFavoritoTitle setText:@"VERBOS PERSONALIZADOS"];
                               }
                               else // IDIOMA INGLÉS
                               {
                                   [EntidadTitle setText:@"VERBS"];
                                   [EntidadFavoritoTitle setText:@"PERSONALIZED VERBS"]; 
                               }
                               EntidadActual=4;
                               
                               //////////////////////////////////////////////////////////////
                               // LLAMADA A LA BD ENTIDAD ORIGINAL
                               //////////////////////////////////////////////////////////////
                               
                               entityDesc = [NSEntityDescription entityForName:@"Verbos" inManagedObjectContext:context];
                               request = [[NSFetchRequest alloc] init];
                               [request setEntity:entityDesc];
                               objects_entidad = [context executeFetchRequest:request error:&error];
                               if ([objects_entidad count] == 0) 
                               {
                                   [alertaSimple show];
                               } 
                               else 
                               {
                                   [objectsCogidos_entidad setArray:objects_entidad];
                                   [self reloadEntidadPics];
                                   [request release];
                               }
                               //////////////////////////////////////////////////////////////
                               // LLAMADA A LA BD ENTIDAD PERSONALIZADA
                               //////////////////////////////////////////////////////////////
                               
                               entityDesc_per=[NSEntityDescription entityForName:@"Verbos" inManagedObjectContext:context_per];
                               request_favorito=[[NSFetchRequest alloc]init];
                               [request_favorito setEntity:entityDesc_per];
                               pred_favorito = [NSPredicate predicateWithFormat:@"ANY album_personalizado like '1'"];
                               [request_favorito setPredicate:pred_favorito];
                               objects_favoritos =[context_per executeFetchRequest:request_favorito error:&error_per];
                               
                               if ([objects_favoritos count] == 0) 
                               {
                                   [alertaSimplePersonalizada show];
                               } 
                               else 
                               {
                                   [objectsCogidos_favoritos setArray:objects_favoritos];
                                   [self pasoPictosfavoritos];
                                   [request_favorito release];
                               }
                           }
                               break;
                               
                           case 5:
                           {
                               NSLog(@"Se está cargando el álbum COMPLEMENTOS");
                               if (ajuste_tipo_letra<40) // IDIOMA CASTELLANO
                               {
                                   [EntidadTitle setText:@"COMPLEMENTOS"];
                                   [EntidadFavoritoTitle setText:@"COMPLEMENTOS PERSONALIZADOS"];
                               }
                               else // IDIOMA INGLÉS
                               {
                                   [EntidadTitle setText:@"COMPLEMENTS"];
                                   [EntidadFavoritoTitle setText:@"PERSONALIZED COMPLEMENTS"]; 
                               }
                               EntidadActual=5;
                               
                               //////////////////////////////////////////////////////////////
                               // LLAMADA A LA BD ENTIDAD ORIGINAL
                               //////////////////////////////////////////////////////////////
                               
                               entityDesc = [NSEntityDescription entityForName:@"Complementos" inManagedObjectContext:context];
                               request = [[NSFetchRequest alloc] init];
                               [request setEntity:entityDesc];
                               objects_entidad = [context executeFetchRequest:request error:&error];
                               if ([objects_entidad count] == 0) 
                               {
                                   [alertaSimple show];
                               } 
                               else 
                               {
                                   [objectsCogidos_entidad setArray:objects_entidad];
                                   [self reloadEntidadPics];
                                   [request release];
                               }
                               //////////////////////////////////////////////////////////////
                               // LLAMADA A LA BD ENTIDAD PERSONALIZADA
                               //////////////////////////////////////////////////////////////
                               
                               entityDesc_per=[NSEntityDescription entityForName:@"Complementos" inManagedObjectContext:context_per];
                               request_favorito=[[NSFetchRequest alloc]init];
                               [request_favorito setEntity:entityDesc_per];
                               pred_favorito = [NSPredicate predicateWithFormat:@"ANY album_personalizado like '1'"];
                               [request_favorito setPredicate:pred_favorito];
                               objects_favoritos =[context_per executeFetchRequest:request_favorito error:&error_per];
                               
                               if ([objects_favoritos count] == 0) 
                               {
                                   [alertaSimplePersonalizada show];
                               } 
                               else 
                               {
                                   [objectsCogidos_favoritos setArray:objects_favoritos];
                                   [self pasoPictosfavoritos];
                                   [request_favorito release];
                               }
                           }
                               break;
                               
                           default:
                               break;
                       }
                       
                       [pool release];
                   });
}  

-(void)reloadEntidadPics
{	
    indice=num_pag_view*[Entidad_table count];
    
    NSLog(@"indice= %i;num_pag_view= %i; thumbnail_table count= %i", indice, num_pag_view, [Entidad_table count]);
    NSLog(@"objetos cogidos %@", objectsCogidos_entidad);
    
    objects_entidad=nil;
    
    int contar2=[objectsCogidos_entidad count];
    NSLog(@"imagenes que tenemos %i ",contar2);
    
    for (int i=0; i<[Entidad_table count]; i++) 
    {
        NSLog(@"i= %i; indice= %i",i,indice);
        if ((i+indice)<[objectsCogidos_entidad count]) 
        {   
            [[Entidad_table objectAtIndex:i] setImage:[UIImage imageNamed:[[objectsCogidos_entidad objectAtIndex:(i+indice)] valueForKey:@"nombre"]]forState:UIControlStateNormal]; //Colocar la imagen en cada botón
            
            [[EntidadLabel_table objectAtIndex:i] setText:[[objectsCogidos_entidad objectAtIndex:i+indice]valueForKey:Idioma]];           
            
            NSString *texto=[[objectsCogidos_entidad objectAtIndex:(i+indice)] valueForKey:@"nombre"];

            [[Entidad_table objectAtIndex:i] setHidden:NO]; //Hacer visibles todos los botones que tengan imagen.
            [[Entidad_table objectAtIndex:i]setAlpha:1];    //Poner la opacidad completa a todos

            if ([selecc_originales containsObject:texto]||[datos_favoritos containsObject:texto]) 
            {
                [[Entidad_table objectAtIndex:i]setAlpha:0.5];
            }
            //Poner la opacidad a la mitad de aquellos botones que ya estén registrados en la selección original.
            
            
            [BotonEntidadSiguiente setEnabled:YES];
            [BotonEntidadSiguiente setHidden:NO];
        }
        else 
        {
            //Hide the button
            [[Entidad_table objectAtIndex:i] setHidden:YES]; 
            [[EntidadLabel_table objectAtIndex:i]setText:@""];
            [BotonEntidadSiguiente setEnabled:NO];
            [BotonEntidadSiguiente setHidden:YES];
            
            if (indice!=0) 
            {
                [BotonEntidadAnterior setEnabled:YES];
                [BotonEntidadAnterior setHidden:NO];
            }
            else
            {
                NSLog(@"Estoy en la primera página!");
            }
            
            
        }
    }  
}

-(void)pasoPictosfavoritos
{
    objects_favoritos=nil;
    
    for (int i=0; i<[objectsCogidos_favoritos count]; i++)
    {
        [datos_favoritos addObject:[[objectsCogidos_favoritos objectAtIndex:i] valueForKey:@"nombre"]];
    }
    
    [self reloadfavoritoPics];
}

-(void)reloadfavoritoPics
{
    indice_per=num_pag_view_per*[Favorito_table count];
    
    NSLog(@"indice_per= %i;num_pag_view_per= %i; Favorito_table count= %i", indice_per, num_pag_view_per, [Favorito_table count]);
    
    for (int i=0; i<[Favorito_table count]; i++) 
    {
        NSLog(@"i= %i; indice= %i",i,indice_per);
        
        ////////////////////////////////////////////////////////
        // MOSTRAMOS LAS IMÁGENES DE LA LLAMADA A LA BD
        ////////////////////////////////////////////////////////
        
        if ((i+indice_per)<[datos_favoritos count]) 
        {   
            [[Favorito_table objectAtIndex:i] setImage:[UIImage imageNamed:[datos_favoritos objectAtIndex:(i+indice_per)]]forState:UIControlStateNormal]; //Colocar la imagen en cada botón
            
            int indiceBDIdioma=[[objectsCogidos_entidad valueForKey:@"nombre"] indexOfObjectIdenticalTo:[datos_favoritos objectAtIndex:i+indice_per]];
            [[FavoritoLabel_table objectAtIndex:i] setText:[[objectsCogidos_entidad objectAtIndex:indiceBDIdioma]valueForKey:Idioma]];  
            
            NSString *texto=[datos_favoritos objectAtIndex:(i+indice_per)];

            [[Favorito_table objectAtIndex:i] setHidden:NO]; //Hacer visibles todos los botones que tengan imagen.
            [[Favorito_table objectAtIndex:i]setAlpha:1];    //Poner la opacidad completa a todos
            
            if ([selecc_favoritos containsObject:texto]) //Poner la opacidad a la mitad de aquellos botones que ya estén registrados en la selección original.
            {
                [[Favorito_table objectAtIndex:i]setAlpha:0.5];
            }

            [BotonFavoritoSiguiente setEnabled:YES];
            [BotonFavoritoSiguiente setHidden:NO];
        }
        
        ////////////////////////////////////////////////////////
        // OCULTAMOS LOS BOTONES QUE SOBRAN
        ////////////////////////////////////////////////////////
        
        else
        {
            //Hide the button
            [[Favorito_table objectAtIndex:i] setHidden:YES]; 
            [[FavoritoLabel_table objectAtIndex:i]setText:@""];
            [BotonFavoritoSiguiente setEnabled:NO];
            [BotonFavoritoSiguiente setHidden:YES];
            
            if (indice_per!=0) 
            {
                [BotonFavoritoAnterior setEnabled:YES];
                [BotonFavoritoAnterior setHidden:NO];
            }
            else
            {
                NSLog(@"Estoy en la primera página de favorito!");
            }
            
            
        }
    }  
}


-(IBAction)volverEntidadPictos:(id)sender
{
    for (int i=0; i<[Favorito_table count]; i++) 
    {
        [[Favorito_table objectAtIndex:i] setHidden:YES];
        [[FavoritoLabel_table objectAtIndex:i]setText:@""];
    }
    
    for (int i=0; i<[Entidad_table count]; i++) 
    {
        [[Entidad_table objectAtIndex:i] setHidden:YES];
        [[EntidadLabel_table objectAtIndex:i]setText:@""];
    }
    
    [BotonEntidadAnterior setHidden:YES];
    [BotonEntidadAnterior setEnabled:NO];
    [BotonEntidadSiguiente setHidden:YES];
    [BotonEntidadSiguiente setEnabled:NO];
    
    [EntidadTitle setText:@"ENTIDAD"];
    [self.view removeFromSuperview];
    
}

-(IBAction)onEntidadPicto:(id)sender
{
    NSInteger ButtonTagInteger= [sender tag];
    NSLog(@"Imagen seleccionada = %i",ButtonTagInteger);
    
    // quitar los pictos que ya estén.
    [selecc_originales removeObjectIdenticalTo:[[objectsCogidos_entidad objectAtIndex:(indice+ButtonTagInteger)]valueForKey:@"nombre"]];
    
    if ([[Entidad_table objectAtIndex:ButtonTagInteger] alpha]==1) //picto no está seleccionado
    {
        NSString *nombre=[[objectsCogidos_entidad objectAtIndex:(indice+ButtonTagInteger)] valueForKey:@"nombre"];
        [selecc_originales addObject:nombre];
        [[Entidad_table objectAtIndex:ButtonTagInteger] setAlpha:0.5];
    }
    else //picto ya está seleccionado
    {
        [[Entidad_table objectAtIndex:ButtonTagInteger] setAlpha:1];
    }    
    
    
    NSLog(@"seleccion originales = %@",selecc_originales);
    
}

-(IBAction)onFavoritoPicto:(id)sender
{
    NSInteger ButtonTagInteger= [sender tag];
    NSLog(@"Imagen seleccionada = %i",ButtonTagInteger);
    
    [selecc_favoritos removeObjectIdenticalTo:[datos_favoritos objectAtIndex:(indice_per+ButtonTagInteger)]];
    
    if ([[Favorito_table objectAtIndex:ButtonTagInteger] alpha]==1) 
    {
        NSString *nombre=[datos_favoritos objectAtIndex:(indice_per+ButtonTagInteger)];
        [selecc_favoritos addObject:nombre];
        [[Favorito_table objectAtIndex:ButtonTagInteger] setAlpha:0.5];
    }
    else
    {
        [[Favorito_table objectAtIndex:ButtonTagInteger] setAlpha:1];
    }    
    
    
    NSLog(@"seleccion selecc_favoritos = %@",selecc_favoritos);
}

-(IBAction)onEntidadSiguiente:(id)sender
{
    num_pag_view +=1;
    
    NSLog(@"A LA SIGUIENTE ENTIDAD!!--> %i",num_pag_view);
    
    [self reloadEntidadPics];
    
    [BotonEntidadAnterior setEnabled:YES];
    [BotonEntidadAnterior setHidden:NO];
}
-(IBAction)onEntidadAnterior:(id)sender
{
    NSLog(@"A LA ANTERIOR ENTIDAD!!");
    
    [BotonEntidadSiguiente setEnabled:YES];
    [BotonEntidadSiguiente setHidden:NO];
    
    if (num_pag_view>0) {
        num_pag_view -=1;    
    }
    if(num_pag_view==0)
    {
        [BotonEntidadAnterior setEnabled:NO];
        [BotonEntidadAnterior setHidden:YES];
    }
    [self reloadEntidadPics];
}

-(IBAction)onFavoritoSiguiente:(id)sender
{
    num_pag_view_per +=1;
    
    NSLog(@"A LA SIGUIENTE ENTIDAD PERSONALIZADA!!--> %i",num_pag_view_per);
    
    [self reloadfavoritoPics];
    
    [BotonFavoritoAnterior setEnabled:YES];
    [BotonFavoritoAnterior setHidden:NO];
}
-(IBAction)onFavoritoAnterior:(id)sender
{
    NSLog(@"A LA ANTERIOR ENTIDAD PERSONALIZADA!!");
    
    [BotonFavoritoSiguiente setEnabled:YES];
    [BotonFavoritoSiguiente setHidden:NO];
    
    if (num_pag_view_per>0) {
        num_pag_view_per -=1;    
    }
    if(num_pag_view_per==0)
    {
        [BotonFavoritoAnterior setEnabled:NO];
        [BotonFavoritoAnterior setHidden:YES];
    }
    [self reloadfavoritoPics];
}

-(IBAction)pulsarButAgregar:(id)sender
{
    for ( int i=0; i<[selecc_originales count]; i++) 
    {
        if ([datos_favoritos containsObject:[selecc_originales objectAtIndex:i]]) 
        {
            
        }
        else
        {
            [datos_favoritos addObject:[selecc_originales objectAtIndex:i]];
            NSLog(@"datos_favoritos %@", datos_favoritos);
        }
    }
    [selecc_favoritos removeAllObjects];
    [self reloadfavoritoPics]; 
    
}
-(IBAction)pulsarButQuitar:(id)sender
{
    for ( int i=0; i<[selecc_favoritos count]; i++) 
    {
        [datos_favoritos removeObjectIdenticalTo:[selecc_favoritos objectAtIndex:i]];
        //[datos_favoritos addObject:[selecc_originales objectAtIndex:i]];
        NSLog(@"datos_favoritos %@", datos_favoritos);
        
        [selecc_originales removeObjectIdenticalTo:[selecc_favoritos objectAtIndex:i]];
    }
    [selecc_favoritos removeAllObjects];
    [self reloadEntidadPics];
    [self reloadfavoritoPics];
}
-(IBAction)pulsarButGuardar:(id)sender
{
    NSString *textoEntidadActual=@"";
    
    switch (EntidadActual) {
        case 1:
            textoEntidadActual=@"Lugar";
            break;
        case 2:
            textoEntidadActual=@"Sublugar";
            break;
        case 3:
            textoEntidadActual=@"Personas";
            break;
        case 4:
            textoEntidadActual=@"Verbos";
            break;
        case 5:
            textoEntidadActual=@"Complementos";
            break;
        default:
            break;
    }
    
    COMUNICADORAppDelegate *appDelegate_guardar = [[UIApplication sharedApplication] delegate];
    NSManagedObjectContext *context_guardar = [appDelegate_guardar managedObjectContext];
    NSEntityDescription *entityDesc_guardar = [NSEntityDescription entityForName:[NSString stringWithString:textoEntidadActual] inManagedObjectContext:context_guardar];
    NSFetchRequest *request_guardar = [[NSFetchRequest alloc] init];
    [request_guardar setEntity:entityDesc_guardar];
    NSError *error_guardar;
    NSArray *todos_objects=[context_guardar executeFetchRequest:request_guardar error:&error_guardar];
    
    
    // NSArray *todos_objects = [context executeFetchRequest:request error:&error];
    
    for ( int i=0; i<[todos_objects count]; i++) 
    {
        if ([datos_favoritos containsObject:[[todos_objects objectAtIndex:i] valueForKey:@"nombre"]]) 
        {
            NSManagedObject *picto_favorito=[todos_objects objectAtIndex:i];
            [picto_favorito setValue:[NSNumber numberWithInt: 1] forKey:@"album_personalizado"];
        }
        else
        {
            NSManagedObject *picto_favorito=[todos_objects objectAtIndex:i];
            [picto_favorito setValue:[NSNumber numberWithInt: 0] forKey:@"album_personalizado"];
            NSLog(@"datos_favoritos %@", datos_favoritos);
        }
    }
    
    [request_guardar release];
    
    if (![context save:&error]) 
    {
        NSLog(@"error de coredata %@, %@", error, [error userInfo]);
        exit(-1);
    }
    
    [alertaSimpleGuardar show];
}

#pragma mark - View lifecycle

- (void)viewDidUnload
{
    self.EntidadPicto0=nil;
    self.EntidadPicto1=nil;
    self.EntidadPicto2=nil;
    self.EntidadPicto3=nil;
    self.EntidadPicto4=nil;
    self.EntidadPicto5=nil;
    self.EntidadPicto6=nil;
    self.EntidadPicto7=nil;
    self.EntidadPicto8=nil;
    self.EntidadPicto9=nil;
    self.EntidadPicto10=nil;
    self.EntidadPicto11=nil;
    self.EntidadPicto12=nil;
    self.EntidadPicto13=nil;
    
    self.FavoritoPicto1=nil;
    self.FavoritoPicto2=nil;
    self.FavoritoPicto3=nil;
    self.FavoritoPicto4=nil;
    self.FavoritoPicto5=nil;
    self.FavoritoPicto6=nil;
    self.FavoritoPicto7=nil;
    self.FavoritoPicto8=nil;
    self.FavoritoPicto9=nil;
    self.FavoritoPicto10=nil;
    self.FavoritoPicto11=nil;
    self.FavoritoPicto12=nil;
    self.FavoritoPicto13=nil;
    self.FavoritoPicto14=nil;
    
    self.Label1=nil;
    self.Label2=nil;
    self.Label3=nil;
    self.Label4=nil;
    self.Label5=nil;
    self.Label6=nil;
    self.Label7=nil;
    self.Label8=nil;
    self.Label9=nil;
    self.Label10=nil;
    self.Label11=nil;
    self.Label12=nil;
    self.Label13=nil;
    self.Label14=nil;
    self.Label15=nil;
    self.Label16=nil;
    self.Label17=nil;
    self.Label18=nil;
    self.Label19=nil;
    self.Label20=nil;
    self.Label21=nil;
    self.Label22=nil;
    self.Label23=nil;
    self.Label24=nil;
    self.Label25=nil;
    self.Label26=nil;
    self.Label27=nil;
    self.Label28=nil;
    
    self.BotonEntidadAnterior=nil;
    self.BotonEntidadSiguiente=nil;
    self.BotonFavoritoAnterior=nil;
    self.BotonFavoritoSiguiente=nil;
    
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return YES;
}

@end
