//
//  Personalizacion.h
//  COMUNICADOR
//
//  Created by JOSE CRUZ PEREZ PI on 17/06/11.
//  Copyright 2011 UNIVERSIDAD PUBLICA DE NAVARRA. All rights reserved.
//

#import <CoreData/CoreData.h>
#import <UIKit/UIKit.h>

@class Ajustes;

@interface Personalizacion : UIViewController <UINavigationControllerDelegate, UIImagePickerControllerDelegate> {
    
    Ajustes * controladorAjustes;
    
    IBOutlet UISwitch *switch_persona;  
    IBOutlet UISwitch *switch_verbo;  
    IBOutlet UISwitch *switch_complemento;
    IBOutlet UILabel *label_frase_guardado;
    IBOutlet UILabel *label_busqueda;
    IBOutlet UILabel *label_instrucciones;
    IBOutlet UILabel *label_borrar;
    
    IBOutlet UILabel *label_nombre_castellano;
    IBOutlet UILabel *label_nombre_ingles;
    IBOutlet UILabel *label_Persona;
    IBOutlet UILabel *label_Verbo;
    IBOutlet UILabel *label_Complemento;
    
    IBOutlet UITextField *texto_castellano;
    IBOutlet UITextField *texto_ingles;
    IBOutlet UITextField *texto_busqueda;
    IBOutlet UIImageView *VISTA_IMAGEN;
    
    IBOutlet UIButton *BOTON_BUSCAR;
    IBOutlet UIButton *BOTON_GUARDAR;
    IBOutlet UIButton *BOTON_BUSCAR_IMAGEN;
    IBOutlet UIButton *BOTON_BORRAR;
    
    IBOutlet UIButton *BOTON_REINICIAR_VALORES;
    IBOutlet UIButton *BOTON_ATRAS;
    
    NSString *entidad_personalizacion;
    
    UIPopoverController *popover;

    int existe;
    int existe_personas;
    int existe_verbos;
    int existe_complementos;
    int fila_a_cambiar_post_busqueda_personas;
    int fila_a_cambiar_post_busqueda_verbos;
    int fila_a_cambiar_post_busqueda_complementos;
    int Es_nuevo_personas;
    int Es_nuevo_verbos;
    int Es_nuevo_complementos;
    
    int ajuste_resp_negativa;
    int ajuste_tiempo_pulsacion;
    int ajuste_tipo_letra;

}

@property(nonatomic,retain)Ajustes * controladorAjustes;

@property (nonatomic, retain) UISwitch *switch_persona;  
@property (nonatomic, retain) UISwitch *switch_verbo;  
@property (nonatomic, retain) UISwitch *switch_complemento;
@property (nonatomic,retain) IBOutlet UILabel *label_frase_guardado;
@property (nonatomic, retain) UIPopoverController *popover;
@property (nonatomic, retain) UIImage *copyImage;

@property (nonatomic, retain)IBOutlet UILabel *label_busqueda;
@property (nonatomic, retain)IBOutlet UILabel *label_instrucciones;
@property (nonatomic, retain)IBOutlet UILabel *label_borrar;

@property (nonatomic, retain)IBOutlet UILabel *label_nombre_castellano;
@property (nonatomic, retain)IBOutlet UILabel *label_nombre_ingles;
@property (nonatomic, retain)IBOutlet UILabel *label_Persona;
@property (nonatomic, retain)IBOutlet UILabel *label_Verbo;
@property (nonatomic, retain)IBOutlet UILabel *label_Complemento;

@property (nonatomic, retain)IBOutlet UIButton *BOTON_BUSCAR;
@property (nonatomic, retain)IBOutlet UIButton *BOTON_GUARDAR;
@property (nonatomic, retain)IBOutlet UIButton *BOTON_BUSCAR_IMAGEN;
@property (nonatomic, retain)IBOutlet UIButton *BOTON_BORRAR;

@property (nonatomic, retain)IBOutlet UIButton *BOTON_REINICIAR_VALORES;
@property (nonatomic, retain)IBOutlet UIButton *BOTON_ATRAS;




- (IBAction) PULSAR_VOLVER_PERSONALIZACION: (id) sender;
- (IBAction) PULSAR_BUSCAR: (id) sender;
- (IBAction) PULSAR_REINICIAR_VALORES: (id) sender;
- (IBAction) GUARDAR_NUEVA_ENTRADA: (id) sender;

- (void) EliminoObjetosEntidad: (NSString *) entidad;
- (void) ModificoColumnasActivo: (NSString *) entidad;
- (void) ModificoColumnasContador: (NSString *) entidad;
- (UIImage*)imageWithImage:(UIImage*)image scaledToSize:(CGSize)newSize;
- (void) Nuevo_elemento: (NSString *) entidad_a_guardar Fila_cambia: (int) fila Indice: (int) indice;
- (IBAction) EliminarObjeto: (id) sender;
- (void) funcion_de_eliminar_objeto: (NSString *) entidad fila: (int) fila_cambio Variable_nuevo: (int) es_nuevo;


- (IBAction)choosePic: (id) sender;

- (void)saveImage:(UIImage*)image:(NSString*)imageName;
- (void)removeImage:(NSString*)fileName;
- (UIImage*)loadImage:(NSString*)imageName;

- (void) DeshabilitarElementos;
- (void) HabilitarElementos;


@end
