//
//  controlAgenda.m
//  COMUNICADOR
//
//  Created by Elisabeth Esandia Melero on 03/05/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "controlAgenda.h"
#import "vistaMes.h"
#import "vistaSemana.h"
#import "vistaDia.h"


@implementation controlAgenda

@synthesize controlVistasAgenda;
@synthesize vistaMesController;
@synthesize vistaSemanaController;
@synthesize vistaDiaController;
@synthesize vistaActualController;

@synthesize BotonAgregarEvento;
@synthesize BotonEditarEvento;

- (void)tabBar:(UITabBar *)tabBar didSelectItem:(UITabBarItem *)item {
	NSLog(@"didSelectItem: %i", item.tag);
    [self activateTab:item.tag];
}

- (void)activateTab:(int)index {
    switch (index) {
        case 1:
            if (vistaActualController != nil)
                [vistaActualController.view removeFromSuperview];
            vistaActualController = vistaMesController;
            if (vistaMesController == nil) {
                self.vistaMesController =
                [[vistaMes alloc] initWithNibName:@"vistaMes" bundle:nil];
            }
            [self.view insertSubview:vistaMesController.view belowSubview:controlVistasAgenda];		
            break;
        case 2:
            if (vistaActualController != nil)
                [vistaActualController.view removeFromSuperview];
            vistaActualController = vistaSemanaController;
            if (vistaSemanaController == nil) {
                self.vistaSemanaController =
                [[vistaSemana alloc] initWithNibName:@"vistaSemana" bundle:nil];
            }
            [self.view insertSubview:vistaSemanaController.view belowSubview:controlVistasAgenda];
		
            break;
        case 3:
            if (vistaActualController != nil)
                [vistaActualController.view removeFromSuperview];
            vistaActualController = vistaDiaController;	
            if (vistaDiaController == nil) {
                self.vistaDiaController =
                [[vistaDia alloc] initWithNibName:@"vistaDia" bundle:nil];
            }
            [self.view insertSubview:vistaDiaController.view belowSubview:controlVistasAgenda];
            break;
        default:
            break;
    }
}

-(IBAction)volverMenu:(id)sender
{
  	[self.view removeFromSuperview];  
}

-(IBAction)onAgregarEvento:(id)sender
{
    
}

-(IBAction)onEditarEvento:(id)sender
{
    
}


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    controlVistasAgenda.delegate=self;
    [controlVistasAgenda setSelectedItem:[controlVistasAgenda.items objectAtIndex:0]];
    [self activateTab:1];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return YES;
}

@end
